
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit
import Contacts

class cAddressBook: NSObject
{
    override init()
    {
        super.init()
    }
    
    deinit
    {
        
    }
    
////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
    
    static func AskAcessToContacts() ->Void
    {
        let vContactStore = CNContactStore()
        vContactStore.requestAccess(for: .contacts, completionHandler: {(_ granted: Bool, _ error: Error?) -> Void in
            
            if granted == true
            {
            
            }
        
        })
    }
    
    func GetAccess() ->Bool
    {
        let entityType: CNEntityType = .contacts
        
        if CNContactStore.authorizationStatus(for: entityType) == .notDetermined
        {
            cAddressBook.AskAcessToContacts()
            return false
        }
        else if CNContactStore.authorizationStatus(for: entityType) == .authorized
        {
            return true
        }
        else
        {
            return false
        }
    }
    
    func ReadContactName(_ sContactId: String) ->String
    {
        if !self.GetAccess()
        {
            return ""
        }
        
        let vContactStore: CNContactStore = CNContactStore()
        let request = CNContactFetchRequest(keysToFetch: [CNContactIdentifierKey as CNKeyDescriptor, CNContactFormatter.descriptorForRequiredKeys(for: .fullName)])
        
        var aContacts = [Any]()
        
        do
        {
            try vContactStore.enumerateContacts(with: request)
            {
                (contact, stop) in
                
                aContacts.append(contact)
            }
        }
        catch
        {
            return ""
        }
        
        if aContacts.count <= 0
        {
            return ""
        }
        
        for vContact in aContacts
        {
            if !(sContactId == (vContact as AnyObject).identifier)
            {
                continue
            }
            
            let formatter = CNContactFormatter()
            let sContactName: String? = formatter.string(from: vContact as! CNContact)
            
            return sContactName!
        }
  
        return ""
    }
    
    
    func IsContactExist(_ sContactId: String) ->Bool
    {
        let sContactName: String = self.ReadContactName(sContactId)
        if sContactName.count == 0
        {
            return false
        }
        
        return true
    }
    
    func FindContactNameWithPhoneNo(_ sPhoneNo: String) ->String
    {
        var sContactName: String = ""
        var sContactId: String = ""
        
        if !self.FindContactWithPhoneNo(sPhoneNo, &sContactName, &sContactId)
        {
            return ""
        }
        
        return sContactName
    }
    
    static func FilterPhoneNo(_ sPhoneNo: String) ->String
    {
        var PhoneNoCharacterSet = CharacterSet(charactersIn: "+")
        
        PhoneNoCharacterSet.formUnion(CharacterSet.decimalDigits)
        
        var sPhoneNoFiltered: String = ""
        sPhoneNoFiltered = sPhoneNo.components(separatedBy: PhoneNoCharacterSet.inverted).joined(separator: "")
        
        return sPhoneNoFiltered
    }
    
    func FindContactWithPhoneNo(_ sPhoneNo: String, _ sResultName: inout String, _ sResultContactId: inout String) ->Bool
    {
        if !self.GetAccess()
        {
            return false
        }
        
        let vContactStore: CNContactStore = CNContactStore()
        let request = CNContactFetchRequest(keysToFetch: [CNContactPhoneNumbersKey as CNKeyDescriptor, CNContactFormatter.descriptorForRequiredKeys(for: .fullName)])
        
        var aContacts = [Any]()

        do
        {
            try vContactStore.enumerateContacts(with: request)
            {
                (contact, stop) in
                
                aContacts.append(contact)
            }
        }
        catch
        {
            return false
        }
        
        let sPhoneNoFiltered = cAddressBook.FilterPhoneNo(sPhoneNo)
        
        for vContact in aContacts
        {
            for label: CNLabeledValue in (vContact as AnyObject).phoneNumbers
            {
                var sContactPhone: String = label.value.stringValue
                
                if sContactPhone.count <= 0
                {
                    continue
                }
                
                sContactPhone = cAddressBook.FilterPhoneNo(sContactPhone)
                
                if !(sContactPhone == sPhoneNoFiltered)
                {
                    continue
                }
                    
                let sContactId: String = String(UInt(bitPattern: ObjectIdentifier(vContact as AnyObject)))
                
                let formatter: CNContactFormatter = CNContactFormatter()
                let sContactName: String = formatter.string(from: vContact as! CNContact)!
                
                sResultName = sContactName
                sResultContactId = sContactId
                
                return true
            }
        }
        
        return false
    }
}
