
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit
import Photos

class cCameraTorch: NSObject
{
    override init()
    {
        super.init()
    }
    
    deinit
    {
        
    }
    
    func IsTorchAvailable() ->Bool
    {
        let vFlashLight = AVCaptureDevice.default(for: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
        
        let vTorchMode: Bool? = vFlashLight?.isTorchAvailable
        let vTorchModeSupported: Bool? = vFlashLight?.isTorchModeSupported(AVCaptureDevice.TorchMode.on)
        
        if vTorchMode == nil || vTorchMode == false || vTorchModeSupported == nil || vTorchModeSupported == false
        {
            return false
        }
        
        return true
    }
    
    func IsTorchModeON() ->Bool
    {
        let vFlashLight = AVCaptureDevice.default(for: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
        
        let vTorchMode: Bool? = vFlashLight?.isTorchAvailable
        let vTorchModeSupported: Bool? = vFlashLight?.isTorchModeSupported(AVCaptureDevice.TorchMode.on)
        
        if vTorchMode == nil || vTorchMode == false || vTorchModeSupported == nil || vTorchModeSupported == false
        {
            return false
        }
        
        if (try? vFlashLight?.lockForConfiguration()) == nil
        {
            return false
        }
        
        let bResult = (vFlashLight?.torchMode == AVCaptureDevice.TorchMode.on)
        
        vFlashLight?.unlockForConfiguration()
        
        return bResult
    }
    
    func SwitchTorchMode() ->Void
    {
        let vFlashLight = AVCaptureDevice.default(for: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
        
        let vTorchMode: Bool? = vFlashLight?.isTorchAvailable
        let vTorchModeSupported: Bool? = vFlashLight?.isTorchModeSupported(AVCaptureDevice.TorchMode.on)
        
        if vTorchMode == nil || vTorchMode == false || vTorchModeSupported == nil || vTorchModeSupported == false
        {
            return
        }
        
        if (try? vFlashLight?.lockForConfiguration()) == nil
        {
            return
        }
        
        if vFlashLight?.torchMode == .on
        {
            vFlashLight?.torchMode = .on
        }
        else
        {
           vFlashLight?.torchMode = .off
        }
        
        vFlashLight?.unlockForConfiguration()
    }
    
    func SwitchTorchMode(_ bModeON: Bool) ->Void
    {
        let vFlashLight = AVCaptureDevice.default(for: AVMediaType(rawValue: convertFromAVMediaType(AVMediaType.video)))
        
        let vTorchMode: Bool? = vFlashLight?.isTorchAvailable
        let vTorchModeSupported: Bool? = vFlashLight?.isTorchModeSupported(AVCaptureDevice.TorchMode.on)
        
        if vTorchMode == nil || vTorchMode == false || vTorchModeSupported == nil || vTorchModeSupported == false
        {
            return
        }
        
        if (try? vFlashLight?.lockForConfiguration()) == nil
        {
            return
        }
        
        if bModeON
        {
            vFlashLight?.torchMode = .on
        }
        else
        {
            vFlashLight?.torchMode = .off
        }
        
        vFlashLight?.unlockForConfiguration()
    }
}

// Helper function inserted by Swift 4.2 migrator.

fileprivate func convertFromAVMediaType(_ input: AVMediaType) -> String
{
	return input.rawValue
}

