
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit
import AVFoundation

@objc class cVaxPhoneDTMF: NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    static var mSelf: cVaxPhoneDTMF?
         
    var mvPlayDTMF: cPlayDTMF!
    var m_nTypeDTMF: Int
    
    override init()
    {
        mvPlayDTMF = cPlayDTMF()
        m_nTypeDTMF = cVaxUserAgentInfo.VAX_DTMF_TYPE_AUTO
        
        super.init()
        
        cVaxPhoneDTMF.mSelf = self
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
        mvPlayDTMF = nil
    }
    
    static func GetSelf() ->cVaxPhoneDTMF
    {
        return mSelf!
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func PlayDTMF(_ sDigit: String) ->Void
    {
        mvPlayDTMF.PlayTone(sDigit: sDigit)
        mVaxAgentSIP.DigitDTMF(0, sDigit, m_nTypeDTMF)
    }
    
    func ForceDigitDTMF(_ nTypeId: Int, _ bEnable: Bool) ->Void
    {
        m_nTypeDTMF = nTypeId
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnInitialized() ->Void
    {
        cSettingDigitDTMFTableView.PostInitialize()
        
        let session = AVAudioSession.sharedInstance()
        try? session.setCategory(.playback, options: .mixWithOthers)
    }
    
    func OnHungupCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        if(mVaxAgentSIP.IsLineBusy(-1))
        {
            return;
        }
        
        let session = AVAudioSession.sharedInstance()
        try? session.setCategory(.playback, options: .mixWithOthers)
    }
    
    func OnDisconnectedCall(_ nLineNo: Int) ->Void
    {
        if(mVaxAgentSIP.IsLineBusy(-1))
        {
            return;
        }
        
        let session = AVAudioSession.sharedInstance()
        try? session.setCategory(.playback, options: .mixWithOthers)
    }
}
