
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxPhoneCodec: NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    static var mSelf: cVaxPhoneCodec?
                
    override init()
    {
        super.init()
        
        cVaxPhoneCodec.mSelf = self
       
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
    }
    
    static func GetSelf() ->cVaxPhoneCodec
    {
        return mSelf!
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func ActivateAudioCodec(_ bEnable: Bool, _ nCodecNo: Int) ->Bool
    {
        if nCodecNo == -1
        {
            if bEnable
            {
                mVaxAgentSIP.SelectAllAudioCodec();
            }
            else
            {
                mVaxAgentSIP.DeselectAllAudioCodec();
            }
            
            return true;
        }
        
        if bEnable
        {
            return mVaxAgentSIP.SelectAudioCodec(nCodecNo);
        }
        
        return mVaxAgentSIP.DeselectAudioCodec(nCodecNo);
    }
    
    func ActivateVideoCodec(_ bEnable: Bool, _ nCodecNo: Int) ->Bool
    {
        if nCodecNo == -1
        {
            if bEnable
            {
                mVaxAgentSIP.SelectAllVideoCodec();
            }
            else
            {
                mVaxAgentSIP.DeselectAllVideoCodec();
            }
            
            return true;
        }
        
        if bEnable
        {
            return mVaxAgentSIP.SelectVideoCodec(nCodecNo);
        }
        
        return mVaxAgentSIP.DeselectVideoCodec(nCodecNo);
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnInitialized() ->Void
    {
        cSettingVideoCodecTableView.PostInitialize()
        cSettingVoiceCodecTableView.PostInitialize()
    }
}
