
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxPhoneLog: NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    static var mSelf: cVaxPhoneLog?
    
    var m_sLogFile: String = ""
         
    override init()
    {
        m_sLogFile = ""
        
        super.init()
        
        cVaxPhoneLog.mSelf = self
       
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
    }
    
    static func GetSelf() ->cVaxPhoneLog
    {
        return mSelf!
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func DiagnosticLog(_ bEnable: Bool) ->Void
    {
        if bEnable
        {
            m_sLogFile = ""
            
            let dir = NSSearchPathForDirectoriesInDomains(FileManager.SearchPathDirectory.documentDirectory, FileManager.SearchPathDomainMask.allDomainsMask, true)[0]
            
            if dir.isEmpty == false
            {
                let docURL = URL(string: dir)!
                let path = docURL.appendingPathComponent("VaxLog.txt");
                print(path)
                
                m_sLogFile = path.path
            }
        }
            
        else
        {
            m_sLogFile = ""
        }
        
        mVaxAgentSIP.DiagnosticLogSIP("", bEnable, bEnable);
    }
    
    func WriteToLogFile(pText: String)
    {
        if m_sLogFile.isEmpty
        {
            return
        }
     
        let nDataSize: Int = Int(strlen(pText))
     
        if nDataSize == 0
        {
            return
        }
        
        let fp = fopen(m_sLogFile, "ab")
        
        fwrite(pText, MemoryLayout<String>.size , nDataSize, fp)
        fclose(fp)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnIncomingDiagnostic(_ sAccountName: String!, _ sMsgSIP :String!, _ sFromIP :String!, _ nFromPort :Int) ->Void
    {
        if m_sLogFile.isEmpty
        {
            return
        }
        
        let vLogPacket: String = NSString(format: "Received: %@:%d\n%@\n", sFromIP, nFromPort, sMsgSIP) as String
        self.WriteToLogFile(pText: vLogPacket)
    }
    
    func OnOutgoingDiagnostic(_ sAccountName: String!, _ sMsgSIP :String!, _ sToIP :String!, _ nToPort :Int) ->Void
    {
        if m_sLogFile.isEmpty
        {
            return
        }
        
        let vLogPacket: String = NSString(format: "Received: %@:%d\n%@\n", sToIP, nToPort, sMsgSIP) as String
        self.WriteToLogFile(pText: vLogPacket)
    }
}
