
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxPhoneMicSpk: NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    static var mSelf: cVaxPhoneMicSpk?
         
    var m_bMuteMic: Bool
    var m_bMuteSpk: Bool
    
    override init()
    {
        m_bMuteMic = false
        m_bMuteSpk = false
        
        super.init()
        
        cVaxPhoneMicSpk.mSelf = self
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
    }
    
    static func GetSelf() ->cVaxPhoneMicSpk
    {
        return mSelf!
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AutoGainSpk(_ bEnable: Bool) ->Bool
    {
        return mVaxAgentSIP.AutoGainSpk(bEnable, 20)
    }
    
    func AutoGainMic(_ bEnable: Bool) ->Bool
    {
        return mVaxAgentSIP.AutoGainMic(bEnable, 20)
    }
    
    func SetVolumeBoostMic(_ bEnable: Bool) ->Bool
    {
        var nBoostVol: Int = 0
        
        if bEnable
        {
            nBoostVol = 20
        }
        
        return mVaxAgentSIP.SetVolumeMic(nBoostVol)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func IsMuteMic() ->Bool
    {
        return m_bMuteMic
    }
     
    func MuteMic(_ bMute: Bool) ->Bool
    {
        if !mVaxAgentSIP.MuteMic(bMute)
        {
            return false
        }
        
        m_bMuteMic = bMute
        return true
    }
    
    func IsMuteSpk() ->Bool
    {
        return m_bMuteSpk
    }
    
    func MuteSpk(_ bMute: Bool) ->Bool
    {
        if !mVaxAgentSIP.MuteSpk(bMute)
        {
            return false
        }
        m_bMuteSpk = bMute
        return true
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnInitialized() ->Void
    {
        cSettingMicSpkTableView.PostInitialize()
    }
}
