
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxPhoneStatus : NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    var m_bVideoCaptureErrorShown: Bool

    override init()
    {
        m_bVideoCaptureErrorShown = false;
        
        super.init()
        
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnInitialized() ->Void
    {
        let sMsgText: String = "Account is online"
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    func OnUnInitialized() ->Void
    {
        m_bVideoCaptureErrorShown = false;
       
        let sMsgText: String = "Account is offline"
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnConnectingToRegister(_ sAccountName: String!) ->Void
    {
        cAccountLoginView.PostStatusText("Trying to connect")
        cVideoView.PostStatusText("Register: Trying to connect")
    }
    
    func OnTryingToRegister(_ sAccountName: String!) ->Void
    {
        let sMsgText: String = "Registering Account"
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    func OnFailToRegister(_ sAccountName: String!, _ nStatusCode :Int, _ sReasonPhrase :String!) ->Void
    {
        let sMsgText: String = NSString(format: "Register: %@", sReasonPhrase) as String
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    func OnSuccessToRegister(_ sAccountName: String!) ->Void
    {
        let sMsgText: String = "Account Registered"
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnConnectingToReRegister(_ sAccountName: String!) ->Void {}
    func OnTryingToReRegister(_ sAccountName: String!) ->Void {}
    
    func OnFailToReRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!)
    {
        let sMsgText: String = NSString(format: "Re-Register: %@", sReasonPhrase) as String
        
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    func OnSuccessToReRegister(_ sAccountName: String!) ->Void {}
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnTryingToUnRegister(_ sAccountName: String!)
    {
        cAccountLoginView.PostStatusText("Un-Registering Account")
    }
    
    func OnFailToUnRegister(_ sAccountName: String!) ->Void
    {
        let sMsgText: String = NSString(format: "Un-Register: %@", "Failed") as String
        cAccountLoginView.PostStatusText(sMsgText)
    }
    
    func OnSuccessToUnRegister(_ sAccountName: String!) ->Void
    {
        cAccountLoginView.PostStatusText("Account Un-Registered")
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnDialCallStarted(_ sAccountName: String!, _ nLineNo :Int, _ sCallerName :String!, _ sCallerId :String!, _ sDialNo :String!) ->Void
    {
        cVideoView.PostStatusText("Call: Connecting")
    }
    
    func OnDialingCall(_ sAccountName: String!, _ nLineNo :Int, _ nStatusCode :Int, _ sReasonPhrase :String!) ->Void
    {
        cVideoView.PostStatusText("Call: Dialing")
    }
    
    func OnDialCallFailed(_ sAccountName: String!, _ nLineNo :Int, _ nStatusCode :Int, _ sReasonPhrase :String!, _ sContact :String!) ->Void
    {
        let sMsgText: String = String(format: "Call: %@", sReasonPhrase)
        cVideoView.PostStatusText(sMsgText)
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnConnectedCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVideoView.PostStatusText("Call: Connected")
    }
    
    func OnDisconnectedCall(_ nLineNo: Int) ->Void
    {
        cVideoView.PostStatusText("Call: Disconnected")
    }
    
    func OnHungupCall(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("Call: Hungup")
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnTransferCallAccepted(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("Transfer: Accepted")
    }
    
    func OnTransferCallFailed(_ sAccountName: String!, _ nLineNo :Int, _ nStatusCode :Int, _ sReasonPhrase :String!) ->Void
    {
        let sMsgtext: String = String(format: "Transfer: %@", sReasonPhrase)
        cVideoView.PostStatusText(sMsgtext)
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnSuccessToHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("Hold: Successful")
    }
    
    func OnTryingToHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("Hold: Trying")
    }
    
    func OnFailToHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("Hold: Failed")
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnSuccessToUnHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("UnHold: Successful")
    }
    
    func OnTryingToUnHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("UnHold: Trying")
    }
    
    func OnFailToUnHold(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        cVideoView.PostStatusText("UnHold: Failed")
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnNetworkReachability(_ bAvailable :Bool) ->Void
    {
        if bAvailable
        {
            cAccountLoginView.PostStatusText("Network is available")
            cVideoView.PostStatusText("Network is available")
        }
        else
        {
            cAccountLoginView.PostStatusText("Network is not available")
            cVideoView.PostStatusText("Network is not available")
        }
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnVaxErrorMsg(_ sFuncName :String!, _ sErrorMsg :String!, _ nErrorCode :Int) ->Void
    {
        if (sFuncName == "OpenVideoDev")
        {
            if m_bVideoCaptureErrorShown
            {
                return
            }
            
            m_bVideoCaptureErrorShown = true
        }
        
        cMsgAlert.ShowAlert(sErrorMsg)
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnVaxRegisterTryingPushKit() ->Void
    {
        let sMsgText: String = "PushKit: Register Trying";
               
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    func OnVaxRegisterFailedPushKit() ->Void
    {
        let sMsgText: String = "PushKit: Register Failed";
            
        cAccountLoginView.PostStatusText(sMsgText)
        cVideoView.PostStatusText(sMsgText)
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
    
    func OnTryingToRefresh(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        
    }
    
    func OnFailToRefresh(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
        
    }
    
    func OnSuccessToRefresh(_ sAccountName: String!, _ nLineNo :Int) ->Void
    {
       
    }
    
    ///////////////////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////////////////
}
