
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxPhoneVoiceChanger: NSObject, iVaxUserAgentSIP
{
    var mVaxAgentSIP: cVaxUserAgentSIP!
    static var mSelf: cVaxPhoneVoiceChanger?
    
    var m_bVoiceChangerEnabled: Bool
         
    override init()
    {
        m_bVoiceChangerEnabled = false;
        
        super.init()
        
        cVaxPhoneVoiceChanger.mSelf = self
       
        mVaxAgentSIP = cVaxUserAgentSIP(iDelegate: self)
    }
    
    deinit
    {
        mVaxAgentSIP = nil
    }
    
    static func GetSelf() ->cVaxPhoneVoiceChanger
    {
        return mSelf!
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func IsVoiceChangerEnabled() ->Bool
    {
        return m_bVoiceChangerEnabled
    }
    
    func VoiceChangerEnabled(_ bEnable: Bool) ->Bool
    {
        if bEnable == false
        {
            m_bVoiceChangerEnabled = false
            return mVaxAgentSIP.VoiceChanger(-1)
        }
        
        if !mVaxAgentSIP.VoiceChanger(cSettingVoiceChangerTableView.GetSelectedPitchNo())
        {
            return false
        }
        
        m_bVoiceChangerEnabled = true
        return true
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnInitialized() ->Void
    {
        m_bVoiceChangerEnabled = false
    }
}
