
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cAccountInfoTableView: UITableViewController
{
    let SECTION_TOTAL_COUNT    = 2
    
    let SECTION_ID_PROFILE     = 0
    let SECTION_ID_SETTINGS    = 1
    
    let SECTION_PROFILE_ROWS   = 4
    let SECTION_SETTING_ROWS   = 4
    
    let ROW_ID_USER_NAME       = 0
    let ROW_ID_DISPLAY_NAME    = 1
    let ROW_ID_AUTH_LOGIN      = 2
    let ROW_ID_AUTH_PASSWORD   = 3
    
    let ROW_ID_DOMAIN_REALM    = 0
    let ROW_ID_SERVER_IP       = 1
    let ROW_ID_SERVER_PORT     = 2
    let ROW_ID_REGISTER_SIP    = 3
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static var m_sAccountInfo_UserName: String          = ""
    static var m_sAccountInfo_DisplayName: String       = ""
    static var m_sAccountInfo_AuthLogin: String         = ""
    static var m_sAccountInfo_AuthPwd: String           = ""
    
    static var m_sAccountInfo_DomainRealm: String       = ""
    static var m_sAccountInfo_ServerAddr: String        = ""
    static var m_sAccountInfo_ServerPort: String        = "5060"
    
    static var m_bAccountInfo_Registration: Bool        = true

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PreloadAccountInfo(sUserName: String, sDisplayName: String, sAuthLogin: String, sAuthPwd: String, sDomainRealm: String, sServerAddr: String, sServerPort: String, bRegisterSIP: Bool) ->Void
    {
        m_sAccountInfo_UserName = sUserName
        m_sAccountInfo_DisplayName = sDisplayName
        
        m_sAccountInfo_AuthLogin = sAuthLogin
        m_sAccountInfo_AuthPwd = sAuthPwd
        
        m_sAccountInfo_DomainRealm = sDomainRealm
        m_sAccountInfo_ServerAddr = sServerAddr
        m_sAccountInfo_ServerPort = sServerPort
        
        m_bAccountInfo_Registration = bRegisterSIP
    }
    
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        if section == SECTION_ID_PROFILE
        {
            return SECTION_PROFILE_ROWS;
        }
        return SECTION_SETTING_ROWS;
    }
    
    override func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String?
    {
        if section == SECTION_ID_PROFILE
        {
            return "Account Profile"
        }
        if section == SECTION_ID_SETTINGS
        {
            return "Account Settings";
        }
        
        return ""
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell
    {
        if indexPath.row == ROW_ID_USER_NAME && indexPath.section == SECTION_ID_PROFILE
        {
            let vRowView: cAccountInfoRowView  = tableView.dequeueReusableCell(withIdentifier: "UserNameCellId", for: indexPath) as! cAccountInfoRowView
            
            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_UserName)
            return vRowView
        }
    
        if indexPath.row == ROW_ID_DISPLAY_NAME && indexPath.section == SECTION_ID_PROFILE
        {
            let vRowView: cAccountInfoRowView = tableView.dequeueReusableCell(withIdentifier: "DisplayNameCellId", for: indexPath) as! cAccountInfoRowView
            
            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_DisplayName)
            return vRowView
        }
        
        if indexPath.row == ROW_ID_AUTH_LOGIN && indexPath.section == SECTION_ID_PROFILE
        {
            let vRowView: cAccountInfoRowView  = tableView.dequeueReusableCell(withIdentifier: "AuthLoginCellId", for: indexPath) as! cAccountInfoRowView

            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_AuthLogin)
            return vRowView
        }
        
        if indexPath.row == ROW_ID_AUTH_PASSWORD && indexPath.section == SECTION_ID_PROFILE
        {
            let vRowView: cAccountInfoRowView  = tableView.dequeueReusableCell(withIdentifier: "AuthPasswordCellId", for: indexPath) as! cAccountInfoRowView
            
            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_AuthPwd)
            return vRowView
        }
        
        if indexPath.row == ROW_ID_DOMAIN_REALM && indexPath.section == SECTION_ID_SETTINGS
        {
            let vRowView: cAccountInfoRowView = tableView.dequeueReusableCell(withIdentifier: "DomainCellId", for: indexPath) as! cAccountInfoRowView
            
            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_DomainRealm)
            return vRowView
        }
        
        if indexPath.row == ROW_ID_SERVER_IP && indexPath.section == SECTION_ID_SETTINGS
        {
            let vRowView: cAccountInfoRowView  = tableView.dequeueReusableCell(withIdentifier: "ServerIPCellId", for: indexPath) as! cAccountInfoRowView

            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_ServerAddr)
            return vRowView
        }
        
        if indexPath.row == ROW_ID_SERVER_PORT && indexPath.section == SECTION_ID_SETTINGS
        {
            let vRowView: cAccountInfoRowView = tableView.dequeueReusableCell(withIdentifier: "ServerPortCellId", for: indexPath) as! cAccountInfoRowView

            vRowView.SetTextField(sText: cAccountInfoTableView.m_sAccountInfo_ServerPort)
            return vRowView
        }
    
        let vRowView: cAccountInfoRowView  = tableView.dequeueReusableCell(withIdentifier: "SIPRegisterCellId", for: indexPath) as! cAccountInfoRowView
        
        vRowView.SetCheckBoxState(bEnable: cAccountInfoTableView.m_bAccountInfo_Registration)
        return vRowView
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?)
    {
        if (segue.identifier == "UnwindSave")
        {
            self.StoreInfoAll()
        }
        else if (segue.identifier == "UnwindCancel")
        {
            
        }
    }
    
    func StoreInfoAll() ->Void
    {
        let vStore: cStoreAccount = cStoreAccount()
        
        vStore.SetUserName(cAccountInfoTableView.m_sAccountInfo_UserName)
        vStore.SetDisplayName(cAccountInfoTableView.m_sAccountInfo_DisplayName)
        
        vStore.SetAuthLogin(cAccountInfoTableView.m_sAccountInfo_AuthLogin)
        vStore.SetAuthPwd(cAccountInfoTableView.m_sAccountInfo_AuthPwd)
        
        vStore.SetDomainRealm(cAccountInfoTableView.m_sAccountInfo_DomainRealm)
        vStore.SetServerAddr(cAccountInfoTableView.m_sAccountInfo_ServerAddr)
        vStore.SetServerPort(cAccountInfoTableView.m_sAccountInfo_ServerPort)
        
        vStore.SetRegistration(cAccountInfoTableView.m_bAccountInfo_Registration)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnEditingUserName(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_UserName = vTextField.text!
    }
    
    @IBAction func OnEditingDisplayName(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_DisplayName = vTextField.text!
    }
    
    @IBAction func OnEditingAuthLogin(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_AuthLogin = vTextField.text!
    }
    
    @IBAction func OnEditingAuthPwd(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_AuthPwd = vTextField.text!
    }
    
    @IBAction func OnEditingDomainRealm(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_DomainRealm = vTextField.text!
    }
    
    @IBAction func OnEditingServerAddr(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_ServerAddr = vTextField.text!
    }
    
    @IBAction func OnEditingServerPort(_ sender: Any)
    {
        let vTextField: cCustomTextField = sender as! cCustomTextField
        cAccountInfoTableView.m_sAccountInfo_ServerPort = vTextField.text!
    }
    
    @IBAction func OnClickRegisterSIP(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        cAccountInfoTableView.m_bAccountInfo_Registration = vCheckBox.GetState()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
