
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var m_nChatMyStatusTableView_StatusId: Int = cVaxUserAgentInfo.VAX_CONTACT_STATUS_ONLINE

class cChatMyStatusTableView: UITableViewController
{
    let  SECTION_TOTAL_COUNT             = 1
    let  ROW_TOTAL_COUNT                 = 5
    
    let  SECTION_ID_MY_STATUS            = 0
    
    let CONTACT_STATUS_ONLINE        = cVaxUserAgentInfo.VAX_CONTACT_STATUS_ONLINE
    let CONTACT_STATUS_OFFLINE       = cVaxUserAgentInfo.VAX_CONTACT_STATUS_OFFLINE
    let CONTACT_STATUS_AWAY          = cVaxUserAgentInfo.VAX_CONTACT_STATUS_AWAY
    let CONTACT_STATUS_ON_PHONE      = cVaxUserAgentInfo.VAX_CONTACT_STATUS_ON_PHONE
    let CONTACT_STATUS_BUSY          = cVaxUserAgentInfo.VAX_CONTACT_STATUS_BUSY
    let CONTACT_STATUS_UNKNOWN       = cVaxUserAgentInfo.VAX_CONTACT_STATUS_UNKNOWN
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize() ->Void
    {
        cVaxPhoneChat.GetSelf().ChatSetMyStatus(m_nChatMyStatusTableView_StatusId)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        var bSelected: Bool = false
        
        if m_nChatMyStatusTableView_StatusId == indexPath.row
        {
            bSelected = true
        }
        
        var vRowView: cChatMyStatusRowView? = nil
        
        if indexPath.row == CONTACT_STATUS_ONLINE && indexPath.section == SECTION_ID_MY_STATUS
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatStatusOnlineCellId", for: indexPath) as? cChatMyStatusRowView
        }
            
        else if indexPath.row == CONTACT_STATUS_OFFLINE && indexPath.section == SECTION_ID_MY_STATUS
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatStatusOfflineCellId", for: indexPath) as? cChatMyStatusRowView
        }
            
        else if indexPath.row == CONTACT_STATUS_AWAY && indexPath.section == SECTION_ID_MY_STATUS
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatStatusAwayCellId", for: indexPath) as? cChatMyStatusRowView
        }
            
        else if indexPath.row == CONTACT_STATUS_ON_PHONE && indexPath.section == SECTION_ID_MY_STATUS
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatStatusOnPhoneCellId", for: indexPath) as? cChatMyStatusRowView
        }
        else
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatStatusBusyCellId", for: indexPath) as? cChatMyStatusRowView
        }
        
        vRowView?.SetSelected(bSelected: bSelected)
        
        return vRowView!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cChatMyStatusRowView? = tableView.cellForRow(at: IndexPath(row: nRowNo, section: SECTION_ID_MY_STATUS)) as? cChatMyStatusRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
        let vRowView: cChatMyStatusRowView? = tableView.cellForRow(at: indexPath) as? cChatMyStatusRowView
        if vRowView != nil
        {
            vRowView?.SetSelected(bSelected: true)
        }
        
        m_nChatMyStatusTableView_StatusId = indexPath.row
        cVaxPhoneChat.GetSelf().ChatSetMyStatus(m_nChatMyStatusTableView_StatusId)
        
        performSegue(withIdentifier: "UnwindSegueToChatContact", sender: self)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
