
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cChatContactRowView: UITableViewCell
{
    @IBOutlet var mLabelContactName: UILabel!
    @IBOutlet var mLabelContactStatus: UILabel!
    
    @IBOutlet var mImageContactStatus: UIImageView!
    
    var m_vRowData: cChatContactRowData?
    
    override func awakeFromNib()
    {
        super.awakeFromNib()
    }

    override func setSelected(_ selected: Bool, animated: Bool)
    {
        super.setSelected(selected, animated: animated)
    }
    
    func SetData(vRowData: cChatContactRowData) -> Void
    {
        m_vRowData = vRowData
        
        self.UpdateLabelContactName()
        self.UpdateContactStatus()
    }
    
    func GetContactName() ->String
    {
        return m_vRowData!.GetContactName()
    }
    
    func UpdateContactStatus() ->Void
    {
        let nStatusId: Int  = m_vRowData!.GetStatusId()
        
        if nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_ONLINE
        {
            mImageContactStatus.image = UIImage(named: "aChatOnline")
            mLabelContactStatus.text = "(Online)"
        }
        
        else if nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_OFFLINE
        {
            mImageContactStatus.image = UIImage(named: "aChatOffline")
            mLabelContactStatus.text = "(Offline)"
        }
            
        else if nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_UNKNOWN
        {
            mImageContactStatus.image = UIImage(named: "aChatUnknown")
            mLabelContactStatus.text = ""
        }
            
        else if nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_BUSY || nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_ON_PHONE
        {
            mImageContactStatus.image = UIImage(named: "aChatBusy")
            mLabelContactStatus.text = "(Busy)"
        }
            
        else if nStatusId == cVaxUserAgentInfo.VAX_CONTACT_STATUS_AWAY
        {
            mImageContactStatus.image = UIImage(named: "aChatAway")
            mLabelContactStatus.text = "(Away)"
        }
            
        else
        {
            mImageContactStatus.image = UIImage(named: "aChatOffline")
            mLabelContactStatus.text = "(Offline)"
        }
    }
    
    func UpdateContactMissedCount() ->Void
    {
        self.UpdateLabelContactName()
    }
    
    func UpdateLabelContactName() ->Void
    {
        let nMissedCount: Int = m_vRowData!.GetMissedCount()
        
        if nMissedCount == 0
        {
            mLabelContactName.text = m_vRowData?.GetContactName()
            mLabelContactName.textColor = UIColor.black
        }
        else
        {
            let sContactLable: String = NSString(format: "%@ (%d)", m_vRowData!.GetContactName(), nMissedCount) as String
            
            mLabelContactName.text = sContactLable
            mLabelContactName.textColor = UIColor.red
        }
    }
    
}
