
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var mvChatContactTableView: cChatContactTableView! = nil
var mvChatContactTableData: [Any]? = nil
var m_nChatContactMissedCount: Int = 0

class cChatContactTableView: UITableViewController, cAddressBookViewDelegate
{
    @IBOutlet var mTitleBarAB: UILabel!
    
    var mvAddressBookView: cAddressBookView? = nil
    
    let  SECTION_TOTAL_COUNT       = 1
    let  SECTION_ID_CHAT_CONTACT   = 0
    
    var mContactsView: cAddressBookView!

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    static func OnStartedAPP() ->Void
    {
        mvChatContactTableData = [Any]()
        //cChatMyStatusTableView.OnStartedAPP()
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        mvChatContactTableView = self
        
        cChatContactTableView.SetMissedCount(nValue: 0)
        cChatContactTableView.ResetContactSelectedStateAll()
        
        cVaxPhoneChat.GetSelf().ChatSubscribeContactAll()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
    override func viewWillDisappear(_ animated: Bool)
    {
        mvChatContactTableView = nil
        super.viewWillDisappear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetContactSelectedStateAll() ->Void
    {
        for nRowNo in 0..<mvChatContactTableData!.count
        {
            let vRowData: cChatContactRowData? = mvChatContactTableData![nRowNo] as? cChatContactRowData
            vRowData?.SetContactSelected(bSelected: false)
        }
    }
    
    static func PostInitialize()
    {
        cVaxPhoneChat.GetSelf().LoadChatContactAll()
        
        /*
         [cChatMyStatusTableView PostInitialize];
         
         */
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostChatContactAdded(sContactName: String, nMissedCount: Int, bPresence: Bool) ->Void
    {
        var vRowData: cChatContactRowData? = cChatContactTableView.FindChatContact(sContactName: sContactName)
            
        if vRowData == nil
        {
            vRowData = cChatContactRowData()
            vRowData?.SetContactName(sName: sContactName)
            
            mvChatContactTableData?.append(vRowData!)
        }
        
        vRowData?.SetMissedCount(nValue: nMissedCount)
        vRowData?.SetPresence(bPresence: bPresence)
        
        if mvChatContactTableView != nil
        {
            let nRowNo = mvChatContactTableData!.count - 1
            mvChatContactTableView.AddRowView(nRowNo: nRowNo)
        }
        
    }
    
    func AddRowView(nRowNo: Int) ->Void
    {
        let indexPath = IndexPath(row: nRowNo, section: SECTION_ID_CHAT_CONTACT)
        tableView.insertRows(at: [indexPath], with: .automatic)
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostChatMessageText(sContactName: String, bIsChatContact: Bool, sMsgText: String, bMsgTypeOutgoing: Bool) ->Void
    {
        if (bMsgTypeOutgoing == false && cMainTabBarController.IsChatContactSelected() == false)
        {
            cChatContactTableView.SetMissedCount(nValue: -1)
        }
        
        /////////////////////////////////////////////////////////////////////////
        
        let vRowData: cChatContactRowData? = cChatContactTableView.FindChatContact(sContactName: sContactName)
        
        if bMsgTypeOutgoing == false && vRowData != nil
        {
            if vRowData?.IsContactSelected() == false
            {
               vRowData?.SetMissedCount(nValue: -1)
            }
        }
        
        if vRowData?.IsContactSelected() == true
        {
            cChatMsgTableView.PostChatMessageText(sContactName: sContactName, sMsgText: sMsgText, bMsgTypeOutgoing: bMsgTypeOutgoing)
        }
        
        /////////////////////////////////////////////////////////////////////////
        
        if bMsgTypeOutgoing == false && mvChatContactTableView != nil
        {
            mvChatContactTableView.UpdateMissedCountRowView(sUserName: sContactName)
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostChatContactStatus(sContactName: String, nStatusId: Int) ->Void
    {
        let vRowData: cChatContactRowData? = cChatContactTableView.FindChatContact(sContactName: sContactName)
        
        if vRowData != nil
        {
            vRowData?.SetStatusId(nStatusId: nStatusId)
            
            if mvChatContactTableView == nil
            {
                return
            }
        }
        
        mvChatContactTableView.UpdateStatusRowView(sUserName: sContactName, nStatusId: nStatusId)
    }
    
    static func FindChatContact(sContactName: String) ->cChatContactRowData!
    {
        var vResultRowData: cChatContactRowData? = nil
        
        for nRowNo in 0..<mvChatContactTableData!.count
        {
            let vRowData: cChatContactRowData? = mvChatContactTableData![nRowNo] as? cChatContactRowData
            
            if vRowData == nil
            {
                continue
            }
            
            let sName: String = vRowData!.GetContactName()
            
            if sName.compare(sContactName, options: .caseInsensitive) == .orderedSame
            {
                vResultRowData = vRowData
                break
            }
            
        }
        
        return vResultRowData
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func UpdateStatusRowView(sUserName: String, nStatusId: Int) ->Void
    {
        for nRowNo in 0..<mvChatContactTableData!.count
        {
            let indexPath: IndexPath? = IndexPath(row: nRowNo, section: SECTION_ID_CHAT_CONTACT)
            
            if indexPath == nil
            {
                continue
            }
            
            let vRowView: cChatContactRowView? = self.tableView.cellForRow(at: indexPath!) as? cChatContactRowView
            
            if vRowView == nil
            {
                continue
            }
            
            let sContactName: String = vRowView!.GetContactName()
            
            if sUserName.compare(sContactName, options: .caseInsensitive) != .orderedSame
            {
                continue
            }
            
            vRowView?.UpdateContactStatus()
        }
    }
    
    func UpdateMissedCountRowView(sUserName: String) ->Void
    {
        for nRowNo in 0..<mvChatContactTableData!.count
        {
            let indexPath: IndexPath? = IndexPath(row: nRowNo, section: SECTION_ID_CHAT_CONTACT)
            
            if indexPath == nil
            {
                continue
            }
            
            let vRowView: cChatContactRowView? = self.tableView.cellForRow(at: indexPath!) as? cChatContactRowView
            
            if vRowView == nil
            {
                continue
            }
            
            let sContactName: String = vRowView!.GetContactName()
            
            if sUserName.compare(sContactName, options: .caseInsensitive) != .orderedSame
            {
                continue
            }
            
            vRowView?.UpdateContactMissedCount()
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func DeleteRow(nRowNo: Int) ->Void
    {
        if nRowNo >= mvChatContactTableData!.count
        {
            return
        }
        
        let vRowData: cChatContactRowData = mvChatContactTableData![nRowNo] as! cChatContactRowData
        
        cVaxPhoneChat.GetSelf().ChatRemoveContact(vRowData.GetContactName())
        mvChatContactTableData?.remove(at: nRowNo)
        
        let indexPath = IndexPath(row: nRowNo, section: SECTION_ID_CHAT_CONTACT)
        self.tableView.deleteRows(at: [indexPath], with: .fade)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return mvChatContactTableData!.count
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        let vRowData: cChatContactRowData = mvChatContactTableData![indexPath.row] as! cChatContactRowData
        let vRowView: cChatContactRowView = tableView.dequeueReusableCell(withIdentifier: "ChatContactCellId", for: indexPath) as! cChatContactRowView
        
        vRowView.SetData(vRowData: vRowData)
        return vRowView
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?)
    {
        if (segue.identifier == "SegueChatMsgContainerView")
        {
            var sAddContactMsg: String = ""
            var sContactName: String = ""
            
            var vRowData: cChatContactRowData? = nil
            
            if (sender is cChatContactRowData)
            {
                vRowData = (sender as? cChatContactRowData)
                
                sContactName = vRowData!.GetContactName()
                sAddContactMsg = "Hi, I'd like to add you as a chat contact."
            }
            else
            {
                let indexPath: IndexPath? = tableView.indexPathForSelectedRow
                
                if indexPath == nil
                {
                    return
                }
                vRowData = mvChatContactTableData![indexPath!.row] as? cChatContactRowData
                
                sContactName = vRowData!.GetContactName()
                sAddContactMsg = ""
            }
            
            vRowData?.SetMissedCount(nValue: 0)
            vRowData?.SetContactSelected(bSelected: true)
            
            cChatMsgContainerView.PostMessageViewData(sContactName: sContactName, bPresence: vRowData!.GetPresence(), sMsgText: sAddContactMsg)
        }
    }
    
    func ShowAddressBookUI(pTitleBar: UILabel) ->Bool
    {
        mvAddressBookView = cAddressBookView(iDelegate: self)
        mvAddressBookView?.ShowContacts(self, true)
        
        return true
    }
    
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickAddContact(_ sender: Any)
    {
        let MsgAlert = UIAlertController(title: "Chat Contact SIP", message: "", preferredStyle: .alert)
        
        let AddAction = UIAlertAction(title: "Add Account SIP", style: .default, handler:
        {(_ action: UIAlertAction) -> Void in
            
            let txtAccountSIP: UITextField? = MsgAlert.textFields?.first
            
            if (txtAccountSIP?.text?.count)! > 0
            {
                self.ChatContactAdd((txtAccountSIP?.text)!)
            }
            
            MsgAlert.dismiss(animated: false, completion: nil)
        })
        
        let ChooseAction = UIAlertAction(title: "Choose from contacts", style: .default, handler: {(_ action: UIAlertAction) -> Void in
           
            self.ShowAddressBookUI(pTitleBar: self.mTitleBarAB)
            
            MsgAlert.dismiss(animated: false, completion: nil)
        })
        
        let CancelAction = UIAlertAction(title: "Cancel", style: .default, handler: {(_ action: UIAlertAction) -> Void in
        })
        
        AddAction.setValue(UIColor.darkGray, forKey: "titleTextColor")
        ChooseAction.setValue(UIColor.darkGray, forKey: "titleTextColor")
        CancelAction.setValue(UIColor.black, forKey: "titleTextColor")
        
        MsgAlert.addTextField(configurationHandler: {(_ txtAccountSIP: UITextField) -> Void in
            
            txtAccountSIP.placeholder = "Account SIP"
        })
        
        MsgAlert.addAction(AddAction)
        MsgAlert.addAction(ChooseAction)
        MsgAlert.addAction(CancelAction)
        
        self.present(MsgAlert, animated: true, completion: nil)
    }
    
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
    
    func ChatContactAdd(_ sContactTitle: String) ->Void
    {
        if !cVaxPhoneChat.GetSelf().ChatAddContact(sContactTitle, true)
        {
            return
        }
        
        let vRowCount = mvChatContactTableData!.count - 1
        
        let vRowData: cChatContactRowData? = mvChatContactTableData![vRowCount] as? cChatContactRowData
        
        performSegue(withIdentifier: "SegueChatMsgContainerView", sender: vRowData)
    }
    
    func OnAddressBookSelectedContact(_ sContactId: String, _ sContactTitle: String) ->Void
    {
        self.ChatContactAdd(sContactTitle)
    }
    
    @IBAction func UnwindFromChatMyStatusView(_ segue : UIStoryboardSegue)
    {
    
    }
    
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool
    {
        return true
    }
    
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCell.EditingStyle, forRowAt indexPath: IndexPath)
    {
        if editingStyle == .delete
        {
            self.DeleteRow(nRowNo: indexPath.row)
        }
    }
    
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
    
    static func LoadMissedCount() ->Void
    {
        m_nChatContactMissedCount = cChatContactTableView.ReadMissedCount()
        cMainTabBarController.SetChatContactBadgeCount(nValue: m_nChatContactMissedCount)
    }
    
    static func SetMissedCount(nValue: Int) ->Void
    {
        if nValue == 0
        {
            m_nChatContactMissedCount = 0
        }
        else
        {
            m_nChatContactMissedCount += 1
        }
        
        cMainTabBarController.SetChatContactBadgeCount(nValue: m_nChatContactMissedCount)
        cChatContactTableView.StoreMissedCount()
    }
    
    static func StoreMissedCount()
    {
        let pRefs = UserDefaults.standard

        
        pRefs.set(Int(m_nChatContactMissedCount), forKey: "m_nChatContactMissedCount")
        pRefs.synchronize()
    }
    
    static func ReadMissedCount() -> Int
    {
        let pRefs = UserDefaults.standard
        
        let pValue = pRefs.object(forKey: "m_nChatContactMissedCount")
        
        if pValue == nil
        {
            return 0
        }
        return pValue as! Int
    }
  
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

}
