
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var m_sChatMsgContainerView_ContactName: String = ""
var m_sChatMsgContainerView_NewContactMsg: String = ""

class cChatMsgContainerView: UIViewController, UITextFieldDelegate
{
    var m_sAddContactMsg: String = ""
    var m_sChatContactName: String = ""
    
    @IBOutlet var mSendChatMsgText: UITextField!
    
    var mWndFrame: CGRect?
    var mKeyBoardFrame: CGRect?
    

    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        mSendChatMsgText.delegate = self
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostMessageViewData(sContactName: String, bPresence: Bool, sMsgText: String) ->Void
    {
        cChatMsgTableView.PostMessageViewData(sContactName: sContactName, bPresence: bPresence)
        
        m_sChatMsgContainerView_ContactName = ""
        m_sChatMsgContainerView_ContactName = sContactName
        
        m_sChatMsgContainerView_NewContactMsg = ""
        m_sChatMsgContainerView_NewContactMsg = sMsgText
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        NotificationCenter.default.addObserver(self, selector: #selector(self.keyboardWillShow), name: UIResponder.keyboardWillShowNotification, object: view.window)
        NotificationCenter.default.addObserver(self, selector: #selector(self.keyboardWillHide), name: UIResponder.keyboardWillHideNotification, object: view.window)
        NotificationCenter.default.addObserver(self, selector: #selector(self.keyboardDidShow), name:  UIResponder.keyboardDidShowNotification, object: view.window)
        
        if m_sChatMsgContainerView_NewContactMsg != nil && m_sChatMsgContainerView_NewContactMsg.count != 0
        {
            mSendChatMsgText.text = m_sChatMsgContainerView_NewContactMsg
        }
        
        super.viewWillAppear(animated)
    }
    
    override func viewDidAppear(_ animated: Bool)
    {
        mWndFrame = self.view.window!.frame
        super.viewDidAppear(animated)
    }
    
    override func viewWillDisappear(_ animated: Bool)
    {
        self.ResetView()
        
        NotificationCenter.default.removeObserver(self, name: UIResponder.keyboardWillShowNotification, object: nil)
        NotificationCenter.default.removeObserver(self, name: UIResponder.keyboardWillHideNotification, object: nil)
        NotificationCenter.default.removeObserver(self, name: UIResponder.keyboardDidShowNotification, object: nil)
        
        super.viewWillDisappear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func keyboardWillHide(notification: Notification)
    {
        let info: NSDictionary = notification.userInfo! as NSDictionary
        let KeyBoardFrame: CGRect = info.object(forKey: UIResponder.keyboardFrameEndUserInfoKey) as! CGRect
        
        var WndFrame: CGRect = self.view.window!.frame
        
        mWndFrame = CGRect(x: 0, y: 0, width: KeyBoardFrame.size.width, height: KeyBoardFrame.origin.y)
        WndFrame = CGRect(x: 0, y: 0, width: KeyBoardFrame.size.width, height: KeyBoardFrame.origin.y)
        
        view.window?.frame = WndFrame
    }
    
    @objc func keyboardWillShow(notification: NSNotification) ->Void
    {
        let info: NSDictionary = notification.userInfo! as NSDictionary
        let KeyBoardFrame: CGRect = info.object(forKey: UIResponder.keyboardFrameEndUserInfoKey) as! CGRect
        
        let nHeightTabBar = self.tabBarController?.tabBar.frame.size.height
        
        var WndFrame: CGRect = self.view.window!.frame
        mWndFrame = CGRect(x: 0, y: 0, width: KeyBoardFrame.size.width, height: KeyBoardFrame.size.height + KeyBoardFrame.origin.y)
        
        WndFrame = CGRect(x: 0, y: 0, width: KeyBoardFrame.size.width, height: KeyBoardFrame.origin.y + nHeightTabBar!)
        self.view.window?.frame = WndFrame

    }
    
    @objc func keyboardDidShow(notification: NSNotification) ->Void
    {
        cChatMsgTableView.PostScrollToBottom()
    }
    
    func textFieldShouldReturn(_ textField: UITextField) -> Bool
    {
        mSendChatMsgText.resignFirstResponder()
        return true
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    func ResetView() ->Void
    {
        self.view.window?.frame = mWndFrame!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickClearBtn(_ sender: Any)
    {
        cChatMsgTableView.PostClearMsgAll()
    }
    
    @IBAction func OnClickSendBtn(_ sender: Any)
    {
        if mSendChatMsgText.text!.count == 0 || m_sChatMsgContainerView_ContactName.isEmpty
        {
            return
        }
        
        if !cVaxPhoneChat.GetSelf().ChatSendMessageText(m_sChatMsgContainerView_ContactName, mSendChatMsgText.text!)
        {
            return
        }
        
        mSendChatMsgText.text = ""
    }
}
