
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cChatMsgRowView: UITableViewCell
{
    @IBOutlet var mLabelIncomingMsg: UILabel!
    @IBOutlet var mBubbleIncomingMsg: UIImageView!
    
    @IBOutlet var mLabelOutgoingMsg: UILabel!
    @IBOutlet var mBubbleOutgoingMsg: UIImageView!
    
    var m_bMsgTypeOutgoing: Bool = false
    
    var m_vRowData: cChatMsgRowData?
    
    
    override func awakeFromNib()
    {
        if(mLabelIncomingMsg != nil)
        {
            mLabelIncomingMsg.isHidden = false
        }
        
        if(mBubbleIncomingMsg != nil)
        {
            mBubbleIncomingMsg.isHidden = false
        }
        
        if(mLabelOutgoingMsg != nil)
        {
            mLabelOutgoingMsg.isHidden = false
        }
        
        if(mBubbleOutgoingMsg != nil)
        {
            mBubbleOutgoingMsg.isHidden = false
        }
        
        super.awakeFromNib()
    }
    
    override func setSelected(_ selected: Bool, animated: Bool)
    {
        super.setSelected(selected, animated: animated)
    }
    
    func SetData(vRowData: cChatMsgRowData) ->Void
    {
        m_vRowData = vRowData
        
        let sTextMsg: String = vRowData.GetChatMsgText()
        m_bMsgTypeOutgoing = vRowData.IsChatMsgTypeOutgoing()
        
        if m_bMsgTypeOutgoing
        {
            self.SetOutgingMsg(sTextMsg: sTextMsg)
        }
        
        else
        {
            self.SetIncomingMsg(sTextMsg: sTextMsg)
        }
        
    }
    
    func SetIncomingMsg(sTextMsg: String) ->Void
    {
        mLabelIncomingMsg.text = sTextMsg
    }
    
    func SetOutgingMsg(sTextMsg: String) ->Void
    {
        mLabelOutgoingMsg.text = sTextMsg
    }
}
