
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var m_vChatMsgTableView: cChatMsgTableView?
var m_sChatMsgTableContactName: String = ""
var m_bChatMsgTablePresence: Bool = false

class cChatMsgTableView: UITableViewController
{
    @IBOutlet var mNewChatAcceptView: UIView!
    
    let  SECTION_TOTAL_COUNT  = 1
    let  SECTION_ID_CHAT_MSG  = 0
    
     var mvTableData: [Any]!
    
    var m_CellHeights: NSMutableDictionary = [:]
    var m_bDidAppear: Bool = false
    
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        m_bDidAppear = false
        
        self.tableView.rowHeight = UITableView.automaticDimension
        self.tableView.estimatedRowHeight = 140.0
        
        m_CellHeights = NSMutableDictionary()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func LoadChatMessageAll() ->Void
    {
        let vStoreDB: cStoreChatMsgs? = cStoreChatMsgs()
        let aMessageAll: [Any] = vStoreDB!.GetChatMessageAll(m_sChatMsgTableContactName)
        
        for nRecordNo in 0..<aMessageAll.count
        {
            let vDataDB: cStoreDataChatMsgs = aMessageAll[nRecordNo] as! cStoreDataChatMsgs
            self.AddChatMessageText(sContactName: vDataDB.m_sContactName, sMsgText: vDataDB.m_sMsgText, bMsgTypeOutgoing: vDataDB.m_bMsgTypeOutgoing)
        }
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostMessageViewData(sContactName: String, bPresence: Bool) ->Void
    {
        m_sChatMsgTableContactName = ""
        m_sChatMsgTableContactName = sContactName
        
        m_bChatMsgTablePresence = bPresence
    }
    
    static func PostChatMessageText(sContactName: String, sMsgText: String, bMsgTypeOutgoing: Bool) ->Void
    {
        if m_vChatMsgTableView == nil
        {
            return
        }
        
        if sContactName.compare(m_sChatMsgTableContactName, options: .caseInsensitive) != .orderedSame
        {
            return
        }
        
        m_vChatMsgTableView?.AddChatMessageText(sContactName: sContactName, sMsgText: sMsgText, bMsgTypeOutgoing: bMsgTypeOutgoing)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewDidLayoutSubviews()
    {
        super.viewDidLayoutSubviews()
        
        if m_bDidAppear == false
        {
            self.ScrollTableViewToBottom(bAnimate: false)
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        m_vChatMsgTableView = self
        
        m_bDidAppear = false
        mvTableData = [Any]()
        
        self.LoadChatMessageAll()
        
        if m_bChatMsgTablePresence
        {
            tableView.tableHeaderView = nil
        }
        else
        {
            self.tableView.tableHeaderView = mNewChatAcceptView
        }
        
        self.tableView.reloadData()
        
        super.viewWillAppear(animated)
    }
    
    override func viewDidAppear(_ animated: Bool)
    {
        m_bDidAppear = true
        super.viewDidAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillDisappear(_ animated: Bool)
    {
        m_vChatMsgTableView = nil
        m_sChatMsgTableContactName = ""
        
        mvTableData.removeAll()
        mvTableData = nil
        
        super.viewWillDisappear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func AddChatMessageText(sContactName: String, sMsgText: String, bMsgTypeOutgoing: Bool) ->Void
    {
        let vRowData:cChatMsgRowData = cChatMsgRowData()
        vRowData.SetChatMsg(sMsgText: sMsgText, bMsgTypeOutgoing: bMsgTypeOutgoing)
        
        mvTableData.append(vRowData)
        
        if m_bDidAppear
        {
            let nRowNo: Int = mvTableData.count - 1
            self.AddRowView(nRowNo: nRowNo)
        }
    }
    
    func AddRowView(nRowNo: Int) ->Void
    {
        let indexPath = IndexPath(row: nRowNo, section: SECTION_ID_CHAT_MSG)
        tableView.insertRows(at: [indexPath], with: .automatic)
        
        self.ScrollTableViewToBottom(bAnimate: true)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostScrollToBottom() ->Void
    {
        if m_vChatMsgTableView == nil
        {
            return
        }
        
        m_vChatMsgTableView?.ScrollTableViewToBottom(bAnimate: true)
    }
    
    func ScrollTableViewToBottom(bAnimate: Bool) ->Void
    {
        let nTableRowCount: Int = tableView.numberOfRows(inSection: SECTION_ID_CHAT_MSG)
        if nTableRowCount == 0
        {
            return
        }
        tableView.scrollToRow(at: IndexPath(row: nTableRowCount - 1, section: SECTION_ID_CHAT_MSG), at: .bottom, animated: bAnimate)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return mvTableData.count
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        let vRowData: cChatMsgRowData  = mvTableData[indexPath.row] as! cChatMsgRowData
        var vRowView: cChatMsgRowView? = nil
                        
        if (vRowData.IsChatMsgTypeOutgoing())
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatOutgoingMsgCellId", for: indexPath) as? cChatMsgRowView
        }
        else
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChatIncomingMsgCellId", for: indexPath) as? cChatMsgRowView
        }

        vRowView?.SetData(vRowData: vRowData)
        return vRowView!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, estimatedHeightForRowAt indexPath: IndexPath) -> CGFloat
    {
        let nHeight: NSNumber? = m_CellHeights.object(forKey: indexPath) as? NSNumber
        
        if nHeight != nil
        {
            return CGFloat(nHeight!.doubleValue)
        }
        return CGFloat(UITableView.automaticDimension)
    }
    
    override func tableView(_ tableView: UITableView, willDisplay cell: UITableViewCell, forRowAt indexPath: IndexPath)
    {
        m_CellHeights.setObject(cell.frame.size.height, forKey: indexPath as NSCopying)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func ClearMsgAll() ->Void
    {
        if m_vChatMsgTableView == nil
        {
            return
        }
        
        let vStoreDB: cStoreChatMsgs = cStoreChatMsgs()
        vStoreDB.RemoveMessageAll(m_sChatMsgTableContactName)
        
        mvTableData.removeAll()
        
        self.tableView.reloadData()
        m_CellHeights.removeAllObjects()
    }
    
    static func PostClearMsgAll() ->Void
    {
        if m_vChatMsgTableView == nil
        {
            return
        }
        
        m_vChatMsgTableView?.ClearMsgAll()
    }
    
    @IBAction func OnClickAcceptBtn(_ sender: Any)
    {
        if !cVaxPhoneChat.GetSelf().ChatAddContact(m_sChatMsgTableContactName, true)
        {
            return
        }
        
        tableView.tableHeaderView = nil
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
