 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.
 
 import UIKit
 
 @objc protocol cCustomCellCheckBoxDelegate: NSObjectProtocol
 {
    func OnClickCustomCellCheckBox(_ bStateON: Bool, _ sender: Any)
 }
 
 class cCustomCellCheckBox: UIButton
 {
    var m_bStateON: Bool = false
    
    var mImageON: UIImage!
    var mImageOFF: UIImage!
    
    var mCheckBoxDelegate: cCustomCellCheckBoxDelegate!
    
    deinit
    {
        
    }
    
    func LoadCheckBox(_ iDelegate: cCustomCellCheckBoxDelegate?, _ sImageON: String, _ sImageOFF: String) ->Void
    {
        mCheckBoxDelegate = iDelegate
        
        mImageON = UIImage(named: sImageON)
        mImageOFF = UIImage(named: sImageOFF)
        
        self.SetState(false)
        self.addTarget(self, action: #selector(self.OnClickCustomCheckBoxTouchDown), for: .touchDown)
    }
    
    func SetSize(_ nWidth: Int, _ nHeight: Int) ->Void
    {
        var frame: CGRect = self.frame
        
        frame.size.width = CGFloat(nWidth)
        frame.size.height = CGFloat(nHeight)
        
        self.frame = frame
    }
    
    func GetState() ->Bool
    {
        return m_bStateON;
    }
    
    func SetState(_ bStateON: Bool) ->Void
    {
        m_bStateON = bStateON
        var pCheckBoxImage: UIImage? = mImageOFF
        
        if bStateON
        {
            pCheckBoxImage = mImageON
        }
        
        setImage(pCheckBoxImage, for: .normal)
    }
    
    func ToggleState() ->Void
    {
        if GetState()
        {
            SetState(false)
        }
        else
        {
            SetState(true)
        }
    }
    
    @IBAction func OnClickCustomCheckBoxTouchDown (_ sender: Any)
    {
        ToggleState()
        
        if mCheckBoxDelegate == nil
        {
            return
        }
        
        if !mCheckBoxDelegate.responds(to: #selector(cCustomCellCheckBoxDelegate.OnClickCustomCellCheckBox))
        {
            return
        }
        
        mCheckBoxDelegate.OnClickCustomCellCheckBox(m_bStateON, self)
    }
 }

