
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var mvMainTabBar: cMainTabBarController! = nil

class cMainTabBarController: UITabBarController
{
    static let TAB_ITEM_INDEX_RECENT        = 0
    static let TAB_ITEM_INDEX_VIDEO         = 1
    static let TAB_ITEM_INDEX_CHAT          = 2
    static let TAB_ITEM_INDEX_SETTING       = 3
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        
        mvMainTabBar = self
        cMainTabBarController.SwitchToVideoTab(sPhoneNo: "")
        
        cChatContactTableView.LoadMissedCount()
        cRecentTableView.LoadMissedCount()
        
        UITabBar.appearance().tintColor = UIColor.white
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    override var prefersStatusBarHidden: Bool
    {
        return false
    }
    
    static func DismissMainTabBar() ->Void
    {
        if mvMainTabBar == nil
        {
            return
        }
        
        mvMainTabBar.dismiss(animated: false, completion: nil)
    }
    
    static func GetMainTabBar() ->UIViewController
    {
        return mvMainTabBar!
    }
    
    static func SwitchTab(nTabIndex: Int) ->Void
    {
        if mvMainTabBar == nil
        {
            return
        }
        
        mvMainTabBar.selectedIndex = nTabIndex
    }
    
    static func SwitchToVideoTab(sPhoneNo: String) ->Void
    {
        cVideoView.ShowDialpadWhenAppear(sNoText: sPhoneNo)
        cMainTabBarController.SwitchTab(nTabIndex: TAB_ITEM_INDEX_VIDEO)
    }
    
    static func IsChatContactSelected() ->Bool
    {
        if mvMainTabBar == nil
        {
            return false
        }
        
        if mvMainTabBar.selectedIndex != TAB_ITEM_INDEX_CHAT
        {
            return false
        }
        
        return true
    }
    
    static func SetChatContactBadgeCount(nValue: Int) ->Void
    {
        if mvMainTabBar == nil
        {
            return
        }
        
        let tabBarItem: UITabBarItem = mvMainTabBar!.tabBar.items![TAB_ITEM_INDEX_CHAT]
        
        if nValue == 0
        {
            tabBarItem.badgeValue = nil
        }
        else
        {
            tabBarItem.badgeValue = NSString(format: "%d", nValue) as String
        }
    }
    
    static func IsRecentSelected() ->Bool
    {
        if mvMainTabBar == nil
        {
            return false
        }
        
        if mvMainTabBar.selectedIndex != TAB_ITEM_INDEX_RECENT
        {
            return false
        }
        
        return true
    }
    
    static func SetRecentBadgeCount(nValue: Int) ->Void
    {
        if mvMainTabBar == nil
        {
            return
        }
        
        let tabBarItem: UITabBarItem = mvMainTabBar!.tabBar.items![TAB_ITEM_INDEX_RECENT]
        
        if nValue == 0
        {
            tabBarItem.badgeValue = nil
        }
        else
        {
            tabBarItem.badgeValue = NSString(format: "%d", nValue) as String
        }
    }
}
