
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cRecentRowView: UITableViewCell
{
    var CALL_HISTORY_TYPE_OUTBOUND            = 0
    var CALL_HISTORY_TYPE_INBOUND             = 1
    var CALL_HISTORY_TYPE_MISSED              = 2
    var CALL_HISTORY_TYPE_REJECTED            = 3
    
    @IBOutlet var mLabelRecentName: UILabel!
    @IBOutlet var mLabelRecentPhoneNo: UILabel!
    
    @IBOutlet var mLabelRecentDuration: UILabel!
    @IBOutlet var mLabelRecentDate: UILabel!
    @IBOutlet var mLabelRecentTime: UILabel!
    
    @IBOutlet var mImageViewRecentCallType: UIImageView!
    
    var m_vRowData: cRecentRowData?
    
    
    override func awakeFromNib()
    {
        super.awakeFromNib()
    }
    
    override func setSelected(_ selected: Bool, animated: Bool)
    {
        super.setSelected(selected, animated: animated)
    }
    
    func SetRowData(vRowData: cRecentRowData) ->Void
    {
        m_vRowData = vRowData
        
        self.UpdateLabelRecentName()
        self.UpdateImageCallType()
        self.UpdateLabelPhoneNo()
        self.UpdateLabelDateTime()
        self.UpdateLabelDuration()
    }
    
    func UpdateLabelRecentName() ->Void
    {
        mLabelRecentName.text = m_vRowData?.GetName()
    }
    
    func UpdateImageCallType() ->Void
    {
        let nHistoryType: Int = m_vRowData!.GetHistoryTypeId()
        
        if nHistoryType == CALL_HISTORY_TYPE_INBOUND
        {
            mImageViewRecentCallType.image = UIImage(named: "aCallTypeInbound")!
        }
            
        else if nHistoryType == CALL_HISTORY_TYPE_OUTBOUND
        {
            mImageViewRecentCallType.image = UIImage(named: "aCallTypeOutbound")
        }
            
        else if nHistoryType == CALL_HISTORY_TYPE_MISSED
        {
            mImageViewRecentCallType.image = UIImage(named: "aCallTypeMissed")
        }
            
        else if nHistoryType == CALL_HISTORY_TYPE_REJECTED
        {
            mImageViewRecentCallType.image = UIImage(named: "aCallTypeInbound")
        }
    }
    
    func UpdateLabelPhoneNo() ->Void
    {
        mLabelRecentPhoneNo.text = m_vRowData!.GetPhoneNo()
    }
    
    func UpdateLabelDateTime() ->Void
    {
        let nDateTime: Int = m_vRowData!.GetDateTime()
        
        let pDate = NSDate(timeIntervalSince1970: TimeInterval(nDateTime))
        
        let dateFormat: DateFormatter = DateFormatter()
        
        dateFormat.doesRelativeDateFormatting = true
        dateFormat.dateStyle = .short
        
        let sDateString: String = dateFormat.string(from: pDate as Date)
        
        if(sDateString.caseInsensitiveCompare("Today") != ComparisonResult.orderedSame && sDateString.caseInsensitiveCompare("Yesterday") != ComparisonResult.orderedSame)
        {
            dateFormat.doesRelativeDateFormatting = false
            dateFormat.dateFormat = "dd-MMM-YYYY"
        }
        
        let sDate: String = dateFormat.string(from: pDate as Date)
        mLabelRecentDate.text = sDate
        
        dateFormat.dateFormat = "hh:mm a"
        let sTime: String = dateFormat.string(from: pDate as Date)
        mLabelRecentTime.text = sTime
        
    }
    
    func UpdateLabelDuration() ->Void
    {
        let nDuration: Int = m_vRowData!.GetDuration()
        
        let pHour: String
        let pMinutes: String
        let pSeconds: String
        
        //nDuration = 7422;
        
        let nHours: Int = nDuration/3600
        
        if nHours <= 9
        {
            pHour = NSString(format: "0%llu", nHours) as String
        }
        else
        {
            pHour = NSString(format: "0%llu", nHours) as String
        }
        
        ///////////////////
        
        let nMinutes: Int = (nDuration%3600)/60
        
        if nMinutes <= 9
        {
            pMinutes = NSString(format: "0%llu", nMinutes) as String
        }
        else
        {
            pMinutes = NSString(format: "0%llu", nMinutes) as String
        }
        
        ///////////////////
        
        let nSeconds: Int = ((nDuration%3600)%60)
        
        if nSeconds <= 9
        {
            pSeconds = NSString(format: "0%llu", nSeconds) as String
        }
        else
        {
            pSeconds = NSString(format: "0%llu", nSeconds) as String
        }
        
        ///////////////////
        
        let sTime: String = NSString(format: "%@:%@:%@", pHour, pMinutes, pSeconds) as String
        mLabelRecentDuration.text = sTime
    }
}
