
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cRecentSectionData: NSObject
{
    let m_nDayNo: Int
    var mvRowList: [Any]?
    
    init(nDayNo: Int)
    {
        m_nDayNo = nDayNo
        mvRowList = [Any]()
        super.init()
    }
    
    deinit
    {
        mvRowList?.removeAll()
        mvRowList = nil
    }
    
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
    
    func GetDayNo() ->Int
    {
        return m_nDayNo
    }
     
    func GetTitle() ->String
    {
        let nDateTime: Int = m_nDayNo * 86400
        
        let vDate = Date(timeIntervalSince1970: TimeInterval(nDateTime))
        
        let dateformat: DateFormatter =  DateFormatter()
        
        dateformat.doesRelativeDateFormatting = true
        dateformat.dateStyle = .short
        
        let sDateString: String = dateformat.string(from: vDate)
        
        if(sDateString.caseInsensitiveCompare("Today") != ComparisonResult.orderedSame && sDateString.caseInsensitiveCompare("Yesterday") != ComparisonResult.orderedSame)
        {
            dateformat.doesRelativeDateFormatting = false
            dateformat.dateFormat = "dd-MMM-YYYY"
        }
        
        let sDate: String = dateformat.string(from: vDate)
        return sDate
    }
    
//////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
    
    func AddRow(nRecordId: Int, bOutboundCallType: Bool, sName: String, sPhoneNo: String, nStartTime: Int, nEndTime: Int, nDuration: Int, nHistoryTypeId: Int) ->Int
    {
        let pData: cRecentRowData = cRecentRowData()
        pData.SetCallInfo(nRecordId: nRecordId, bOutboundCallType: bOutboundCallType, sName: sName, sPhoneNo: sPhoneNo, nStartTime: nStartTime, nEndTime: nEndTime, nDuration: nDuration, nHistoryTypeId: nHistoryTypeId)
        
        mvRowList?.insert(pData, at: 0)
        let nRowNo = 0
        
        return nRowNo
    }
    
    func DeleteRow(nRowNo: Int) ->Void
    {
        if (nRowNo >= mvRowList!.count)
        {
            return
        }
        
        mvRowList?.remove(at: nRowNo)
    }
    
    func GetRowData(nRowNo: Int) ->cRecentRowData?
    {
        if (nRowNo >= mvRowList!.count)
        {
            return nil
        }
        
        return mvRowList?[nRowNo] as? cRecentRowData
    }
    
    func GetRowCount() ->Int
    {
        return mvRowList!.count
    }
}
