
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var mvRecentTableView: cRecentTableView! = nil
var m_nRecentMissedCount: Int = 0

class cRecentTableView: UITableViewController
{
    var SECTION_TOTAL_COUNT        = 1
    var CALL_HISTORY_TYPE_MISSED   = 2
    
    @IBOutlet var mClearBarBtn: UIBarButtonItem!
    @IBOutlet var mEditBarBtn: UIBarButtonItem!
    @IBOutlet var mDoneBarBtn: UIBarButtonItem!
    
    var m_bDidAppear: Bool = false;
    var m_bEditingActivated: Bool = false
    
    var mvTableData: [Any]?    
    
    override func viewDidLoad()
    {
        m_bDidAppear = false
        m_bEditingActivated = false
        
        super.viewDidLoad()
        
    }
    
    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    func LoadCallHistoryAll() ->Void
    {
        let vStoreDB: cStoreRecents = cStoreRecents()
        
        let vInfoAll: [Any] = vStoreDB.GetCallHistoryAll()
        
        for nCount in 0..<vInfoAll.count
        {
            let pData: cStoreDataRecents? = vInfoAll[nCount] as? cStoreDataRecents
            cRecentTableView.PostAddCallHistory(pData!.m_nRecordId, pData!.m_bOutboundCallType, pData!.m_sName, pData!.m_sPhoneNo, pData!.m_nStartTime, pData!.m_nEndTime, pData!.m_nDuration, pData!.m_nDayNo, pData!.m_nHistoryTypeId)
        }
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewDidAppear(_ animated: Bool)
    {
        m_bDidAppear = true
        super.viewDidAppear(animated)
    }
    
    override func viewWillAppear(_ animated: Bool)
    {
        mvRecentTableView = self
        m_bDidAppear = false
        
        self.ActivateEditingMode(bEnable: false, bAnimated: false)
        mvTableData = [Any]()
        
        self.LoadCallHistoryAll()
        
        cRecentTableView.SetMissedCount(nValue: 0)
        self.tableView.reloadData()
        
        super.viewWillAppear(animated)
    }
    
    override func viewWillDisappear(_ animated: Bool)
    {
        mvRecentTableView = nil
        
        mvTableData?.removeAll()
        mvTableData = nil
        
        super.viewWillDisappear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostAddCallHistory(_ nRecordId: Int, _ bOutboundCallType: Bool, _ sName: String, _ sPhoneNo: String, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void
    {
        if !cMainTabBarController.IsRecentSelected() && bOutboundCallType == false && nHistoryTypeId == cVaxUserAgentInfo.VAX_CALL_HISTORY_TYPE_MISSED
        {
            cRecentTableView.SetMissedCount(nValue: -1)
        }
        
        if mvRecentTableView == nil
        {
            return
        }
        
        mvRecentTableView.AddCallHistory(nRecordId, bOutboundCallType, sName, sPhoneNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId)
    }
    
    func AddCallHistory(_ nRecordId: Int, _ bOutboundCallType: Bool, _ sName: String, _ sPhoneNo: String, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void
    {
        let nSectionCountOld: Int = self.GetSectionCount()
        
        let nSectionNo: Int = self.AddSection(nDayNo: nDayNo)!
        let nSectionCountNew: Int = self.GetSectionCount()
        
        let vSection: cRecentSectionData = mvTableData?[nSectionNo] as! cRecentSectionData
        let nRowNo: Int = vSection.AddRow(nRecordId: nRecordId, bOutboundCallType: bOutboundCallType, sName: sName, sPhoneNo: sPhoneNo, nStartTime: nStartTime, nEndTime: nEndTime, nDuration: nDuration, nHistoryTypeId: nHistoryTypeId)
        
        if m_bDidAppear
        {
            self.tableView.beginUpdates()
        
            let indexPath = IndexPath(row: nRowNo, section: nSectionNo)
            tableView.insertRows(at: [indexPath], with: .automatic)
        
            if nSectionCountOld != nSectionCountNew
            {
                self.tableView.insertSections(NSIndexSet(index: nSectionNo) as IndexSet, with: .fade)
            }
        
            self.tableView.endUpdates()
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func AddSection(nDayNo: Int) ->Int?
    {
        var vSection: cRecentSectionData? = nil
        
        
        if let mvTableData = mvTableData
        {
            for nSectionNo in 0..<mvTableData.count
            {
                vSection = mvTableData[nSectionNo] as? cRecentSectionData
                let nLastDayNo: Int = vSection!.GetDayNo()
                
                if nLastDayNo == nDayNo
                {
                    return nSectionNo
                }
            }
        }
        
        vSection = cRecentSectionData(nDayNo: nDayNo)
        mvTableData?.insert(vSection!, at: 0)
        
        let nSectionNo = 0
        return nSectionNo
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func GetSectionCount() ->Int
    {
        return mvTableData!.count
    }
    
    func GetRowCount(nSectionNo: Int) ->Int
    {
        if nSectionNo >= self.GetSectionCount()
        {
            return 0
        }
        
        let vSection: cRecentSectionData = mvTableData?[nSectionNo] as! cRecentSectionData
        return vSection.GetRowCount()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func GetSectionTitle(nSectionNo: Int) ->String
    {
        if nSectionNo >= self.GetSectionCount()
        {
            return ""
        }
        
        let vSection: cRecentSectionData = mvTableData?[nSectionNo] as! cRecentSectionData
        return vSection.GetTitle()
    }
    
    func GetRowData(nSectionNo: Int, nRowNo: Int) -> cRecentRowData?
    {
        if nSectionNo >= self.GetSectionCount()
        {
            return nil
        }
        
        let vSection: cRecentSectionData = mvTableData?[nSectionNo] as! cRecentSectionData
        return vSection.GetRowData(nRowNo: nRowNo)
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func DeleteRow(nSectionNo: Int, nRowNo: Int) ->Void
    {
        if nSectionNo >= self.GetSectionCount()
        {
            return
        }
        
        let vRowData: cRecentRowData? = self.GetRowData(nSectionNo: nSectionNo, nRowNo: nRowNo)!
        
        if vRowData != nil
        {
            let nRecordId: Int = vRowData!.GetRecordId()
            
            let vStoreDB: cStoreRecents = cStoreRecents()
            vStoreDB.RemoveCallHistory(nRecordId)
        }
        
        let vSection: cRecentSectionData = mvTableData?[nSectionNo] as! cRecentSectionData
        vSection.DeleteRow(nRowNo: nRowNo)
        
        self.tableView.beginUpdates()
        
        let indexPath = IndexPath(row: nRowNo, section: nSectionNo)
        tableView.deleteRows(at: [indexPath], with: .fade)
        
        if vSection.GetRowCount() == 0
        {
            mvTableData?.remove(at: nSectionNo)
            tableView.deleteSections(NSIndexSet(index: nSectionNo) as IndexSet, with: .fade)
        }
        
        self.tableView.endUpdates()
    }
    
    func DeleteAll() ->Void
    {
        let vStoreDB: cStoreRecents = cStoreRecents()
        vStoreDB.RemoveCallHistoryAll()
        
        mvTableData?.removeAll()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        self.UpdateEditBarButton()
        return mvRecentTableView!.GetSectionCount()
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        self.UpdateEditBarButton()
        return mvRecentTableView!.GetRowCount(nSectionNo: section)
    }
    
    override func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String?
    {
        return mvRecentTableView!.GetSectionTitle(nSectionNo: section)
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell
    {
        let vRowData: cRecentRowData = self.GetRowData(nSectionNo: indexPath.section, nRowNo: indexPath.row)!
        let vRowView: cRecentRowView = tableView.dequeueReusableCell(withIdentifier: "RecentCellId", for: indexPath) as! cRecentRowView
        
        vRowView.SetRowData(vRowData: vRowData)
        return vRowView
    }
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let vRowData: cRecentRowData = self.GetRowData(nSectionNo: indexPath.section, nRowNo: indexPath.row)!
        
        UIView.beginAnimations(nil, context: nil)
        UIView.setAnimationDuration(0.65)
        UIView.setAnimationTransition(.flipFromLeft, for: self.view.window!, cache: true)
        
        cMainTabBarController.SwitchToVideoTab(sPhoneNo: vRowData.GetPhoneNo())
        UIView.commitAnimations()
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickClear(_ sender: Any)
    {
        self.DeleteAll()
        self.tableView.reloadData()
    }
   
    @IBAction func OnClickEdit(_ sender: Any)
    {
        self.ActivateEditingMode(bEnable: m_bEditingActivated, bAnimated: false)
        self.UpdateEditBarButton()
    }
    
    override func tableView(_ tableView: UITableView, canEditRowAt indexPath: IndexPath) -> Bool
    {
        return true
    }
    
    func UpdateEditBarButton() ->Void
    {
        if self.GetSectionCount() == 0
        {
            self.navigationItem.leftBarButtonItem = nil
            self.navigationItem.rightBarButtonItem = nil
            
            self.ActivateEditingMode(bEnable: false, bAnimated: false)
        }
        else if m_bEditingActivated
        {
            self.navigationItem.leftBarButtonItem = nil
            self.navigationItem.leftBarButtonItem = mDoneBarBtn
            self.navigationItem.rightBarButtonItem = mClearBarBtn
        }
        else
        {
            self.navigationItem.leftBarButtonItem = nil
            self.navigationItem.leftBarButtonItem = mEditBarBtn
            self.navigationItem.rightBarButtonItem = mClearBarBtn
        }
    }
    
    override func tableView(_ tableView: UITableView, commit editingStyle: UITableViewCell.EditingStyle, forRowAt indexPath: IndexPath)
    {
        if editingStyle == .delete
        {
            self.DeleteRow(nSectionNo: indexPath.section, nRowNo: indexPath.row)
        }
        else if editingStyle == .insert
        {
            
        }
    }
    
    func ActivateEditingMode(bEnable: Bool, bAnimated: Bool)
    {
        m_bEditingActivated = bEnable
        self.setEditing(bEnable, animated: bAnimated)
    }
    
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////
    
    static func LoadMissedCount() ->Void
    {
        m_nRecentMissedCount = cRecentTableView.ReadMissedCount()
        cMainTabBarController.SetRecentBadgeCount(nValue: m_nRecentMissedCount)
    }
    
    static func SetMissedCount(nValue: Int) ->Void
    {
        if nValue == 0
        {
            m_nRecentMissedCount = 0
        }
        else
        {
            m_nRecentMissedCount += 1
        }
        
        cMainTabBarController.SetRecentBadgeCount(nValue: m_nRecentMissedCount)
        cRecentTableView.StoreMissedCount()
    }
    
    static func StoreMissedCount() ->Void
    {
        let vRefs: UserDefaults? = UserDefaults.standard
        
        vRefs?.set(m_nRecentMissedCount, forKey: "m_nRecentMissedCount")
        vRefs?.synchronize()
    }
    
    static func ReadMissedCount() ->Int
    {
        let vRefs: UserDefaults? = UserDefaults.standard
        
        let vValue = vRefs?.object(forKey: "m_nRecentMissedCount") as? NSNumber
        
        if vValue == nil
        {
            return 0
        }
        return Int(truncating: vValue!)
        
    }    
    
///////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////

}
