 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.
 
import UIKit

class cSettingDigitDTMFTableView: UITableViewController
{
    
    let SECTION_TOTAL_COUNT          = 1
    let ROW_TOTAL_COUNT              = 4
    
    let SECTION_ID_DIGIT_DTMF        = 0
    
    var m_nSelectedTypeDigitDTMF: Int = cVaxUserAgentInfo.VAX_DTMF_TYPE_RFC2833


    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////    
    
    static func ResetData() ->Void
    {
        let vStore: cStoreDigitDTMF = cStoreDigitDTMF()
        vStore.ResetData()
        
        cSettingDigitDTMFTableView.PostInitialize()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize() ->Void
    {
        let vStore: cStoreDigitDTMF = cStoreDigitDTMF()
        
        let nTypeDigitDTMF: Int = vStore.GetDigitDTMF()
        
        cVaxPhoneDTMF.GetSelf().ForceDigitDTMF(nTypeDigitDTMF, true)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreDigitDTMF = cStoreDigitDTMF()
        m_nSelectedTypeDigitDTMF = vStore.GetDigitDTMF()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        var bSelected: Bool = false
        
        if m_nSelectedTypeDigitDTMF == indexPath.row
        {
            bSelected = true
        }
        
        var vRowView: cSettingDigitDTMFRowView? = nil
        
         if indexPath.row == cVaxUserAgentInfo.VAX_DTMF_TYPE_AUTO && indexPath.section == SECTION_ID_DIGIT_DTMF
         {
             vRowView = tableView.dequeueReusableCell(withIdentifier: "AutoCellId", for: indexPath) as? cSettingDigitDTMFRowView
         }
         
        else if indexPath.row == cVaxUserAgentInfo.VAX_DTMF_TYPE_RFC2833 && indexPath.section == SECTION_ID_DIGIT_DTMF
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "RFC2833CellId", for: indexPath) as? cSettingDigitDTMFRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_DTMF_TYPE_SIP_INFO && indexPath.section == SECTION_ID_DIGIT_DTMF
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "SIPINFOCellId", for: indexPath) as? cSettingDigitDTMFRowView
        }
            
        else if(indexPath.row == cVaxUserAgentInfo.VAX_DTMF_TYPE_INBAND && indexPath.section == SECTION_ID_DIGIT_DTMF)
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "InbandCellId", for: indexPath) as? cSettingDigitDTMFRowView
        }

        
        vRowView!.SetSelected(bSelected: bSelected)
        return vRowView!
    }
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let nTypeDigitDTMF: Int = indexPath.row
        m_nSelectedTypeDigitDTMF = nTypeDigitDTMF
        
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cSettingDigitDTMFRowView? = self.tableView.cellForRow(at: IndexPath(row: nRowNo, section: SECTION_ID_DIGIT_DTMF)) as? cSettingDigitDTMFRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
        let vRowView: cSettingDigitDTMFRowView? = self.tableView.cellForRow(at: indexPath) as? cSettingDigitDTMFRowView
        
        if vRowView != nil
        {
            vRowView?.SetSelected(bSelected: true)
        }
        
        cVaxPhoneDTMF.GetSelf().ForceDigitDTMF(nTypeDigitDTMF, true)
        
        let vStore: cStoreDigitDTMF = cStoreDigitDTMF()
        vStore.SetDigitDTMF(nTypeDigitDTMF)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
