 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.
 
import UIKit

class cSettingMicSpkTableView: UITableViewController
{
    let SECTION_TOTAL_COUNT                = 2
    
    let SECTION_SPK_ROW_COUNT              = 1
    let SECTION_MIC_ROW_COUNT              = 2
        
    let SECTION_ID_SPK                     = 0
    let SECTION_ID_MIC                     = 1
        
    let ROW_ID_AUTO_GAIN_SPK               = 0
    let ROW_ID_AUTO_GAIN_MIC               = 0
    let ROW_ID_VOLUME_BOOST_MIC            = 1
                
    var mbAutoGainSpk: Bool = false
    var mbAutoGainMic: Bool = false
    var mbVolumeBoostMic: Bool = false
        
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetData() ->Void
    {
        let vStore: cStoreSpKMic = cStoreSpKMic()
        vStore.ResetData()
        
        cSettingMicSpkTableView.PostInitialize()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize() ->Void
    {
        let vStore: cStoreSpKMic = cStoreSpKMic()
        
        ///////////////////////////////////////////////////////////////////////////////////
        
        var bEnable: Bool = vStore.GetAutoGainSpk()
        cVaxPhoneMicSpk.GetSelf().AutoGainSpk(bEnable)
        
        bEnable = vStore.GetAutoGainMic()
        cVaxPhoneMicSpk.GetSelf().AutoGainMic(bEnable)
        
        //////////////////////////////////////////////////////////////////////////////////
               
        bEnable = vStore.GetVolumeBoostMic()
        cVaxPhoneMicSpk.GetSelf().SetVolumeBoostMic(bEnable)
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreSpKMic = cStoreSpKMic()
        
        mbAutoGainSpk = vStore.GetAutoGainSpk()
        
        mbAutoGainMic = vStore.GetAutoGainMic()
        mbVolumeBoostMic = vStore.GetVolumeBoostMic()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        if(section == SECTION_ID_SPK)
        {
            return SECTION_SPK_ROW_COUNT
        }
           
        return SECTION_MIC_ROW_COUNT;
    }
    
    override func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String?
    {
        if section == SECTION_ID_SPK
        {
            return "Speaker"
        }
        
        return "Microphone"
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        if indexPath.row == ROW_ID_AUTO_GAIN_SPK && indexPath.section == SECTION_ID_SPK
        {
            let vRowView: cSettingMicSpkRowView  = tableView.dequeueReusableCell(withIdentifier: "SpeakerAutoGainCellId", for: indexPath) as! cSettingMicSpkRowView
            
            vRowView.UpdateView(bEnable: mbAutoGainSpk)
            return vRowView;
        }
        
        if indexPath.row == ROW_ID_AUTO_GAIN_MIC && indexPath.section == SECTION_ID_MIC
        {
            let vRowView: cSettingMicSpkRowView  = tableView.dequeueReusableCell(withIdentifier: "MicrophoneAutoGainCellId", for: indexPath) as! cSettingMicSpkRowView

            vRowView.UpdateView(bEnable: mbAutoGainMic)
            return vRowView;
        }
       
        let vRowView: cSettingMicSpkRowView  = tableView.dequeueReusableCell(withIdentifier: "MicrophoneVolumeBoostCellId", for: indexPath) as! cSettingMicSpkRowView

        vRowView.UpdateView(bEnable: mbVolumeBoostMic)
        return vRowView;
    }
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    @IBAction func OnClickAutoGainSpk(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        let bAutoGainSpk: Bool = vCheckBox.GetState()
        
        cVaxPhoneMicSpk.GetSelf().AutoGainSpk(bAutoGainSpk)
        
        let vStore: cStoreSpKMic = cStoreSpKMic()
        vStore.SetAutoGainSpk(bAutoGainSpk)
    }
       
    @IBAction func OnClickAutoGainMic(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        let bAutoGainMic: Bool = vCheckBox.GetState()
        
        cVaxPhoneMicSpk.GetSelf().AutoGainMic(bAutoGainMic)
        
        let vStore: cStoreSpKMic = cStoreSpKMic()
        vStore.SetAutoGainMic(bAutoGainMic)
    }

    
    @IBAction func OnClickVolBoostMic(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        let bVolumeBoostMic: Bool = vCheckBox.GetState()
        
        cVaxPhoneMicSpk.GetSelf().SetVolumeBoostMic(bVolumeBoostMic)
        
        let vStore: cStoreSpKMic = cStoreSpKMic()
        vStore.SetVolumeBoostMic(bVolumeBoostMic)
    }

    //////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////

}
