 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingNetworkTableView: UITableViewController
{
    let SECTION_TOTAL_COUNT                 = 1
    let SECTION_ROW_COUNT_SIP               = 2
    
    let ROW_ID_LOCAL_PORT_SIP               = 0
    let ROW_ID_CHOOSE_RANDOM_SIP            = 1
            
    var mnLocalPortSIP: Int = 0
    var mbRandomlyPortSIP: Bool = true

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetData() ->Void
    {
        let vStore: cStoreNetwork = cStoreNetwork()
        vStore.ResetData()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    static func GetNetworkPortSIP() ->Int
    {
        let vStore: cStoreNetwork = cStoreNetwork()
         return Int(vStore.GetLocalPortSIP())
    }
    
    static func IsRandomPortSIP() ->Bool
    {
        let vStore: cStoreNetwork = cStoreNetwork()
        return (vStore.GetChooseRandomlySIP())
    }
        
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreNetwork = cStoreNetwork()
        
        mnLocalPortSIP = vStore.GetLocalPortSIP()
        mbRandomlyPortSIP = vStore.GetChooseRandomlySIP()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return SECTION_ROW_COUNT_SIP
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        if indexPath.row == ROW_ID_LOCAL_PORT_SIP
        {
            let vRowView: cSettingNetworkRowView = tableView.dequeueReusableCell(withIdentifier: "LocalPortSIPCellId", for: indexPath) as! cSettingNetworkRowView
            
            vRowView.UpdateTextField(sText: String (mnLocalPortSIP))
            return vRowView
        }
        
         let vRowView: cSettingNetworkRowView  = tableView.dequeueReusableCell(withIdentifier: "ChooseRandomlySIPCellId", for: indexPath) as! cSettingNetworkRowView
         
         vRowView.UpdateCheckBox(bEnable: mbRandomlyPortSIP)
         return vRowView
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnEditingTextFieldPortSIP(_ sender: Any)
    {
        let sLocalPortSIP: String? = (sender as? cCustomTextField)?.text
        
        if sLocalPortSIP == nil || (sLocalPortSIP?.count) == 0
        {
            return
        }
        
        let vStore: cStoreNetwork = cStoreNetwork()
        vStore.SetLocalPortSIP(Int (sLocalPortSIP!)!)
    }
            
    @IBAction func OnClickCheckBoxRandomSIP(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        
        let vStore: cStoreNetwork = cStoreNetwork()
        vStore.SetChooseRandomlySIP(vCheckBox.GetState())
    }
}
