 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingRingToneTableView: UITableViewController
{
    
    let  SECTION_TOTAL_COUNT             = 1
    let  SECTION_ID_RINGTONE             = 0
    let  ROW_TOTAL_COUNT                 = 5
    
    let  ROW_ID_RING_TONE_GROOVY         = cVaxUserAgentInfo.VAX_RING_TONE_GROOVY
    let  ROW_ID_RING_TONE_DIGITAL_RAIN   = cVaxUserAgentInfo.VAX_RING_TONE_DIGITAL_RAIN
    let  ROW_ID_RING_TONE_MAGICAL        = cVaxUserAgentInfo.VAX_RING_TONE_MAGICAL
    let  ROW_ID_RING_TONE_DEJA_VU        = cVaxUserAgentInfo.VAX_RING_TONE_DEJA_VU
    let  ROW_ID_RING_TONE_OFFICE_PHONE   = cVaxUserAgentInfo.VAX_RING_TONE_OFFICE_PHONE
    
    var m_nSelectedRingToneId: Int = cVaxUserAgentInfo.VAX_RING_TONE_DIGITAL_RAIN

    override func viewDidLoad()
    {
        super.viewDidLoad()

    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetData() ->Void
    {
        let vStore: cStoreRingtones = cStoreRingtones()
        vStore.ResetData()
        
        PostInitialize()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize() ->Void
    {
        let vStore: cStoreRingtones = cStoreRingtones()
        
        let nToneId = vStore.GetRingtone()
        cVaxPhoneRing.GetSelf().SetRingTone(nToneId)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreRingtones = cStoreRingtones()
        m_nSelectedRingToneId = vStore.GetRingtone()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        var bSelected: Bool = false;
        
        if m_nSelectedRingToneId == indexPath.row
        {
            bSelected = true
        }
        
        var vRowView: cSettingRingToneRowView? = nil;
        
        if indexPath.row == cVaxUserAgentInfo.VAX_RING_TONE_GROOVY && indexPath.section == 0
        {
            vRowView  = tableView.dequeueReusableCell(withIdentifier: "GroovyCellId", for: indexPath) as? cSettingRingToneRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_RING_TONE_DIGITAL_RAIN && indexPath.section == 0
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "DigitalRainCellId", for: indexPath) as? cSettingRingToneRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_RING_TONE_MAGICAL && indexPath.section == 0
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "MagicalCellId", for: indexPath) as? cSettingRingToneRowView
        }
            
        else if(indexPath.row == cVaxUserAgentInfo.VAX_RING_TONE_DEJA_VU && indexPath.section == 0)
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "DejaVuCellId", for: indexPath) as? cSettingRingToneRowView
        }
        else
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "OfficePhoneCellId", for: indexPath) as? cSettingRingToneRowView
        }
        
        vRowView?.SetSelected(bSelected: bSelected)
        return vRowView!
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let nRingToneId = indexPath.row
        m_nSelectedRingToneId = nRingToneId
        
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cSettingRingToneRowView? = self.tableView.cellForRow(at: IndexPath(row: nRowNo, section: SECTION_ID_RINGTONE)) as? cSettingRingToneRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
            let vRowView: cSettingRingToneRowView? = self.tableView.cellForRow(at: indexPath) as? cSettingRingToneRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: true)
            }
            
            cVaxPhoneRing.GetSelf().SetRingTone(nRingToneId)
            
            let vStore: cStoreRingtones = cStoreRingtones()
            vStore.SetRingtone(nRingToneId)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
