
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingVideoBitrateTableView: UITableViewController
{
    let  SECTION_TOTAL_COUNT            = 1
    let  ROW_TOTAL_COUNT                = 5
    
    let  SECTION_ID_BITRATE_QUALITY     = 0
    
    var maBitrateName: [Any] = []
    var mnSelectedBitrateTypeId: Int = cVaxUserAgentInfo.VAX_VIDEO_QUALITY_MEDIUM

    override func viewDidLoad()
    {
        super.viewDidLoad()
    
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize()
    {
        let vStore: cStoreVideoBitrate = cStoreVideoBitrate()
        let nBitrateTypeId = vStore.GetVideoBitrate()
        
        cVaxPhoneVideo.GetSelf().ApplyVideoBitrate(Int(nBitrateTypeId))
    }
    
    static func ResetData() ->Void
    {
        let vStore: cStoreVideoBitrate = cStoreVideoBitrate()
        vStore.ResetDate()
        
        cSettingVideoBitrateTableView.PostInitialize()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        maBitrateName = ["Low", "Normal", "Medium", "High", "Maximum"]
        
        let vStore: cStoreVideoBitrate = cStoreVideoBitrate()
        mnSelectedBitrateTypeId = vStore.GetVideoBitrate()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
        
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
     {
        var bSelected: Bool = false
        
        if mnSelectedBitrateTypeId == indexPath.row
        {
            bSelected = true
        }
        
        let vRowView: cSettingVideoBitrateRowView  = tableView.dequeueReusableCell(withIdentifier: "VideoBitrateCellId", for: indexPath) as! cSettingVideoBitrateRowView
        
        vRowView.SetNameType(sName: maBitrateName[indexPath.row] as! String)
        vRowView.SetSelected(bSelected: bSelected)
        
        return vRowView;
    }
    
    
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let nBitrateTypeId = indexPath.row
        mnSelectedBitrateTypeId = nBitrateTypeId
        
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cSettingVideoBitrateRowView? = self.tableView.cellForRow(at: IndexPath(row: nRowNo, section :SECTION_ID_BITRATE_QUALITY)) as? cSettingVideoBitrateRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
        let vRowView: cSettingVideoBitrateRowView? = self.tableView.cellForRow(at: indexPath) as? cSettingVideoBitrateRowView
        
        if vRowView != nil
        {
            vRowView?.SetSelected(bSelected: true)
        }
        
        let vStore: cStoreVideoBitrate = cStoreVideoBitrate()
        vStore.SetVideoBitrate(nBitrateTypeId)
        
        cVaxPhoneVideo.GetSelf().ApplyVideoBitrate(nBitrateTypeId)
    }
}
