 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingVideoQualityTableView: UITableViewController
{
    let  SECTION_TOTAL_COUNT        = 1
    let  ROW_TOTAL_COUNT            = 5
    
    let  SECTION_ID_VIDEO_QUALITY   =  0
    
    var maQualityName: [Any] = []
    var mnSelectedQualityTypeId: Int = cVaxUserAgentInfo.VAX_VIDEO_QUALITY_MEDIUM

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetData() ->Void
    {
        let vStore: cStoreVideoQuality = cStoreVideoQuality()
        vStore.ResetData()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        maQualityName = ["Low", "Normal", "Medium", "High", "Maximum"]
        
        let vStore: cStoreVideoQuality = cStoreVideoQuality()
        mnSelectedQualityTypeId = vStore.GetVideoQuality()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func GetVideoQuality() ->Int
    {
        let vStore: cStoreVideoQuality = cStoreVideoQuality()
        return Int(vStore.GetVideoQuality())
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell 
    {
        var bSelected: Bool = false
        
        if mnSelectedQualityTypeId == indexPath.row
        {
            bSelected = true
        }
        
        let vRowView: cSettingVideoQualityRowView = tableView.dequeueReusableCell(withIdentifier: "VideoQualityCellId", for: indexPath) as! cSettingVideoQualityRowView
        
        vRowView.SetNameType(sName: maQualityName[indexPath.row] as! String)
        vRowView.SetSelected(bSelected: bSelected)
        
        return vRowView
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let nQualityTypeId = indexPath.row
        mnSelectedQualityTypeId = nQualityTypeId
        
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cSettingVideoQualityRowView? = self.tableView.cellForRow(at: IndexPath(row: nRowNo, section:SECTION_ID_VIDEO_QUALITY)) as? cSettingVideoQualityRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
        let vRowView: cSettingVideoQualityRowView? = self.tableView.cellForRow(at: indexPath) as? cSettingVideoQualityRowView
        
        if vRowView != nil
        {
            vRowView?.SetSelected(bSelected: true)
        }
        
        let vStore: cStoreVideoQuality = cStoreVideoQuality()
        vStore.SetVideoQuality(nQualityTypeId)
        
        cVaxPhoneVideo.GetSelf().ApplyVideoQuality()
    }
}
