 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingVoiceChangerTableView: UITableViewController
{
    let SECTION_TOTAL_COUNT            = 1
    let ROW_TOTAL_COUNT                = 5
    
    let SECTION_ID_VOICE_CHANGER       = 0

    var m_nSelectedVoiceChangerId: Int = cVaxUserAgentInfo.VAX_VOICE_CHANGER_HELIUM_INHALED

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func ResetData() ->Void
    {
        let vStore: cStoreVoiceChanger = cStoreVoiceChanger()
        vStore.ResetData()
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func GetSelectedPitchNo() ->Int
    {
        let vStore: cStoreVoiceChanger = cStoreVoiceChanger()
        let nVoiceChangerId: Int = vStore.GetVoiceChanger()
        
        let aVoicePitch = [cVaxUserAgentInfo.VAX_VOICE_PITCH_GRANDPA_DRUNK, cVaxUserAgentInfo.VAX_VOICE_PITCH_TEEN_BOY, cVaxUserAgentInfo.VAX_VOICE_PITCH_GRANDPA_DRUNK, cVaxUserAgentInfo.VAX_VOICE_PITCH_HELIUM_INHALED, cVaxUserAgentInfo.VAX_VOICE_PITCH_CHIPMUNK]
        return Int(aVoicePitch[nVoiceChangerId])
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreVoiceChanger = cStoreVoiceChanger()
        m_nSelectedVoiceChangerId = vStore.GetVoiceChanger()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    // MARK: - Table view data source

    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return ROW_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) ->UITableViewCell
     {
        var bSelected: Bool = false
        
        if m_nSelectedVoiceChangerId == indexPath.row
        {
            bSelected = true;
        }
        
        var vRowView: cSettingVoiceChangerRowView? = nil;
        
        if indexPath.row == cVaxUserAgentInfo.VAX_VOICE_CHANGER_GRANDPA_DRUNK && indexPath.section == SECTION_ID_VOICE_CHANGER
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "GrandpadrunkCellId", for: indexPath) as? cSettingVoiceChangerRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_VOICE_CHANGER_TEEN_BOY && indexPath.section == SECTION_ID_VOICE_CHANGER
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "TeenboyCellId", for: indexPath) as? cSettingVoiceChangerRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_VOICE_CHANGER_HOUSE_HOLD_REBOT && indexPath.section == SECTION_ID_VOICE_CHANGER
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "HouseholdrobotCellId", for: indexPath) as? cSettingVoiceChangerRowView
        }
            
        else if indexPath.row == cVaxUserAgentInfo.VAX_VOICE_CHANGER_HELIUM_INHALED && indexPath.section == SECTION_ID_VOICE_CHANGER
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "HeliuminhaledCellId", for: indexPath) as? cSettingVoiceChangerRowView
        }
        else
        {
            vRowView = tableView.dequeueReusableCell(withIdentifier: "ChipmunkCellId", for: indexPath) as? cSettingVoiceChangerRowView
        }
        
        vRowView?.SetSelected(bSelected: bSelected)
        return vRowView!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let nVoiceChangerId = indexPath.row
        m_nSelectedVoiceChangerId = nVoiceChangerId
        
        for nRowNo in 0..<ROW_TOTAL_COUNT
        {
            let vRowView: cSettingVoiceChangerRowView? = self.tableView.cellForRow(at: IndexPath(row: nRowNo, section:SECTION_ID_VOICE_CHANGER)) as? cSettingVoiceChangerRowView
            
            if vRowView != nil
            {
                vRowView?.SetSelected(bSelected: false)
            }
        }
        
        let vRowView: cSettingVoiceChangerRowView? = self.tableView.cellForRow(at: indexPath) as? cSettingVoiceChangerRowView
        
        if vRowView != nil
        {
            vRowView?.SetSelected(bSelected: true)
        }
        
        let vStore: cStoreVoiceChanger = cStoreVoiceChanger()
        vStore.SetVoiceChanger(nVoiceChangerId)
        
        if cVaxPhoneVoiceChanger.GetSelf().IsVoiceChangerEnabled()
        {
            cVaxPhoneVoiceChanger.GetSelf().VoiceChangerEnabled(true)
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
}
