 
 //  Created by VaxSoft
 //  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cSettingsTableView: UITableViewController
{
    
    let SECTION_TOTAL_COUNT       = 4
          
    let SECTION_ID_VIDEO         = 0
    let SECTION_ID_VOICE         = 1
    let SECTION_ID_NETWORK       = 2
    let SECTION_ID_RESET_ALL     = 3
    
    let SECTION_VIDEO_ROWS       = 4
    let SECTION_VOICE_ROWS       = 3
    let SECTION_NETWORK_ROWS     = 3
    let SECTION_RESET_ALL_ROWS   = 1
    
    let ROW_ID_DIAGNOSTIC_LOG     = 1
    
    var mbDiagnosticLog: Bool = false

    override func viewDidLoad()
    {
        super.viewDidLoad()
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func PostInitialize() ->Void
    {
        let vStore: cStoreSettings = cStoreSettings()
                        
        let bDiagnosticLog: Bool = vStore.GetDiagnosticLog()
        cVaxPhoneLog.GetSelf().DiagnosticLog(bDiagnosticLog)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        let vStore: cStoreSettings = cStoreSettings()
        mbDiagnosticLog = vStore.GetDiagnosticLog()
        
        self.tableView.reloadData()
        super.viewWillAppear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func numberOfSections(in tableView: UITableView) -> Int
    {
        return SECTION_TOTAL_COUNT
    }

    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        if section == SECTION_ID_VIDEO
        {
            return SECTION_VIDEO_ROWS
        }
        
        if section == SECTION_ID_VOICE
        {
            return SECTION_VOICE_ROWS
        }
        
        if section == SECTION_ID_NETWORK
        {
            return SECTION_NETWORK_ROWS
        }
               
        return SECTION_RESET_ALL_ROWS
    }

    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell
     {
        if indexPath.row == 0 && indexPath.section == SECTION_ID_VIDEO
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "VideoBitrateCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 1 && indexPath.section == SECTION_ID_VIDEO
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "VideoQualityCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 2 && indexPath.section == SECTION_ID_VIDEO
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "VideoCodecCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 3 && indexPath.section == SECTION_ID_VIDEO
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "VoiceCodecCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 0 && indexPath.section == SECTION_ID_VOICE
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "MicSpkCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 1 && indexPath.section == SECTION_ID_VOICE
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "RingtoneCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 2 && indexPath.section == SECTION_ID_VOICE
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "VoiceChangerCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 0 && indexPath.section == SECTION_ID_NETWORK
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "NetworkCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
        
        if indexPath.row == 1 && indexPath.section == SECTION_ID_NETWORK
        {
            let vCell = tableView.dequeueReusableCell(withIdentifier: "DigitDTMFSettingsCellId", for: indexPath)
            vCell.accessoryView = cCustomCellAccessory()
            
            return vCell
        }
                        
        if indexPath.row == 2 && indexPath.section == SECTION_ID_NETWORK
        {
            let vRowView: cSettingRowView  = tableView.dequeueReusableCell(withIdentifier: "DiagnosticCellId", for: indexPath) as! cSettingRowView
            vRowView.UpdateDiagnosticLogView(bDiagnosticLog: mbDiagnosticLog)

            return vRowView
        }
        
        return tableView.dequeueReusableCell(withIdentifier: "ResetAllSettingsCellId", for: indexPath)
    }

//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

    func ShowResetAlert() ->Void
    {
        let MsgAlert = UIAlertController(title: "Reset Settings", message: "", preferredStyle: .alert)
        let ResetAction = UIAlertAction(title: "Reset All", style: .default, handler:
        {(_ action: UIAlertAction) -> Void in
            
            AppDelegate.ResetSettings()
            self.tableView.reloadData()
        })
        
        let CancelAction = UIAlertAction(title: "Cancel", style: .default, handler:
        {(_ action: UIAlertAction) -> Void in
            
        })
        
        ResetAction.setValue(UIColor.red, forKey: "titleTextColor")
        
        MsgAlert.addAction(ResetAction)
        MsgAlert.addAction(CancelAction)
    
        self.present(MsgAlert, animated: true, completion: nil)
    }

    @IBAction func OnClickResetSettings(_ sender: Any)
    {
        self.ShowResetAlert()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickDiagnosticLog(_ sender: Any)
    {
        let vCheckBox: cCustomCellCheckBox = sender as! cCustomCellCheckBox
        let bDiagnosticLog = vCheckBox.GetState()
        
        cVaxPhoneLog.GetSelf().DiagnosticLog(bDiagnosticLog)
        
        let vStore: cStoreSettings = cStoreSettings()
        vStore.SetDiagnosticLog(bDiagnosticLog)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickLogout(_ sender: Any)
    {
        cVaxPhoneSIP.GetSelf().DisconnectCall()
        cMainTabBarController.DismissMainTabBar()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////

}
