
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var mvDialPadView: cDialPadView! = nil
var mvDialPadStatusText: String! = ""
var mvDialPadPhoneNoText: String! = ""

class cDialPadView: UIViewController, cAddressBookViewDelegate
{
    @IBOutlet var mTextFieldDialNo: cCustomTextField!
    
    @IBOutlet var mDialCall: UIButton!
    @IBOutlet var mEndCall: UIButton!

    @IBOutlet var mHoldCall: UIButton!
    @IBOutlet var mUnHoldCall: UIButton!
    @IBOutlet var mContact: UIButton!
    
    var mContactsView: cAddressBookView!
    
    override func viewDidLoad()
    {
        super.viewDidLoad()

        mTextFieldDialNo.EnableKeyboardReturnKey()
        mContactsView = cAddressBookView(iDelegate: self)
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }

/////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillAppear(_ animated: Bool)
    {
        mvDialPadView = self
        
        mTextFieldDialNo.text = mvDialPadPhoneNoText
        
        self.ShowStatusMsg(sMsgText: mvDialPadStatusText!)
        self.UpdateButton()
        
        super.viewWillAppear(animated)
    }
    
    override func viewDidAppear(_ animated: Bool)
    {
        super.viewDidAppear(animated)
    }
    
    override func viewWillDisappear(_ animated: Bool)
    {
        mvDialPadView = nil
        super.viewWillDisappear(animated)
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnStartedAPP() ->Void
    {
        mvDialPadStatusText = ""
        mvDialPadPhoneNoText = ""
    }
    
    static func PostDialCallStarted() ->Void
    {
        if mvDialPadView != nil
        {
            mvDialPadView.UpdateButton()
        }
    }
    
    static func PostDialCallFailed(nStatusCode: Int, sReasonPhrase: String) ->Void
    {
        if mvDialPadView != nil
        {
            mvDialPadView.UpdateButton()
        }
    }
    
    static func PostConnectedCall() ->Void
    {
        if mvDialPadView != nil
        {
            mvDialPadView.UpdateButton()
        }
    }
    
    static func PostDisconnectedCall() ->Void
    {
        if mvDialPadView != nil
        {
            mvDialPadView.UpdateButton()
        }
    }
    
    static func PostPhoneNoText(sNoText: String) ->Void
    {
        mvDialPadPhoneNoText = sNoText
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickDigit1(_ sender: Any)
    {        
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("1")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("1")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }

    @IBAction func OnClickDigit2(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("2")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("2")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit3(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("3")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("3")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit4(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("4")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("4")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit5(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("5")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("5")
        
        mvDialPadPhoneNoText = (mTextFieldDialNo.text!)
    }
    @IBAction func OnClickDigit6(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("6")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("6")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit7(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("7")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("7")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit8(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("8")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("8")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit9(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("9")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("9")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickDigit0(_ sender: Any)
    {
        mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("0")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("0")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickHash(_ sender: Any)
    {
         mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("#")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("#")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickStar(_ sender: Any)
    {
         mTextFieldDialNo.text = mTextFieldDialNo.text?.appending("*")
        cVaxPhoneDTMF.GetSelf().PlayDTMF("*")
        
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    
    @IBAction func OnClickCall(_ sender: Any)
    {
        if mTextFieldDialNo.text!.isEmpty
        {
            return
        }
        
        if !cVaxPhoneSIP.GetSelf().DialCall(mTextFieldDialNo.text!)
        {
            return
        }
        
        self.UpdateButton()
        self.performSegue(withIdentifier: "SegueUnwindDialPadView", sender: self)
    }
    
    @IBAction func OnClickEnd(_ sender: Any)
    {
        if !cVaxPhoneSIP.GetSelf().DisconnectCall()
        {
            return
        }
        
        self.UpdateButton()
    }
    
    @IBAction func OnClickContact(_ sender: Any)
    {
        self.ShowAddressBookUI()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickRemoveUp(_ sender: Any)
    {
        mTextFieldDialNo.ClearTextStop()
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    @IBAction func OnClickRemoveDown(_ sender: Any)
    {
        mTextFieldDialNo.ClearTextStart()
        mvDialPadPhoneNoText = mTextFieldDialNo.text!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @IBAction func OnClickHold(_ sender: Any)
    {
        if !cVaxPhoneGeneral.GetSelf().HoldLine()
         {
            return
         }
        
        self.UpdateButton()
    }
    @IBAction func OnClickUnhold(_ sender: Any)
    {
        if !cVaxPhoneGeneral.GetSelf().UnHoldLine()
         {
            return
         }
        
        self.UpdateButton()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    func UpdateButton() ->Void
    {
        if cVaxPhoneGeneral.GetSelf().IsLineHold()
        {
            mDialCall.isHidden = true
            mEndCall.isHidden = false
            
            mHoldCall.isHidden = true
            mUnHoldCall.isHidden = false
            
            mContact.isHidden = true
        }
        else if cVaxPhoneGeneral.GetSelf().IsLineConnected()
        {
            mDialCall.isHidden = true
            mEndCall.isHidden = false
            
            mHoldCall.isHidden = false
            mUnHoldCall.isHidden = true
            
            mContact.isHidden = true
        }
        else if cVaxPhoneGeneral.GetSelf().IsLineBusy()
        {
            mDialCall.isHidden = true
            mEndCall.isHidden = false
            
            mHoldCall.isHidden = false
            mUnHoldCall.isHidden = true
            
            mContact.isHidden = true
        }
        else
        {
            mDialCall.isHidden = false
            mEndCall.isHidden = true
            
            mHoldCall.isHidden = true
            mUnHoldCall.isHidden = true
            
            mContact.isHidden = false
        }
    }

    static func PostStatusText(sMsgText: String) ->Void
    {
        mvDialPadStatusText = sMsgText
        
        if mvDialPadView != nil
        {
            mvDialPadView.ShowStatusMsg(sMsgText: sMsgText)
        }
    }
    
    func ShowStatusMsg(sMsgText: String) ->Void
    {
    }
    
    func ShowAddressBookUI() ->Bool
    {
        mContactsView = cAddressBookView(iDelegate: self)
        mContactsView.ShowContacts(self, false)
        
        return true
    }
    
    func OnAddressBookSelectedPhoneNo(_ sPhoneNo: String) ->Void
    {
        mTextFieldDialNo.text = sPhoneNo
        mvDialPadPhoneNoText = mTextFieldDialNo.text
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
}
