
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

var mvVideoDeviceView: cVideoDeviceView! = nil

class cVideoDeviceView: UIViewController
{
    var mDisplayLayer: CALayer!
    
    var m_nLastWidth: Int = 0
    var m_nLastHeight: Int = 0

    override func viewDidLoad()
    {
        super.viewDidLoad()

        mDisplayLayer = self.view.layer
        
        m_nLastWidth  = -1
        m_nLastHeight = -1
    }

    override func didReceiveMemoryWarning()
    {
        super.didReceiveMemoryWarning()
    }
    
    override func viewWillAppear(_ animated: Bool)
    {
        mvVideoDeviceView = self
        super.viewWillAppear(animated)
    }
    
    override func viewDidAppear(_ animated: Bool)
    {
        super.viewDidAppear(animated)
        
        self.AdjustSize(bAfterDelay: false)
        //self.view.layer.addSublayer(mDisplayLayer)
    }
    
    override func viewWillDisappear(_ animated: Bool)
    {
        mvVideoDeviceView = nil
        super.viewWillDisappear(animated)
    }
    
    static func ShowView() ->Void
    {
        if mvVideoDeviceView == nil
        {
            return
        }
        
        if mvVideoDeviceView.view.isHidden
        {
            mvVideoDeviceView.view.isHidden = false
        }
    }
    
    override func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?)
    {
        if !view.isHidden
        {
            mvVideoDeviceView.view.isHidden = true
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnAdjustSize() ->Void
    {
        //mDisplayLayer.bounds = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
        //mDisplayLayer.position = CGPointMake(self.view.frame.size.width/2.0, self.view.frame.size.height/2.0);
    }
    
    func AdjustSize(bAfterDelay: Bool) ->Void
    {
        NSObject.cancelPreviousPerformRequests(withTarget: self, selector: #selector(self.OnAdjustSize), object: nil)
        
        if bAfterDelay
        {
            perform(#selector(self.OnAdjustSize), with: nil, afterDelay: 0.5)
        }
        else
        {
            self.OnAdjustSize()
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////
    
    override func viewWillTransition(to size: CGSize, with coordinator: UIViewControllerTransitionCoordinator)
    {
        self.AdjustSize(bAfterDelay: true)
    }
    
    func DisplayFrame(_ pDataRGB: UnsafeMutablePointer<Int8>!, _ nWidth: Int, _ nHeight: Int)
    {
        if m_nLastWidth != nWidth || m_nLastHeight != nHeight
        {
            self.AdjustSize(bAfterDelay: true)
            
            m_nLastWidth = nWidth
            m_nLastHeight = nHeight
        }
        
        let iColorSpace = CGColorSpaceCreateDeviceRGB()
        let iContext = CGContext(data: pDataRGB, width: nWidth, height: nHeight, bitsPerComponent: 8, bytesPerRow: nWidth * 4, space: iColorSpace, bitmapInfo: CGBitmapInfo.byteOrder32Little.rawValue | CGImageAlphaInfo.premultipliedFirst.rawValue)
        
        let iContextImage: CGImage? = iContext!.makeImage()
        mDisplayLayer.contents = iContextImage
    }
    
    static func PostFrameRGB(_ pDataRGB: UnsafeMutablePointer<Int8>!, _ nSize: Int, _ nWidth: Int, _ nHeight: Int)
    {
        if mvVideoDeviceView == nil
        {
            return
        }
        
        mvVideoDeviceView.DisplayFrame(pDataRGB, nWidth, nHeight)
    }
}
