
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cDataPRF: NSObject
{
    
    override init()
    {
        super.init()
    }
    
    deinit
    {
        
    }
    
    func WriteString(_ sKey: String, _ sData: String) ->Void
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        pRefs.set(sData, forKey: sKey)
        pRefs.synchronize()
    }
    
    func WriteBoolean(_ sKey: String, _ bData: Bool) ->Void
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        pRefs.set(bData, forKey: sKey)
        pRefs.synchronize()
    }
    
    func WriteInteger(_ sKey: String, _ nData: Int) ->Void
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        pRefs.set(nData, forKey: sKey)
        pRefs.synchronize()
    }
    
    func WriteArray(_ sKey: String, _ aData: [Any]) ->Void
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        pRefs.set(aData, forKey: sKey)
        pRefs.synchronize()
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func ReadString(_ sKey: String, _ sDefaultData: String) ->String
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        let sData: String? = pRefs.object(forKey: sKey) as? String
        
        if sData == nil
        {
            return sDefaultData
        }
        
        return sData!
    }
    
    func ReadBoolean(_ sKey: String, _ bDefaultData: Bool) ->Bool
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        let pValue: NSNumber? = pRefs.object(forKey: sKey) as? NSNumber
        
        if pValue == nil
        {
            return bDefaultData
        }
        
        return pValue! as! Bool
    }
    
    func ReadInt(_ sKey: String, _ nDefaultData: Int) ->Int
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        let nValue: NSNumber? = pRefs.object(forKey: sKey) as? NSNumber
        
        if nValue == nil
        {
            return nDefaultData
        }
        
        return nValue as! Int
    }
    
    func ReadArray(_ sKey: String, _ aDefaultData: [Any]) ->[Any]
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        let aData: [Any]? = pRefs.object(forKey: sKey) as? [Any]
        
        if aData == nil
        {
            return aDefaultData
        }
        
        return aData!
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func RemoveKey(_ sKey: String) ->Void
    {
        let pRefs: UserDefaults = UserDefaults.standard
        
        pRefs.removeObject(forKey: sKey)
        pRefs.synchronize()
    }
}
