
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreDataChatContacts: NSObject
{
    var m_nRecordId: Int
    var m_sName: String
    var m_nMissedCount: Int
    var m_bPresence: Bool
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        m_nRecordId = 0
        m_sName = ""
        m_nMissedCount = 0
        m_bPresence = false
        
        super.init()
    }
    
    deinit
    {
        
    }
    
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

class cStoreChatContacts: NSObject
{
    let TABLE_NAME                  = "TableChatContacts"
    let COLUMN_RECORD_ID            = "RecordId"
    let COLUMN_NAME                 = "Name"
    let COLUMN_MISSED_COUNT         = "MissedCount"
    let COLUMN_PRESENCE             = "Presence"
    
    var mvDataSQL: cDataSQL!
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        mvDataSQL = cDataSQL()
        
        super.init()
    }
    
    deinit
    {
        mvDataSQL = nil
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func CreateTable() ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "CREATE TABLE IF NOT EXISTS '%@' ('%@' INTEGER PRIMARY KEY AUTOINCREMENT, '%@' TEXT, '%@' INTEGER DEFAULT 0, '%@' INTEGER DEFAULT 0)", TABLE_NAME, COLUMN_RECORD_ID, COLUMN_NAME, COLUMN_MISSED_COUNT, COLUMN_PRESENCE)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func AddContact(_ sName: String, _ nMissedCount: Int, _ bPresence: Bool) ->Void
    {
        self.RemoveContact(sName)
        
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "INSERT INTO %@ (%@, %@, %@) VALUES ('%@', %ld, %hhu)", TABLE_NAME, COLUMN_NAME, COLUMN_MISSED_COUNT, COLUMN_PRESENCE, sName, nMissedCount, bPresence as CVarArg)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func UpdateMissedCount(_ sName: String, _ nValue: Int) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQurey: String = String(format: "UPDATE %@ SET %@ = %ld WHERE %@ = '%@'", TABLE_NAME, COLUMN_MISSED_COUNT, nValue, COLUMN_NAME, sName)
        
        if !(mvDataSQL.StartQuery(sQurey))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func GetContactAll() ->[Any]
    {
        var aRecordAll: [Any] = [Any]()
        
        if !(mvDataSQL.OpenDatabase())
        {
            return aRecordAll
        }
        
        let sQurey: String = String(format: "SELECT * FROM %@", TABLE_NAME)
        
        if !(mvDataSQL.StartQuery(sQurey))
        {
            mvDataSQL.CloseDatabase()
            return aRecordAll
        }
        
        while true
        {
            var aRecord:[Any] = [Any]()
            
            if !(mvDataSQL.GetRowData(&aRecord))
            {
                break
            }
            
            let vData: cStoreDataChatContacts = cStoreDataChatContacts()
            
            vData.m_nRecordId = Int (aRecord[0] as! UInt32)
            vData.m_sName = aRecord[1] as! String
            vData.m_nMissedCount = Int (aRecord[2] as! UInt32)
            vData.m_bPresence = (aRecord[3] as! UInt32) != 0
            
            aRecordAll.append(vData)
        }
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
        
        return aRecordAll
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func RemoveContactAll() ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "DELETE FROM %@", TABLE_NAME)
            
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func RemoveContact(_ sName: String) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "DELETE FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_NAME, sName)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

}
