
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreDataChatMsgs: NSObject
{
    var m_nRecordId: Int
    var m_sContactName: String
    var m_sMsgText: String
    var m_bMsgTypeOutgoing: Bool
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        m_nRecordId = 0
        m_sContactName = ""
        m_sMsgText = ""
        m_bMsgTypeOutgoing = false
        
        super.init()
    }
    
    deinit
    {
        
    }
    
}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

class cStoreChatMsgs: NSObject
{
    let TABLE_NAME                      = "TableChatMsgs"
    
    let COLUMN_RECORD_ID                = "RecordId"
    let COLUMN_CONTACT_NAME             = "ContactName"
    let COLUMN_MSG_TEXT                 = "MsgText"
    let COLUMN_MSG_TYPE_OUTGOING        = "MsgTypeOutgoing"
    
    var mvDataSQL: cDataSQL!
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        mvDataSQL = cDataSQL()
        
        super.init()
    }
    
    deinit
    {
        mvDataSQL = nil
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func CreateTable() ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "CREATE TABLE IF NOT EXISTS '%@' ('%@' INTEGER PRIMARY KEY AUTOINCREMENT, '%@' TEXT, '%@' TEXT, '%@' INTEGER)", TABLE_NAME, COLUMN_RECORD_ID, COLUMN_CONTACT_NAME, COLUMN_MSG_TEXT, COLUMN_MSG_TYPE_OUTGOING)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func AddChatMessageText(_ sContactName: String, _ sMsgText: String, _ bMsgTypeOutgoing: Bool) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "INSERT INTO %@ (%@, %@, %@) VALUES (?, ?, ?)", TABLE_NAME, COLUMN_CONTACT_NAME, COLUMN_MSG_TEXT, COLUMN_MSG_TYPE_OUTGOING)
        
        let aParam: [Any] = [sContactName, sMsgText, bMsgTypeOutgoing]
        
        if !(mvDataSQL.StartQuery(sQuery, aParam))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
        
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func GetChatMessageAll(_ sContactName: String) ->[Any]
    {
        var vRecordAll: [Any] = [Any]()
        
        if !(mvDataSQL.OpenDatabase())
        {
            return vRecordAll
        }
        
        let sQuery: String = String(format: "SELECT * FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_CONTACT_NAME, sContactName)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return vRecordAll
        }
        
        while true
        {
            var vRecord: [Any] = [Any]()
            
            if !(mvDataSQL.GetRowData(&vRecord))
            {
                break
            }
            
            let vData: cStoreDataChatMsgs = cStoreDataChatMsgs()
            
            vData.m_nRecordId = Int (vRecord[0] as! UInt32)
            vData.m_sContactName = vRecord[1] as! String
            vData.m_sMsgText = vRecord[2] as! String
            vData.m_bMsgTypeOutgoing = (vRecord[3] as! UInt32) != 0
            
            vRecordAll.append(vData)
        }
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
        
        return vRecordAll
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func RemoveMessageAll(_ sContactName: String) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "DELETE FROM %@ WHERE %@ = '%@'", TABLE_NAME, COLUMN_CONTACT_NAME, sContactName)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func RemoveMessage(_ nRecordId: Int) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "DELETE FROM %@ WHERE %@ = '%ld'", TABLE_NAME, COLUMN_RECORD_ID, nRecordId)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////


}
