
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreDataRecents: NSObject
{
    var m_nRecordId: Int
    var m_bOutboundCallType: Bool
    var m_sName: String
    var m_sPhoneNo: String
    var m_nStartTime: Int
    var m_nEndTime: Int
    var m_nDuration: Int
    var m_nDayNo: Int
    var m_nHistoryTypeId: Int
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        m_nRecordId = 0
        m_bOutboundCallType = false
        m_sName = ""
        m_sPhoneNo = ""
        m_nStartTime = 0
        m_nEndTime = 0
        m_nDuration = 0
        m_nDayNo = 0
        m_nHistoryTypeId = 0
        
        super.init()
    }
    
    deinit
    {
        
    }

}

///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////

class cStoreRecents: NSObject
{
    let TABLE_NAME                      = "TableRecents"
    
    let COLUMN_RECORD_ID                = "RecordId"
    let COLUMN_OUTBOUND_CALL_TYPE       = "OutboundCallType"
    let COLUMN_NAME                     = "Name"
    let COLUMN_PHONE_NO                 = "PhoneNo"
    let COLUMN_START_TIME               = "StartTime"
    let COLUMN_END_TIME                 = "EndTime"
    let COLUMN_DURATION                 = "Duration"
    let COLUMN_DAY_NO                   = "DayNo"
    let COLUMN_HISTORY_TYPE_ID          = "HistoryTypeId"
    
    var mvDataSQL: cDataSQL!
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        mvDataSQL = cDataSQL()
        
        super.init()
    }
    
    deinit
    {
        mvDataSQL = nil
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func CreateTable() ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format: "CREATE TABLE IF NOT EXISTS '%@' ('%@' INTEGER PRIMARY KEY AUTOINCREMENT, '%@' INTEGER, '%@' TEXT, '%@' TEXT, '%@' INTEGER, '%@' INTEGER, '%@' INTEGER, '%@' INTEGER, '%@' INTEGER )", TABLE_NAME, COLUMN_RECORD_ID, COLUMN_OUTBOUND_CALL_TYPE,
                                    COLUMN_NAME, COLUMN_PHONE_NO, COLUMN_START_TIME, COLUMN_END_TIME, COLUMN_DURATION, COLUMN_DAY_NO, COLUMN_HISTORY_TYPE_ID)
        
        if !mvDataSQL.StartQuery(sQuery)
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var pRecordArray = [Any]()
        mvDataSQL.GetRowData(&pRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func AddCallHistory(_ bOutboundCallType: Bool, _ sName: String, _ sPhoneNo: String, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Int
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return -1;
        }
        
        var sQuery: String = String(format: "INSERT INTO %@ (%@, %@, %@, %@, %@, %@, %@, %@) VALUES (?, ?, ?, ?, ?, ?, ?, ?)",
                                    TABLE_NAME, COLUMN_OUTBOUND_CALL_TYPE, COLUMN_NAME, COLUMN_PHONE_NO, COLUMN_START_TIME, COLUMN_END_TIME, COLUMN_DURATION, COLUMN_DAY_NO, COLUMN_HISTORY_TYPE_ID)
        
        let aParam: [Any] = [bOutboundCallType, sName, sPhoneNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId]
        
        if !(mvDataSQL.StartQuery(sQuery, aParam))
        {
            mvDataSQL.CloseDatabase()
            return -1
        }
        
        var aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        
        mvDataSQL.EndQuery()
        
        sQuery = String(format: "SELECT MAX(%@) FROM %@", COLUMN_RECORD_ID, TABLE_NAME)
        
        if !mvDataSQL.StartQuery(sQuery)
        {
            mvDataSQL.CloseDatabase()
            return -1
        }
        
        aRecordArray = [Any]()
        mvDataSQL.GetRowData(&aRecordArray)
        mvDataSQL.EndQuery()
        
        if aRecordArray.count == 0
        {
            mvDataSQL.CloseDatabase()
            return -1
        }
        
        let nRecordId: Int = Int(aRecordArray[0] as! UInt32)
        mvDataSQL.CloseDatabase()
        
        return nRecordId
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func GetCallHistoryAll() ->[Any]
    {
        var pRecordAll = [Any]()
        
        if !(mvDataSQL .OpenDatabase())
        {
            return pRecordAll
        }
        
        let sQuery = String(format: "SELECT * FROM %@ ORDER BY %@ ASC", TABLE_NAME, COLUMN_DAY_NO)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return pRecordAll
        }
        
        while (true)
        {
            var pRecord = [Any]()
            
            if !(mvDataSQL.GetRowData(&pRecord))
            {
                break
            }
            
            let pData: cStoreDataRecents = cStoreDataRecents()
            
            pData.m_nRecordId = Int (pRecord[0] as! UInt32)
            pData.m_bOutboundCallType = (pRecord[1] as! UInt32) != 0
            pData.m_sName = pRecord[2] as! String
            pData.m_sPhoneNo = pRecord[3] as! String
            pData.m_nStartTime = Int(pRecord[4] as! UInt32)
            pData.m_nEndTime = Int(pRecord[5] as! UInt32)
            pData.m_nDuration = Int(pRecord[6] as! UInt32)
            pData.m_nDayNo = Int(pRecord[7] as! UInt32)
            pData.m_nHistoryTypeId = Int(pRecord[8] as! UInt32)
            
             pRecordAll.append(pData)
        }
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
        
        return pRecordAll
    }
    
///////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////
    
    func RemoveCallHistoryAll() ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery = String(format :"DELETE FROM %@", TABLE_NAME)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var pRecordArray = [Any]()
        mvDataSQL.GetRowData(&pRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
    func RemoveCallHistory(_ nRecordId: Int) ->Void
    {
        if !(mvDataSQL.OpenDatabase())
        {
            return
        }
        
        let sQuery: String = String(format :"DELETE FROM %@ WHERE %@ = '%ld'", TABLE_NAME, COLUMN_RECORD_ID, nRecordId)
        
        if !(mvDataSQL.StartQuery(sQuery))
        {
            mvDataSQL.CloseDatabase()
            return
        }
        
        var pRecordArray = [Any]()
        mvDataSQL.GetRowData(&pRecordArray)
        
        mvDataSQL.EndQuery()
        mvDataSQL.CloseDatabase()
    }
    
//////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////
    
    /*
    - (long) GetCallCount;
    {
    if(![mpDataSQL OpenDatabase])
    return 0;
    
    NSString* sQuery = [NSString stringWithFormat :@"SELECT COUNT(*) FROM %@", TABLE_NAME];
    
    if(![mpDataSQL StartQuery: sQuery])
    {
    [mpDataSQL CloseDatabase];
    return 0;
    }
    
    NSMutableArray* pRecordArray = [NSMutableArray new];
    [mpDataSQL GetRowData: pRecordArray];
    
    [mpDataSQL EndQuery];
    [mpDataSQL CloseDatabase];
    
    NSNumber* pNoCount = pRecordArray[0];
    return [pNoCount integerValue];
    }
    */
}
