
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreNetwork: NSObject
{
    let LOCAL_PORT_SIP_KEY                  = "VaxLocalPortSIP"
    let CHOOSE_RANDOMLY_SIP_KEY             = "VaxChooseRandomlySIP"
    
    let LOCAL_PORT_SIP_DEFAULT_VALUE        = 5060
    let CHOOSE_RANDOMLY_SIP_DEFAULT_VALUE   = true
    
    let m_vDataPRF: cDataPRF
    
    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        m_vDataPRF = cDataPRF()
        super.init()
    }
    
    deinit
    {
        
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetLocalPortSIP(_ nPort: Int) ->Void
    {
        m_vDataPRF.WriteInteger(LOCAL_PORT_SIP_KEY, nPort)
    }
    
    func SetChooseRandomlySIP(_ bRandomly: Bool) ->Void
    {
        m_vDataPRF.WriteBoolean(CHOOSE_RANDOMLY_SIP_KEY, bRandomly)
    }
     
    /////////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////////
    
    func GetLocalPortSIP() ->Int
    {
        return m_vDataPRF.ReadInt(LOCAL_PORT_SIP_KEY, LOCAL_PORT_SIP_DEFAULT_VALUE)
    }
    
    func GetChooseRandomlySIP() ->Bool
    {
        return m_vDataPRF.ReadBoolean(CHOOSE_RANDOMLY_SIP_KEY, CHOOSE_RANDOMLY_SIP_DEFAULT_VALUE)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////////////
    
    func ResetData() ->Void
    {
        m_vDataPRF.RemoveKey(LOCAL_PORT_SIP_KEY)
        m_vDataPRF.RemoveKey(CHOOSE_RANDOMLY_SIP_KEY)
    }
}
