
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreSpKMic: NSObject
{
    let AUTO_GAIN_SPK_KEY                   = "VaxAutoGainSpk"
    let AUTO_GAIN_MIC_KEY                   = "VaxAutoGainMic"
    let VOLUME_BOOST_MIC_KEY                = "VaxVolumeBoostMic"
        
    let AUTO_GAIN_SPK_DEFAULT_VALUE         = false
    let AUTO_GAIN_MIC_DEFAULT_VALUE         = false
    let VOLUME_BOOST_MIC_DEFAULT_VALUE      = false
        
    let m_vDataPRF: cDataPRF
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        m_vDataPRF = cDataPRF()
        super.init()
    }
    
    deinit
    {
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetAutoGainSpk(_ bEnable: Bool) ->Void
    {
        m_vDataPRF.WriteBoolean(AUTO_GAIN_SPK_KEY, bEnable)
    }
       
    func SetAutoGainMic(_ bEnable: Bool) ->Void
    {
        m_vDataPRF.WriteBoolean(AUTO_GAIN_MIC_KEY, bEnable)
    }
    
    func SetVolumeBoostMic(_ bEnable: Bool) ->Void
    {
        m_vDataPRF.WriteBoolean(VOLUME_BOOST_MIC_KEY, bEnable)
    }
        
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
    
    func GetAutoGainSpk() ->Bool
    {
        return m_vDataPRF.ReadBoolean(AUTO_GAIN_SPK_KEY, AUTO_GAIN_SPK_DEFAULT_VALUE)
    }
    
    func GetAutoGainMic() ->Bool
    {
        return m_vDataPRF.ReadBoolean(AUTO_GAIN_MIC_KEY, AUTO_GAIN_MIC_DEFAULT_VALUE)
    }
     
    func GetVolumeBoostMic() ->Bool
    {
        return m_vDataPRF.ReadBoolean(VOLUME_BOOST_MIC_KEY, VOLUME_BOOST_MIC_DEFAULT_VALUE)
    }
        
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
    
    func ResetData() ->Void
    {
        m_vDataPRF.RemoveKey(AUTO_GAIN_SPK_KEY)
               
        m_vDataPRF.RemoveKey(AUTO_GAIN_MIC_KEY)
        m_vDataPRF.RemoveKey(VOLUME_BOOST_MIC_KEY)
        
    }

}
