
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreVideoCodecs: NSObject
{
    let VIDEO_CODEC_KEY      = "VaxVideoCodecNo"
    let VIDEO_CODEC_ENABLED_KEY = "VaxVideoCodecEnabled"
    
    var maDefaultCodecNo: [Any]
    var maDefaultCodecEnabled: [Bool]
    
    let m_vDataPRF: cDataPRF
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        maDefaultCodecEnabled = [true]
        maDefaultCodecNo = [cVaxUserAgentInfo.VAX_VIDEO_CODEC_VP8]
        m_vDataPRF = cDataPRF()
        
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_VIDEO_CODEC_VP8] =  true
                
        super.init()
    }
    
    deinit
    {
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetVideoCodec(_ aCodecNo: inout [AnyHashable]) ->Void
    {
        m_vDataPRF.WriteArray(VIDEO_CODEC_KEY, aCodecNo)
    }
    
    func GetVideoCodec(_ aCodecNo: inout [AnyHashable])
    {
        var aReadCodecNo = m_vDataPRF.ReadArray(VIDEO_CODEC_KEY, maDefaultCodecNo)
        
        if aReadCodecNo.count != cVaxUserAgentInfo.VAX_VIDEO_CODEC_TOTAL
        {
            aReadCodecNo = maDefaultCodecNo
        }
        for nCount in 0..<aReadCodecNo.count
        {
            aCodecNo.append(aReadCodecNo[nCount] as! AnyHashable)
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetVideoCodecEnabled(_ nCodecNo: Int, _ bEnable: Bool) ->Void
    {
        let sKey: String = String(format: "%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo)
        m_vDataPRF.WriteBoolean(sKey, bEnable)
    }
    
    func GetVideoCodecEnabled(_ nCodecNo: Int) ->Bool
    {
        let sKey: String = String(format: "%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo)
        return m_vDataPRF.ReadBoolean(sKey, maDefaultCodecEnabled[nCodecNo])
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
    
    func ResetData() ->Void
    {
        m_vDataPRF.RemoveKey(VIDEO_CODEC_KEY)
        
        for nCodecNo in 0..<cVaxUserAgentInfo.VAX_VIDEO_CODEC_TOTAL
        {
            let sKey = String(format: "%@:%ld", VIDEO_CODEC_ENABLED_KEY, nCodecNo)
            m_vDataPRF.RemoveKey(sKey)
        }
    }
}
