
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cStoreVoiceCodecs: NSObject
{
    let VOICE_CODEC_NO_KEY      = "VaxVoiceCodecNo"
    let VOICE_CODEC_ENABLED_KEY = "VaxVoiceCodecEnabled"
    
    var maDefaultCodecNo: [Any]
    var maDefaultCodecEnabled: [Bool]
    
    let m_vDataPRF: cDataPRF
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    override init()
    {
        maDefaultCodecEnabled = [true, true, true, true, true]
        
        maDefaultCodecNo = [cVaxUserAgentInfo.VAX_AUDIO_CODEC_G711U, cVaxUserAgentInfo.VAX_AUDIO_CODEC_G711A, cVaxUserAgentInfo.VAX_AUDIO_CODEC_G729, cVaxUserAgentInfo.VAX_AUDIO_CODEC_GSM610, cVaxUserAgentInfo.VAX_AUDIO_CODEC_ILBC]
        
        m_vDataPRF = cDataPRF()
        
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_AUDIO_CODEC_G711U] =  true
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_AUDIO_CODEC_G711A] = true
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_AUDIO_CODEC_G729] = true
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_AUDIO_CODEC_GSM610] = true
        maDefaultCodecEnabled[cVaxUserAgentInfo.VAX_AUDIO_CODEC_ILBC] = true
        
        super.init()
    }
    
    deinit
    {
        
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetVoiceCodec(_ aCodecNo: [AnyHashable]) ->Void
    {
        m_vDataPRF.WriteArray(VOICE_CODEC_NO_KEY, aCodecNo)
    }
    
    func GetVoiceCodec(_ aCodecNo: inout [AnyHashable])
    {
        var aReadCodecNo = m_vDataPRF.ReadArray(VOICE_CODEC_NO_KEY, maDefaultCodecNo)
        
        if aReadCodecNo.count != cVaxUserAgentInfo.VAX_AUDIO_CODEC_TOTAL
        {
            aReadCodecNo = maDefaultCodecNo
        }
        for nCount in 0..<aReadCodecNo.count
        {
            aCodecNo.append(aReadCodecNo[nCount] as! AnyHashable)
        }
    }
    
//////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
    
    func SetVoiceCodecEnabled(_ nCodecNo: Int, _ bEnable: Bool) ->Void
    {
        let sKey: String = String(format: "%@:%ld", VOICE_CODEC_ENABLED_KEY, nCodecNo)
        m_vDataPRF.WriteBoolean(sKey, bEnable)
    }
    
    func GetVoiceCodecEnabled(_ nCodecNo: Int) ->Bool
    {
        let sKey: String = String(format: "%@:%ld", VOICE_CODEC_ENABLED_KEY, nCodecNo)
        return m_vDataPRF.ReadBoolean(sKey, maDefaultCodecEnabled[nCodecNo])
    }
    
/////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////
    
    func ResetData() ->Void
    {
        m_vDataPRF.RemoveKey(VOICE_CODEC_NO_KEY)
        
        for nCodecNo in 0..<cVaxUserAgentInfo.VAX_AUDIO_CODEC_TOTAL
        {
            let sKey = String(format: "%@:%ld", VOICE_CODEC_ENABLED_KEY, nCodecNo)
            m_vDataPRF.RemoveKey(sKey)
        }
    }
}
