
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.


#import "VaxUserAgentFrw/VaxUserAgentFrw.h"

@class cVaxUserAgentFrw;

@interface VaxUserAgentExFrw : VaxUserAgentFrw
{
	cVaxUserAgentFrw* m_pSwiftFrw;
}

- (id) init :(cVaxUserAgentFrw*) pSwiftFrw;
- (void) dealloc;

//////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
- (void) OnUnInitialized;

- (void) OnConnectingToRegister :(NSString*) sAccountName;
- (void) OnTryingToRegister :(NSString*) sAccountName;

- (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToRegister :(NSString*) sAccountName;

- (void) OnConnectingToReRegister :(NSString*) sAccountName;
- (void) OnTryingToReRegister :(NSString*) sAccountName;

- (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToReRegister :(NSString*) sAccountName;
    
- (void) OnTryingToUnRegister :(NSString*) sAccountName;
- (void) OnFailToUnRegister :(NSString*) sAccountName;
- (void) OnSuccessToUnRegister :(NSString*) sAccountName;
        
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
- (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;

- (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sToAddrRTP :(int) nToPortRTP;
- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnIncomingCallStarted :(NSString*) sAccountName :(NSString*) sCallId :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(NSString*) sFromURI :(NSString*) sToURI;
- (void) OnIncomingCallEnded :(NSString*) sAccountName :(NSString*) sCallId :(int) nReasonCode;
    
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;

- (void) OnPlayWaveDone :(NSString*) sAccountName :(int) nLineNo;
- (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
    
- (void) OnMsgNOTIFY :(NSString*) sAccountName :(NSString*) sMsg;
- (void) OnVoiceMailMsg :(NSString*) sAccountName :(Boolean) bIsMsgWaiting :(int) nNewMsgCount :(int) nOldMsgCount :(int) nNewUrgentMsgCount :(int) nOldUrgentMsgCount :(NSString*) sMsgAccount;
                
- (void) OnRingToneStarted :(NSString*) sAccountName :(NSString*) sCallId;
- (void) OnRingToneEnded :(NSString*) sAccountName :(NSString*) sCallId;
        
- (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
- (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;

- (void) OnAudioSessionLost :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;

- (void) OnChatSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;

- (void) OnChatContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
        
- (void) OnChatSendMsgTextSuccess :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(long) nUserValue;
- (void) OnChatSendMsgTextFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sMsgText :(long) nUserValue;
    
- (void) OnChatSendMsgTypingSuccess :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
- (void) OnChatSendMsgTypingFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(long) nUserValue;

- (void) OnChatRecvMsgText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bIsChatContact;
- (void) OnChatRecvMsgTypingStart :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatRecvMsgTypingStop :(NSString*) sAccountName :(NSString*) sUserName;

- (void) OnAudioRecordedPCM :(NSString*) sAccountName :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM :(int) nTypePCM;
- (void) OnDetectedAMD :(NSString*) sAccountName :(int) nLineNo :(Boolean) bIsHuman;

- (void) OnHoldCall :(NSString*) sAccountName :(int) nLineNo;
- (void) OnUnHoldCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnVideoRemoteStarted :(NSString*) sAccountName :(int) nLineNo;
- (void) OnVideoRemoteEnded :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnVideoDeviceFrameRGB :(int) nDeviceId :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
- (void) OnVideoRemoteFrameRGB :(NSString*) sAccountName :(int) nLineNo :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
            
- (void) OnAddCallHistory :(NSString*) sAccountName :(Boolean) bOutboundCallType :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nDayNo :(int) nHistoryTypeId;
- (void) OnNetworkReachability :(Boolean) bAvailable;

- (void) OnAudioDeviceMicVU :(int) nLevelVU;
- (void) OnAudioDeviceSpkVU :(int) nLevelVU;

- (void) OnBusyLampSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnBusyLampSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnBusyLampContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;

- (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;

@end
