//
//  VaxUserAgentFrw.h
//  VaxUserAgentFrw
//
//  Created by VaxSoft
//  Copyright © 2023 VaxSoft. All rights reserved.

#import <UIKit/UIKit.h>

//! Project version number for VaxUserAgentFrw.
FOUNDATION_EXPORT double VaxUserAgentFrwVersionNumber;

//! Project version string for VaxUserAgentFrw.
FOUNDATION_EXPORT const unsigned char VaxUserAgentFrwVersionString[];

// In this header, you should import all the public headers of your framework using statements like #import <VaxUserAgentFrw/PublicHeader.h>


#import <Foundation/Foundation.h>
@class VaxMainFrw;
@protocol iVaxUserAgentFrw;

@interface VaxUserAgentFrw : NSObject
{
    VaxMainFrw* m_pMainFrw;
    id <iVaxUserAgentFrw> mVaxFrwDelegate;
}

@property (retain) id mVaxFrwDelegate;

- (id) init;
- (id) initWith:(id) iDelegate;

- (void) dealloc;

- (NSString*) GetVersionFile;
- (NSString*) GetVersionSDK;

- (Boolean) SetLicenceKey :(NSString*) sLicenceKey;
             
- (Boolean) Initialize;
- (void) UnInitialize;
        
- (Boolean) AddAccountSIP :(NSString*) sAccountName :(int) nAccountType :(NSString*) sListenIP :(int) nListenPort :(NSString*) sDisplayName :(NSString*) sUserName :(NSString*) sAuthLogin :(NSString*) sAuthPwd :(NSString*) sDomainRealm :(NSString*) sServerAddr :(int) nServerPort;
- (void) RemoveAccountSIP :(NSString*) sAccountName;

- (Boolean) RegisterAccountSIP :(NSString*) sAccountName :(int) nExpire;
- (Boolean) UnRegisterAccountSIP :(NSString*) sAccountName;
    
- (Boolean) OpenLine :(int) nLineNo :(NSString*) sRTPRxIP :(int) nRxAudioPortRTP :(int) nRxVideoPortRTP;
- (Boolean) OpenLineREC :(int) nLineNo :(NSString*) sRTPRxIP :(int) nAudioPortRTP;
- (Boolean) CloseLine :(int) nLineNo;

- (Boolean) CryptoMediaNONE :(Boolean) bForced;
- (Boolean) CryptoMediaSDP :(Boolean) bForced;

- (int) GetVaxErrorCode;
- (NSString*) GetVaxErrorMsg;
    
- (NSString*) GetCallId :(int) nLineNo;
- (Boolean) AudioDeviceVU :(Boolean) bActivate :(Boolean) bMicVU :(Boolean) bSpkVU;

- (int) GetAudioInDevTotal;
- (int) GetAudioOutDevTotal;

- (NSString*) GetAudioInDevName :(int) nDeviceId;
- (NSString*) GetAudioOutDevName :(int) nDeviceId;

- (Boolean) DialCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(int) nInputDeviceId :(int) nOutputDeviceId;
- (Boolean) DialCallToREC :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDialNo;
- (Boolean) DisconnectCall :(int) nLineNo;

- (Boolean) AcceptCall :(int) nLineNo :(NSString*) sCallId :(int) nInputDeviceId :(int) nOutputDeviceId;
- (Boolean) RejectCall :(NSString*) sCallId;
    
- (Boolean) TransferCallBlind :(int) nLineNo :(NSString*) sToUserName;
- (Boolean) TransferCallConsult :(int) nLineNoA :(int) nLineNoB;
    
- (Boolean) HoldLine :(int) nLineNo;
- (Boolean) UnHoldLine :(int) nLineNo;
- (Boolean) RefreshLine :(int) nLineNo;
    
- (Boolean) IsLineOpen :(int) nLineNo;
- (Boolean) IsLineHold :(int) nLineNo;
- (Boolean) IsLineBusy :(int) nLineNo;
- (Boolean) IsLineConnected :(int) nLineNo;
    
- (Boolean) EnableKeepAlive :(NSString*) sAccountName :(int) nSeconds;
- (void) DisableKeepAlive :(NSString*) sAccountName;

- (void) DeselectAllAudioCodec;
- (void) SelectAllAudioCodec;
- (Boolean) SelectAudioCodec :(int) nCodecNo;
- (Boolean) DeselectAudioCodec :(int) nCodecNo;

- (void) DeselectAllVideoCodec;
- (void) SelectAllVideoCodec;
- (Boolean) SelectVideoCodec :(int) nCodecNo;
- (Boolean) DeselectVideoCodec :(int) nCodecNo;
        
- (Boolean) DigitDTMF :(int) nLineNo :(NSString*) sDigit :(int) nTypeDTMF;
- (Boolean) SetVolumeDTMF :(int) nVolume;
- (int) GetVolumeDTMF;
            
///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

- (Boolean) MuteMic :(Boolean) bMute;
- (Boolean) MuteSpk :(Boolean) bMute;

- (Boolean) MuteLineSpk :(int) nLineNo :(Boolean) bMute;
- (Boolean) MuteLineMic :(int) nLineNo :(Boolean) bMute;
        
- (Boolean) AutoGainMic :(Boolean) bEnable :(int) nVolume;
- (Boolean) AutoGainSpk :(Boolean) bEnable :(int) nVolume;
            
- (Boolean) SetVolumeMic :(int) nVolume;
- (int) GetVolumeMic;

- (Boolean) SetVolumeSpk :(int) nVolume;
- (int) GetVolumeSpk;
            
- (Boolean) SetLineVolumeSpk :(int) nLineNo :(int) nVolume;
- (int) GetLineVolumeSpk :(int) nLineNo;

///////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////
    
- (Boolean) EchoCancellation :(Boolean) bEnable;
- (Boolean) DonotDisturb :(Boolean) bEnable;
    
- (Boolean) IsLineRecording :(int) nLineNo;
- (Boolean) StartRecording :(int) nLineNo :(NSString*) sFileName :(int) nTypeRecord :(int) nTypePCM;
- (Boolean) StopRecording :(int) nLineNo;
- (Boolean) ResetRecording :(int) nLineNo;

- (Boolean) IsLinePlaying :(int) nLineNo;
    
- (Boolean) PlayWaveOpen :(int) nLineNo :(NSString*) sFileName;
- (Boolean) PlayWaveClose :(int) nLineNo;
    
- (Boolean) PlayWaveSkipTo :(int) nLineNo :(int) nMilliSeconds;
- (int) PlayWaveTotalTime :(int) nLineNo;
- (Boolean) PlayWavePause :(int) nLineNo;
- (Boolean) PlayWaveStart :(int) nLineNo :(Boolean) bListen;
- (Boolean) PlayWaveStop :(int) nLineNo;
- (int) PlayWavePosition :(int) nLineNo;
            
- (int) GetOutboundCodec :(int) nLineNo;
- (int) GetInboundCodec :(int) nLineNo;
        
- (Boolean) AudioSessionLost :(int) nSeconds;

- (Boolean) SetUserAgentSIP :(NSString*) sUserAgentName;
- (NSString*) GetUserAgentSIP;

- (Boolean) SetSubjectSDP :(NSString*) sSubjectSDP;
- (NSString*) GetSubjectSDP;

- (Boolean) ConfAllowLine :(int) nLineNo :(Boolean) bAllowListen :(Boolean) bAllowSpeak;
- (Boolean) LineVoiceChannelSpk :(int) nLineNo :(int) nChannel;
        
- (Boolean) ChatFindContact :(NSString*) sAccountName :(NSString*) sUserName;
- (Boolean) ChatAddContact :(NSString*) sAccountName :(NSString*) sUserName :(Boolean) bPresence;
- (Boolean) ChatRemoveContact :(NSString*) sAccountName :(NSString*) sUserName;
    
- (Boolean) ChatSendMessageTyping :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
- (Boolean) ChatSendMessageText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bMsgTypeHtml :(long) nUserValue;
    
- (Boolean) ChatSubscribeContactAll :(NSString*) sAccountName;
- (Boolean) ChatSetMyStatus :(NSString*) sAccountName :(int) nStatusId;
    
- (Boolean) VoiceChanger :(int) nPitch;
- (Boolean) ForwardCall :(Boolean) bEnable :(NSString*) sToUserName;

- (Boolean) PlayAddPCM :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM;
- (Boolean) PlayResetPCM :(int) nLineNo;
    
- (Boolean) AddCustomHeader :(int) nLineNo :(int) nReqId :(NSString*) sName :(NSString*) sValue;
- (Boolean) RemoveCustomHeader :(int) nLineNo :(int) nReqId :(NSString*) sName;
- (Boolean) RemoveCustomHeaderAll :(int) nLineNo :(int) nReqId;

- (Boolean) AddCustomHeaderReferToURI :(NSString*) sName :(NSString*) sValue;
- (Boolean) RemoveCustomHeaderReferToURI :(NSString*) sName;
- (Boolean) RemoveCustomHeaderAllReferToURI;
        
- (int) GetCountPacketLost :(int) nLineNo;
- (int) GetSizeJitterBuffer :(int) nLineNo;

- (int) GetVideoDevTotal;
- (NSString*) GetVideoDevName :(int) nDeviceId;

- (Boolean) OpenVideoDev :(int) nDeviceId :(int) nQuality;
- (void) CloseVideoDev;
                
- (Boolean) DialRingEnable :(NSString*) sFileName;
- (Boolean) DialRingDisable;

- (Boolean) BusyRingEnable :(NSString*) sFileName;
- (Boolean) BusyRingDisable;

- (Boolean) EnableVideo :(int) nLineNo :(Boolean) bOutbound :(Boolean) bInbound;

- (Boolean) IsNetworkAvailable;
- (Boolean) NetworkReachability :(Boolean) bEnable;

- (Boolean) AutoRegistration :(NSString*) sAccountName :(Boolean) bEnable :(int) nTickCountLimit :(int) nTickSeconds;
- (Boolean) VideoCodecBitRate :(int) nCodecNo :(int) nQuality;

- (int) BusyLampGetContactStatus :(NSString*) sAccountName :(NSString*) sUserName;
- (Boolean) BusyLampFindContact :(NSString*) sAccountName :(NSString*) sUserName;
- (Boolean) BusyLampAddContact :(NSString*) sAccountName :(NSString*) sUserName;
- (Boolean) BusyLampRemoveContact :(NSString*) sAccountName :(NSString*) sUserName;
- (Boolean) BusyLampSubscribeContactAll :(NSString*) sAccountName;
        
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (Boolean) DiagnosticLogSIP :(NSString*) sAccountName :(Boolean) bInbound :(Boolean) bOutbound;

- (Boolean) SetPushSIP :(NSString*) sAccountName :(NSString*) sTeamID :(NSString*) sBundleID :(NSString*) sDeviceToken;

- (Boolean) AudioVAD :(int) nLineNo :(Boolean) bEnable;
- (Boolean) SetNetworkPrioritySIP :(int) nMode;

/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnInitialized;
- (void) OnUnInitialized;

- (void) OnConnectingToRegister :(NSString*) sAccountName;
- (void) OnTryingToRegister :(NSString*) sAccountName;

- (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToRegister :(NSString*) sAccountName;

- (void) OnConnectingToReRegister :(NSString*) sAccountName;
- (void) OnTryingToReRegister :(NSString*) sAccountName;

- (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToReRegister :(NSString*) sAccountName;
    
- (void) OnTryingToUnRegister :(NSString*) sAccountName;
- (void) OnFailToUnRegister :(NSString*) sAccountName;
- (void) OnSuccessToUnRegister :(NSString*) sAccountName;
        
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
- (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;

- (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sToAddrRTP :(int) nToPortRTP;
- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnIncomingCallStarted :(NSString*) sAccountName :(NSString*) sCallId :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(NSString*) sFromURI :(NSString*) sToURI;
- (void) OnIncomingCallEnded :(NSString*) sAccountName :(NSString*) sCallId :(int) nReasonCode;
    
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;

- (void) OnPlayWaveDone :(NSString*) sAccountName :(int) nLineNo;
- (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
    
- (void) OnMsgNOTIFY :(NSString*) sAccountName :(NSString*) sMsg;
- (void) OnVoiceMailMsg :(NSString*) sAccountName :(Boolean) bIsMsgWaiting :(int) nNewMsgCount :(int) nOldMsgCount :(int) nNewUrgentMsgCount :(int) nOldUrgentMsgCount :(NSString*) sMsgAccount;
                
- (void) OnRingToneStarted :(NSString*) sAccountName :(NSString*) sCallId;
- (void) OnRingToneEnded :(NSString*) sAccountName :(NSString*) sCallId;
        
- (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
- (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;

- (void) OnAudioSessionLost :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;

- (void) OnChatSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;

- (void) OnChatContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
        
- (void) OnChatSendMsgTextSuccess :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(long) nUserValue;
- (void) OnChatSendMsgTextFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sMsgText :(long) nUserValue;
    
- (void) OnChatSendMsgTypingSuccess :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
- (void) OnChatSendMsgTypingFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(long) nUserValue;

- (void) OnChatRecvMsgText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bIsChatContact;
- (void) OnChatRecvMsgTypingStart :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatRecvMsgTypingStop :(NSString*) sAccountName :(NSString*) sUserName;

- (void) OnAudioRecordedPCM :(NSString*) sAccountName :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM :(int) nTypePCM;

- (void) OnHoldCall :(NSString*) sAccountName :(int) nLineNo;
- (void) OnUnHoldCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnVideoRemoteStarted :(NSString*) sAccountName :(int) nLineNo;
- (void) OnVideoRemoteEnded :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnVideoDeviceFrameRGB :(int) nDeviceId :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
- (void) OnVideoRemoteFrameRGB :(NSString*) sAccountName :(int) nLineNo :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
            
- (void) OnAddCallHistory :(NSString*) sAccountName :(Boolean) bOutboundCallType :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nDayNo :(int) nHistoryTypeId;
- (void) OnNetworkReachability :(Boolean) bAvailable;

- (void) OnAudioDeviceMicVU :(int) nLevelVU;
- (void) OnAudioDeviceSpkVU :(int) nLevelVU;

- (void) OnBusyLampSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnBusyLampSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnBusyLampContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;

- (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;

@end

@protocol iVaxUserAgentFrw <NSObject>

@optional


- (void) OnInitialized;
- (void) OnUnInitialized;

- (void) OnConnectingToRegister :(NSString*) sAccountName;
- (void) OnTryingToRegister :(NSString*) sAccountName;

- (void) OnFailToRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToRegister :(NSString*) sAccountName;

- (void) OnConnectingToReRegister :(NSString*) sAccountName;
- (void) OnTryingToReRegister :(NSString*) sAccountName;

- (void) OnFailToReRegister :(NSString*) sAccountName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnSuccessToReRegister :(NSString*) sAccountName;
    
- (void) OnTryingToUnRegister :(NSString*) sAccountName;
- (void) OnFailToUnRegister :(NSString*) sAccountName;
- (void) OnSuccessToUnRegister :(NSString*) sAccountName;
        
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnDialCallStarted :(NSString*) sAccountName :(int) nLineNo :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo;
- (void) OnDialingCall :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnDialCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sContact;

- (void) OnConnectedCall :(NSString*) sAccountName :(int) nLineNo :(NSString*) sToAddrRTP :(int) nToPortRTP;
- (void) OnHungupCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnIncomingCallStarted :(NSString*) sAccountName :(NSString*) sCallId :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(NSString*) sFromURI :(NSString*) sToURI;
- (void) OnIncomingCallEnded :(NSString*) sAccountName :(NSString*) sCallId :(int) nReasonCode;
    
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////

- (void) OnTransferCallFailed :(NSString*) sAccountName :(int) nLineNo :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnTransferCallAccepted :(NSString*) sAccountName :(int) nLineNo;

- (void) OnPlayWaveDone :(NSString*) sAccountName :(int) nLineNo;
- (void) OnDigitDTMF :(NSString*) sAccountName :(int) nLineNo :(NSString*) sDigit;
    
- (void) OnMsgNOTIFY :(NSString*) sAccountName :(NSString*) sMsg;
- (void) OnVoiceMailMsg :(NSString*) sAccountName :(Boolean) bIsMsgWaiting :(int) nNewMsgCount :(int) nOldMsgCount :(int) nNewUrgentMsgCount :(int) nOldUrgentMsgCount :(NSString*) sMsgAccount;
                
- (void) OnRingToneStarted :(NSString*) sAccountName :(NSString*) sCallId;
- (void) OnRingToneEnded :(NSString*) sAccountName :(NSString*) sCallId;
        
- (void) OnIncomingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sFromIP :(int) nFromPort;
- (void) OnOutgoingDiagnostic :(NSString*) sAccountName :(NSString*) sMsgSIP :(NSString*) sToIP :(int) nToPort;

- (void) OnAudioSessionLost :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnSuccessToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnSuccessToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnTryingToUnHold :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToUnHold :(NSString*) sAccountName :(int) nLineNo;

- (void) OnTryingToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnFailToRefresh :(NSString*) sAccountName :(int) nLineNo;
- (void) OnSuccessToRefresh :(NSString*) sAccountName :(int) nLineNo;

- (void) OnChatSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;

- (void) OnChatContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;
        
- (void) OnChatSendMsgTextSuccess :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(long) nUserValue;
- (void) OnChatSendMsgTextFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(NSString*) sMsgText :(long) nUserValue;
    
- (void) OnChatSendMsgTypingSuccess :(NSString*) sAccountName :(NSString*) sUserName :(long) nUserValue;
- (void) OnChatSendMsgTypingFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase :(long) nUserValue;

- (void) OnChatRecvMsgText :(NSString*) sAccountName :(NSString*) sUserName :(NSString*) sMsgText :(Boolean) bIsChatContact;
- (void) OnChatRecvMsgTypingStart :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnChatRecvMsgTypingStop :(NSString*) sAccountName :(NSString*) sUserName;

- (void) OnAudioRecordedPCM :(NSString*) sAccountName :(int) nLineNo :(char*) pDataPCM :(int) nSizePCM :(int) nTypePCM;
- (void) OnDetectedAMD :(NSString*) sAccountName :(int) nLineNo :(Boolean) bIsHuman;

- (void) OnHoldCall :(NSString*) sAccountName :(int) nLineNo;
- (void) OnUnHoldCall :(NSString*) sAccountName :(int) nLineNo;

- (void) OnVideoRemoteStarted :(NSString*) sAccountName :(int) nLineNo;
- (void) OnVideoRemoteEnded :(NSString*) sAccountName :(int) nLineNo;
    
- (void) OnVideoDeviceFrameRGB :(int) nDeviceId :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
- (void) OnVideoRemoteFrameRGB :(NSString*) sAccountName :(int) nLineNo :(char*) pFrameRGB :(int) nFrameSize :(int) nFrameWidth :(int) nFrameHeight;
            
- (void) OnAddCallHistory :(NSString*) sAccountName :(Boolean) bOutboundCallType :(NSString*) sCallerName :(NSString*) sCallerId :(NSString*) sDialNo :(long) nStartTime :(long) nEndTime :(long) nDuration :(long) nDayNo :(int) nHistoryTypeId;
- (void) OnNetworkReachability :(Boolean) bAvailable;

- (void) OnAudioDeviceMicVU :(int) nLevelVU;
- (void) OnAudioDeviceSpkVU :(int) nLevelVU;

- (void) OnBusyLampSubscribeSuccess :(NSString*) sAccountName :(NSString*) sUserName;
- (void) OnBusyLampSubscribeFailed :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusCode :(NSString*) sReasonPhrase;
- (void) OnBusyLampContactStatus :(NSString*) sAccountName :(NSString*) sUserName :(int) nStatusId;

- (void) OnVaxErrorMsg :(NSString*) sFuncName :(NSString*) sErrorMsg :(int) nErrorCode;

@end


