
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

@objc class cVaxUserAgentFrw : NSObject
{
    var mUserAgentExLib : VaxUserAgentExFrw!
    
    override init()
    {
        super.init()

        mUserAgentExLib = VaxUserAgentExFrw(self)
    }

    deinit
    {
        mUserAgentExLib = nil
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func GetVersionFile() ->String
    {
        return mUserAgentExLib.getVersionFile()
    }

    func GetVersionSDK() ->String
    {
        return mUserAgentExLib.getVersionSDK()
    }
    
    func SetLicenceKey(_ sLicenceKey: String) ->Bool
    {
        return mUserAgentExLib.setLicenceKey(sLicenceKey)
    }
            
    func Initialize() ->Bool
    {
        return mUserAgentExLib.initialize()
    }
    
    func UnInitialize() ->Void
    {
        mUserAgentExLib.unInitialize()
    }
    
    func AddAccountSIP(_ sAccountName: String, _ nAccountType: Int, _ sListenIP: String, _ nListenPort: Int, _ sDisplayName: String, _ sUserName: String, _ sAuthLogin: String, _ sAuthPwd: String, _ sDomainRealm: String, _ sServerAddr: String, _ nServerPort: Int) ->Bool
    {
        return mUserAgentExLib.addAccountSIP(sAccountName, Int32(nAccountType), sListenIP, Int32(nListenPort), sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, Int32(nServerPort))
    }
    
    func RemoveAccountSIP(_ sAccountName: String)
    {
        mUserAgentExLib.removeAccountSIP(sAccountName);
    }
    
    func RegisterAccountSIP(_ sAccountName: String, _ nExpire: Int) ->Bool
    {
        return mUserAgentExLib.registerAccountSIP(sAccountName, Int32(nExpire))
    }
    
    func UnRegisterAccountSIP(_ sAccountName: String) ->Bool
    {
        return mUserAgentExLib.unRegisterAccountSIP(sAccountName)
    }
    
    func OpenLine(_ nLineNo: Int, _ sRTPRxIP: String, _ nRxAudioPortRTP: Int, _ nRxVideoPortRTP:Int) ->Bool
    {
        return mUserAgentExLib.openLine(Int32(nLineNo), sRTPRxIP, Int32(nRxAudioPortRTP), Int32(nRxVideoPortRTP))
    }
    
    func OpenLineREC(_ nLineNo: Int, _ sRTPRxIP: String, _ nAudioPortRTP: Int) ->Bool
    {
        return mUserAgentExLib.openLineREC(Int32(nLineNo), sRTPRxIP, Int32(nAudioPortRTP))
    }
    
    func CloseLine(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.closeLine(Int32(nLineNo))
    }
    
    func CryptoMediaNONE(_ bForced: Bool) ->Bool
    {
        return mUserAgentExLib.cryptoMediaNONE(bForced)
    }
    
    func CryptoMediaSDP(_ bForced: Bool) ->Bool
    {
        return mUserAgentExLib.cryptoMediaSDP(bForced)
    }
    
    
    func GetVaxErrorCode() ->Int
    {
        return Int(mUserAgentExLib.getVaxErrorCode())
    }
    
    func GetVaxErrorMsg() ->String
    {
        return mUserAgentExLib.getVaxErrorMsg()
    }
    
    func GetCallId(_ nLineNo: Int) ->String
    {
        return mUserAgentExLib.getCallId(Int32(nLineNo));
    }
    
    func AudioDeviceVU(_ bActivate: Bool, _ bMicVU: Bool, _ bSpkVU: Bool) ->Bool
    {
        return mUserAgentExLib.audioDeviceVU(bActivate, bMicVU, bSpkVU);
    }
    
    func GetAudioInDevTotal() ->Int
    {
        return Int(mUserAgentExLib.getAudioInDevTotal());
    }
    
    func GetAudioOutDevTotal() ->Int
    {
        return Int(mUserAgentExLib.getAudioOutDevTotal());
    }
    
    func GetAudioOutDevName(_ nDeviceId: Int) ->String
    {
        return mUserAgentExLib.getAudioOutDevName(Int32(nDeviceId));
    }
    
    func GetAudioInDevName(_ nDeviceId: Int) ->String
    {
        return mUserAgentExLib.getAudioOutDevName(Int32(nDeviceId));
    }
    
    func DialCall(_ sAccountName: String, _ nLineNo: Int, _ sCallerName: String, _ sCallerId: String, _ sDialNo: String, _ nInputDeviceId: Int, _ nOutputDeviceId: Int) ->Bool
    {
        return mUserAgentExLib.dialCall(sAccountName, Int32(nLineNo), sCallerName, sCallerId, sDialNo, Int32(nInputDeviceId), Int32(nOutputDeviceId))
    }
    
    func DialCallToREC(_ sAccountName: String, _ nLineNo: Int, _ sDialNo: String) ->Bool
    {
        return mUserAgentExLib.dialCall(toREC: sAccountName, Int32(nLineNo), sDialNo)
    }
    
    func DisconnectCall(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.disconnectCall(Int32(nLineNo))
    }
    
    func AcceptCall(_ nLineNo: Int, _ sCallId: String, _ nInputDeviceId: Int, _ nOutputDeviceId: Int) ->Bool
    {
        return mUserAgentExLib.acceptCall(Int32(nLineNo), sCallId, Int32(nInputDeviceId), Int32(nOutputDeviceId))
    }
    
    func RejectCall(_ sCallId: String) ->Bool
    {
        return mUserAgentExLib.rejectCall(sCallId)
    }
    
    func TransferCallBlind(_ nLineNo: Int, _ sToUserName: String) ->Bool
    {
        return mUserAgentExLib.transferCallBlind(Int32(nLineNo), sToUserName)
    }
    
    func TransferCallConsult(_ nLineNoA: Int, _ nLineNoB: Int) ->Bool
    {
        return mUserAgentExLib.transferCallConsult(Int32(nLineNoA), Int32(nLineNoB))
    }
    
    func HoldLine(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.holdLine(Int32(nLineNo))
    }
    
    func UnHoldLine(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.unHoldLine(Int32(nLineNo))
    }
    
    func RefreshLine(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.refreshLine(Int32(nLineNo))
    }
        
    func IsLineOpen(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLineOpen(Int32(nLineNo))
    }
    
    func IsLineHold(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLineHold(Int32(nLineNo))
    }
            
    func IsLineBusy(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLineBusy(Int32(nLineNo))
    }
    
    func IsLineConnected(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLineConnected(Int32(nLineNo))
    }
    
    func EnableKeepAlive(_ sAccountName: String, _ nSeconds: Int) ->Bool
    {
        return mUserAgentExLib.enableKeepAlive(sAccountName, Int32(nSeconds))
    }
    
    func DisableKeepAlive(_ sAccountName: String) ->Void
    {
        mUserAgentExLib.disableKeepAlive(sAccountName)
    }
    
    func SelectAllAudioCodec() ->Void
    {
        mUserAgentExLib.selectAllAudioCodec()
    }
    
    func SelectAudioCodec(_ nCodecNo: Int) ->Bool
    {
        return mUserAgentExLib.selectAudioCodec(Int32(nCodecNo))
    }
    
    func DeselectAllAudioCodec() ->Void
    {
        mUserAgentExLib.deselectAllAudioCodec()
    }
    
    func DeselectAudioCodec(_ nCodec: Int) ->Bool
    {
        return mUserAgentExLib.deselectAudioCodec(Int32(nCodec))
    }
    
    func SelectAllVideoCodec() ->Void
    {
        mUserAgentExLib.selectAllVideoCodec()
    }
    
    func SelectVideoCodec(_ nCodec: Int) ->Bool
    {
        return mUserAgentExLib.selectVideoCodec(Int32(nCodec))
    }
    
    func DeselectAllVideoCodec() ->Void
    {
        mUserAgentExLib.deselectAllVideoCodec()
    }
    
    func DeselectVideoCodec(_ nCodec: Int) ->Bool
    {
        return mUserAgentExLib.deselectVideoCodec(Int32(nCodec))
    }
    
    func DigitDTMF(_ nLineNo: Int, _ sDigit: String, _ nTypeDTMF: Int) ->Bool
    {
        return mUserAgentExLib.digitDTMF(Int32(nLineNo), sDigit, Int32(nTypeDTMF))
    }
    
    func SetVolumeDTMF(_ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.setVolumeDTMF(Int32(nVolume))
    }
    
    func GetVolumeDTMF() ->Int
    {
        return Int(mUserAgentExLib.getVolumeDTMF())
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func MuteMic(_ bMute: Bool) ->Bool
    {
        return mUserAgentExLib.muteMic(bMute)
    }
    
    func MuteSpk(_ bMute: Bool) ->Bool
    {
        return mUserAgentExLib.muteSpk(bMute)
    }
    
    func MuteLineSpk(_ nLineNo: Int, _ bMute: Bool) ->Bool
    {
        return mUserAgentExLib.muteLineSpk(Int32(nLineNo), bMute)
    }
    
    func MuteLineMic(_ nLineNo: Int, _ bMute: Bool) ->Bool
    {
        return mUserAgentExLib.muteLineMic(Int32(nLineNo), bMute)
    }
    
    func AutoGainMic(_ bEnable: Bool, _ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.autoGainMic(bEnable, Int32(nVolume))
    }
    
    func AutoGainSpk(_ bEnable: Bool, _ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.autoGainSpk(bEnable, Int32(nVolume))
    }
    
    func SetVolumeMic(_ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.setVolumeMic(Int32(nVolume))
    }
    
    func GetVolumeMic() ->Int
    {
        return Int(mUserAgentExLib.getVolumeMic())
    }
    
    func SetVolumeSpk(_ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.setVolumeSpk(Int32(nVolume))
    }
    
    func GetVolumeSpk() ->Int
    {
        return Int(mUserAgentExLib.getVolumeSpk())
    }
    
    func SetLineVolumeSpk(_ nLineNo: Int, _ nVolume: Int) ->Bool
    {
        return mUserAgentExLib.setLineVolumeSpk(Int32(nLineNo), Int32(nVolume))
    }
    
    func GetLineVolumeSpk(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.getLineVolumeSpk(Int32(nLineNo)))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func EchoCancellation(_ bEnable: Bool) ->Bool
    {
        return mUserAgentExLib.echoCancellation(bEnable)
    }
    
    func DonotDisturb(_ bEnable: Bool) ->Bool
    {
        return mUserAgentExLib.donotDisturb(bEnable)
    }
    
    func IsLineRecording(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLineRecording(Int32(nLineNo))
    }
    
    func StartRecording(_ nLineNo: Int, _ sFileName: String, _ nTypeRecord: Int, _ nTypePCM: Int) ->Bool
    {
        return mUserAgentExLib.startRecording(Int32(nLineNo), sFileName, Int32(nTypeRecord), Int32(nTypePCM))
    }
    
    func StopRecording(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.stopRecording(Int32(nLineNo))
    }
    
    func ResetRecording(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.resetRecording(Int32(nLineNo))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func IsLinePlaying(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.isLinePlaying(Int32(nLineNo))
    }
    
    func PlayWaveOpen(_ nLineNo: Int, _ sFileName: String) ->Bool
    {
        return mUserAgentExLib.playWaveOpen(Int32(nLineNo), sFileName)
    }
    
    func PlayWaveClose(_ nlineNo: Int) ->Bool
    {
        return mUserAgentExLib.playWaveClose(Int32(nlineNo))
    }
    
    func PlayWaveSkipTo(_ nLineNo: Int, _ nMilliSeconds: Int) ->Bool
    {
        return mUserAgentExLib.playWaveSkip(to: Int32(nLineNo), Int32(nMilliSeconds))
    }
    
    func PlayWaveTotalTime(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.playWaveTotalTime(Int32(nLineNo)))
    }
    
    func PlayWavePause(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.playWavePause(Int32(nLineNo))
    }
    
    func PlayWaveStart(_ nLineNo: Int, _ bListen: Bool) ->Bool
    {
        return mUserAgentExLib.playWaveStart(Int32(nLineNo), bListen)
    }
    
    func PlayWaveStop(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.playWaveStop(Int32(nLineNo))
    }
    
    func PlayWavePosition(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.playWavePosition(Int32(nLineNo)))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func GetOutboundCodec(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.getOutboundCodec(Int32(nLineNo)))
    }
    
    func GetInboundCodec(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.getInboundCodec(Int32(nLineNo)))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func AudioSessionLost(_ nSecond: Int) ->Void
    {
        mUserAgentExLib.audioSessionLost(Int32(nSecond))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func SetUserAgentSIP(_ sUserAgentName: String) ->Bool
    {
        return mUserAgentExLib.setUserAgentSIP(sUserAgentName)
    }
    
    func GetUserAgentSIP() ->String
    {
        return mUserAgentExLib.getUserAgentSIP()
    }
    
    func SetSubjectSDP(_ sSubjectSDP: String) ->Bool
    {
        return mUserAgentExLib.setSubjectSDP(sSubjectSDP)
    }
    
    func GetSubjectSDP() ->String
    {
        return mUserAgentExLib.getSubjectSDP()
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func ConfAllowLine(_ nLineNo: Int, _ bAllowListen: Bool, _ bAllowSpeak: Bool) ->Bool
    {
        return mUserAgentExLib.confAllowLine(Int32(nLineNo), bAllowListen, bAllowSpeak)
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func ChatFindContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mUserAgentExLib.chatFindContact(sAccountName, sUserName)
    }
    
    func ChatAddContact(_ sAccountName: String, _ sUserName: String, _ bPresence: Bool) ->Bool
    {
        return mUserAgentExLib.chatAddContact(sAccountName, sUserName, bPresence)
    }
    
    func ChatRemoveContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mUserAgentExLib.chatRemoveContact(sAccountName, sUserName)
    }
    
    func ChatSendMessageTyping(_ sAccountName: String, _ sUserName: String, _ nUserValue: Int) ->Bool
    {
        return mUserAgentExLib.chatSendMessageTyping(sAccountName, sUserName, nUserValue)
    }
    
    func ChatSendMessageText(_ sAccountName: String, _ sUserName: String, _ sMsgText: String, _ bMsgTypeHtml: Bool, _ nUserValue: Int) ->Bool
    {
        return mUserAgentExLib.chatSendMessageText(sAccountName, sUserName, sMsgText, bMsgTypeHtml, nUserValue)
    }
    
    func ChatSubscribeContactAll(_ sAccountName: String) ->Bool
    {
        return mUserAgentExLib.chatSubscribeContactAll(sAccountName)
    }
    
    func ChatSetMyStatus(_ sAccountName: String, _ nStatusId: Int) ->Bool
    {
        return mUserAgentExLib.chatSetMyStatus(sAccountName, Int32(nStatusId))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func VoiceChanger(_ nPitch: Int) ->Bool
    {
        return mUserAgentExLib.voiceChanger(Int32(nPitch))
    }
    
    func ForwardCall(_ bEnable: Bool, _ sToUserName: String) ->Bool
    {
        return mUserAgentExLib.forwardCall(bEnable, sToUserName)
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func PlayAddPCM(_ nLineNo: Int, _ pDataPCM: UnsafeMutablePointer<Int8>, _ nSizePCM: Int) ->Bool
    {
        return mUserAgentExLib.playAddPCM(Int32(nLineNo), pDataPCM, Int32(nSizePCM))
    }
    
    func PlayResetPCM(_ nLineNo: Int) ->Bool
    {
        return mUserAgentExLib.playResetPCM(Int32(nLineNo))
    }
            
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func AddCustomHeader(_ nLineNo: Int, _ nReqId: Int, _ sName: String, _ sValue: String) ->Bool
    {
        return mUserAgentExLib.addCustomHeader(Int32(nLineNo), Int32(nReqId), sName, sValue)
    }
    
    func RemoveCustomHeader(_ nLineNo: Int, _ nReqId: Int, _ sName: String) ->Bool
    {
        return mUserAgentExLib.removeCustomHeader(Int32(nLineNo), Int32(nReqId), sName)
    }
    
    func RemoveCustomHeaderAll(_ nLineNo: Int, _ nReqId: Int) ->Bool
    {
        return mUserAgentExLib.removeCustomHeaderAll(Int32(nLineNo), Int32(nReqId))
    }
    
    
    func AddCustomHeaderReferToURI(_ sName: String, _ sValue: String) ->Bool
    {
        return mUserAgentExLib.addCustomHeaderRefer(toURI: sName, sValue)
    }
    
    func RemoveCustomHeaderReferToURI(_ sName: String) ->Bool
    {
        return mUserAgentExLib.removeCustomHeaderRefer(toURI: sName)
    }
    
    func RemoveCustomHeaderAllReferToURI() ->Bool
    {
        return mUserAgentExLib.removeCustomHeaderAllReferToURI()
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func GetCountPacketLost(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.getCountPacketLost(Int32(nLineNo)))
    }
    
    func GetSizeJitterBuffer(_ nLineNo: Int) ->Int
    {
        return Int(mUserAgentExLib.getSizeJitterBuffer(Int32(nLineNo)))
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func GetVideoDevTotal() ->Int
    {
        return Int(mUserAgentExLib.getVideoDevTotal())
    }
    
    func GetVideoDevName(_ nDeviceId: Int) ->String
    {
        return mUserAgentExLib.getVideoDevName(Int32(nDeviceId))
    }
    
    func OpenVideoDev(_ nDeviceId: Int, _ nQuality: Int) ->Bool
    {
        return mUserAgentExLib.openVideoDev(Int32(nDeviceId), Int32(nQuality))
    }
    
    func CloseVideoDev() ->Void
    {
        mUserAgentExLib.closeVideoDev()
    }
    
    ///////////////////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////////////////
    
    func DialRingEnable(_ sFileName: String) ->Bool
    {
        return mUserAgentExLib.dialRingEnable(sFileName)
    }
    
    func DialRingDisable() ->Bool
    {
        return mUserAgentExLib.dialRingDisable()
    }
    
    func BusyRingEnable(_ sFileName: String) ->Bool
    {
        return mUserAgentExLib.busyRingEnable(sFileName)
    }
    
    func BusyRingDisable() ->Bool
    {
        return mUserAgentExLib.busyRingDisable()
    }
    
    ///////////////////////////////////////////////////////////////
    ///////////////////////////////////////////////////////////////
    
    func EnableVideo(_ nLineNo: Int, _ bOutbound: Bool, _ bInbound: Bool) ->Bool
    {
        return mUserAgentExLib.enableVideo(Int32(nLineNo), bOutbound, bInbound)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////
    
    func IsNetworkAvailable() ->Bool
    {
        return mUserAgentExLib.isNetworkAvailable()
    }
    
    func NetworkReachability(_ bEnable: Bool) ->Bool
    {
        return mUserAgentExLib.networkReachability(bEnable)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AutoRegistration(_ sAccountName: String, _ bEnable: Bool, _ nTryCount: Int, _ nTryAfterSeconds: Int) ->Bool
    {
        return mUserAgentExLib.autoRegistration(sAccountName, bEnable, Int32(nTryCount), Int32(nTryAfterSeconds))
    }
    
    func VideoCodecBitRate(_ nCodecNo: Int, _ nQuality: Int) ->Bool
    {
        return mUserAgentExLib.videoCodecBitRate(Int32(nCodecNo), Int32(nQuality))
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func BusyLampGetContactStatus(_ sAccountName: String, _ sUserName: String) ->Int
    {
        return Int (mUserAgentExLib.busyLampGetContactStatus(sAccountName, sUserName))
    }
    
    func BusyLampFindContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mUserAgentExLib.busyLampFindContact(sAccountName, sUserName)
    }
    
    func BusyLampAddContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mUserAgentExLib.busyLampAddContact(sAccountName, sUserName)
    }
    
    func BusyLampRemoveContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mUserAgentExLib.busyLampRemoveContact(sAccountName, sUserName)
    }
    
    func BusyLampSubscribeContactAll(_ sAccountName: String) ->Bool
    {
        return mUserAgentExLib.busyLampSubscribeContactAll(sAccountName)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func DiagnosticLogSIP(_ sAccountName: String, _ bInbound: Bool, _ bOutbound: Bool) ->Bool
    {
        return mUserAgentExLib.diagnosticLogSIP(sAccountName, bInbound, bOutbound)
    }
    
    func SetPushSIP(_ sAccountName: String, _ sTeamID: String, _ sBundleID: String, _ sDeviceToken: String) ->Bool
    {
        return mUserAgentExLib.setPushSIP(sAccountName, sTeamID, sBundleID, sDeviceToken)
    }
    
    func AudioVAD(_ nLineNo: Int, _ bEnable: Bool) ->Bool
    {
        return mUserAgentExLib.audioVAD(Int32(nLineNo), bEnable)
    }
    
    func SetNetworkPrioritySIP(_ nMode: Int) ->Bool
    {
        return mUserAgentExLib.setNetworkPrioritySIP(Int32(nMode))
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnInitialized() ->Void {}
    @objc func OnUnInitialized() ->Void {}
    
    @objc func OnConnectingToRegister(_ sAccountName: String!) ->Void {}
    @objc func OnTryingToRegister(_ sAccountName: String!) ->Void {}
    @objc func OnFailToRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void {}
    @objc func OnSuccessToRegister(_ sAccountName: String!) ->Void {}
    
    @objc func OnConnectingToReRegister(_ sAccountName: String!) ->Void {}
    @objc func OnTryingToReRegister(_ sAccountName: String!) ->Void {}
    @objc func OnFailToReRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void {}
    @objc func OnSuccessToReRegister(_ sAccountName: String!) ->Void {}
    
    @objc func OnTryingToUnRegister(_ sAccountName: String!) ->Void {}
    @objc func OnFailToUnRegister(_ sAccountName: String!) ->Void {}
    @objc func OnSuccessToUnRegister(_ sAccountName: String!) ->Void {}
            
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnDialCallStarted(_ sAccountName: String!, _ nLineNo: Int, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!) ->Void {}
    @objc func OnDialingCall(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void {}
    @objc func OnDialCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sContact: String!) ->Void {}
    
    @objc func OnConnectedCall(_ sAccountName: String!, _ nLineNo: Int, _ sToRTPIP: String!, _ nToRTPPort: Int) ->Void {}
    @objc func OnHungupCall(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnIncomingCallStarted(_ sAccountName: String!, _ sCallId: String!, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ sFromURI: String!, _ sToURI: String!) ->Void {}
    @objc func OnIncomingCallEnded(_ sAccountName: String!, _ sCallId: String!, _ nReasonCode: Int) ->Void {}
    
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnTransferCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void {}
    @objc func OnTransferCallAccepted(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnRingToneStarted(_ sAccountName: String!, _ sCallId: String!) ->Void {}
    @objc func OnRingToneEnded(_ sAccountName: String!, _ sCallId: String!) ->Void {}
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc func OnPlayWaveDone(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnDigitDTMF(_ sAccountName: String!, _ nLineNo: Int, _ sDigit: String!) ->Void {}
    
    @objc func OnMsgNOTIFY(_ sAccountName: String!, _ sMsg: String!) ->Void {}
    @objc func OnVoiceMailMsg(_ sAccountName: String!, _ bIsMsgWaiting: Bool, _ nNewMsgCount: Int, _ nOldMsgCount: Int, _ nNewUrgentMsgCount: Int, _ nOldUrgentMsgCount: Int, _ sMsgAccount: String!) ->Void {}
    
    @objc func OnIncomingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sFromIP: String!, _ nFromPort: Int) ->Void {}
    @objc func OnOutgoingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sToIP: String!, _ nToPort: Int) ->Void {}
    
    @objc func OnAudioSessionLost(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnSuccessToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnTryingToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnFailToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnSuccessToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnTryingToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnFailToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnTryingToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnFailToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnSuccessToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnChatSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) -> Void {};
    @objc func OnChatSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) -> Void {};
        
    @objc func OnChatContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void {}
    
    @objc func OnChatSendMsgTextSuccess(_ sAccountName: String!, _ sUserName: String!, _ sMsgText:String!, _ nUserValue: Int) ->Void {}
    @objc func OnChatSendMsgTextFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sMsgText: String!, _ nUserValue: Int) ->Void {}
    
    @objc func OnChatSendMsgTypingSuccess(_ sAccountName: String!, _ sUserName: String!, _ nUserValue: Int) ->Void {}
    @objc func OnChatSendMsgTypingFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ nUserValue: Int) ->Void {}
    
    @objc func OnChatRecvMsgText(_ sAccountName: String!, _ sUserName: String!, _ sMsgText: String!, _ bIsChatContact: Bool) ->Void {}
    @objc func OnChatRecvMsgTypingStart(_ sAccountName: String!, _ sUserName: String!) ->Void {}
    @objc func OnChatRecvMsgTypingStop(_ sAccountName: String!, _ sUserName: String!) ->Void {}
    
    @objc func OnAudioRecordedPCM(_ sAccountName: String!, _ nLineNo: Int, _ pDataPCM :UnsafeMutablePointer<Int8>!, _ nSizePCM: Int, _ nTypePCM: Int) ->Void {}
    @objc func OnDetectedAMD(_ sAccountName: String!, _ nLineNo: Int, _ bIsHuman: Bool) ->Void {}
    
    @objc func OnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnUnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnVideoRemoteStarted(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    @objc func OnVideoRemoteEnded(_ sAccountName: String!, _ nLineNo: Int) ->Void {}
    
    @objc func OnVideoDeviceFrameRGB(_ nDeviceId: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void {}
    @objc func OnVideoRemoteFrameRGB(_ sAccountName: String!, _ nLineNo: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void {}
           
    @objc func OnAddCallHistory(_ sAccountName: String!, _ bOutboundCallType: Bool, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void {}
    @objc func OnNetworkReachability(_ bAvailable: Bool) ->Void {}
    
    @objc func OnAudioDeviceMicVU(_ nLevelVU: Int) ->Void {}
    @objc func OnAudioDeviceSpkVU(_ nLevelVU: Int) ->Void {}
    
    @objc func OnBusyLampSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) -> Void {}
    @objc func OnBusyLampSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void {}
    @objc func OnBusyLampContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void {}

    @objc func OnVaxErrorMsg(_ sFuncName: String!, _ sErrorMsg: String!, _ nErrorCode: Int) ->Void {}
    
}
