
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit
import AVFoundation

class cVaxUserAgentFrwSIP : cVaxUserAgentFrw, iVaxPushKit
{
    var mPushKit: cVaxPushKit!
    
    override init()
    {
        super.init()
    
        mPushKit = cVaxPushKit(iDelegate: self)
    }

    deinit
    {
    
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func RegisterAccountPushKit(_ sAccountName: String, _ nExpire: Int) ->Bool
    {
        #if targetEnvironment(simulator)
            if !super.RegisterAccountSIP(sAccountName, nExpire)
            {
                return false
            }
        #else
            mPushKit.Start()
        #endif
        
        return true;
    }

    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func SpeakerPhone(_ bEnable: Bool) ->Bool
    {
        let vAudioSession = AVAudioSession.sharedInstance()
        
        do
        {
            if bEnable
            {
                try vAudioSession.overrideOutputAudioPort(.speaker)
            }
            else
            {
                try vAudioSession.overrideOutputAudioPort(.none)
            }
        }
        catch
        {
            return false;
        }
        
        return true;
    }
    
    func IsSpeakerPhone() ->Bool
    {
        let vAudioSession = AVAudioSession.sharedInstance()
        
        if vAudioSession == nil
        {
            return false;
        }
        
        if vAudioSession.currentRoute == nil
        {
            return false;
        }
        
        if vAudioSession.currentRoute.outputs == nil
        {
            return false;
        }
        
        if vAudioSession.currentRoute.outputs.count == 0
        {
            return false;
        }
        
        var PortRoute: AVAudioSessionPortDescription! = vAudioSession.currentRoute.outputs[0]
        
        if PortRoute.portType != AVAudioSession.Port.builtInSpeaker
        {
            return false;
        }
        
        return true;
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OnVaxTryingPushKit() ->Void
    {
        cVaxUserAgentSIP.OnVaxRegisterTryingPushKit()
    }
    
    func OnVaxFailedPushKit() ->Void
    {
        cVaxUserAgentSIP.OnVaxRegisterFailedPushKit()
    }
    
    func OnVaxSuccessPushKit(_ sDeviceToken: String) ->Void
    {
        cVaxUserAgentSIP.OnVaxRegisterSuccessPushKit(sDeviceToken)
    }
    
    func OnVaxNotificationPushKit(_ sCallerName: String, _ sCallerId: String) ->Void
    {
        cVaxUserAgentSIP.OnVaxNotificationPushKit(sCallerName, sCallerId)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    override func OnInitialized() ->Void
    {
        cVaxUserAgentSIP.OnInitialized()
    }
    
    override func OnUnInitialized() ->Void
    {
        cVaxUserAgentSIP.OnUnInitialized()
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnConnectingToRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnConnectingToRegister(sAccountName)
    }
    
    override func OnTryingToRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnTryingToRegister(sAccountName)
    }
    
    override func OnFailToRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnFailToRegister(sAccountName, nStatusCode, sReasonPhrase)
    }

    override func OnSuccessToRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToRegister(sAccountName)
    }
    
    override func OnConnectingToReRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnConnectingToReRegister(sAccountName)
    }

    override func OnTryingToReRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnTryingToReRegister(sAccountName)
    }

    override func OnFailToReRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnFailToReRegister(sAccountName, nStatusCode, sReasonPhrase)
    }

    override func OnSuccessToReRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToReRegister(sAccountName)
    }
        
    override func OnTryingToUnRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnTryingToUnRegister(sAccountName)
    }

    override func OnFailToUnRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnFailToUnRegister(sAccountName)
    }

    override func OnSuccessToUnRegister(_ sAccountName: String!) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToUnRegister(sAccountName)
    }
            
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnDialCallStarted(_ sAccountName: String!, _ nLineNo: Int, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!) ->Void
    {
        cVaxUserAgentSIP.OnDialCallStarted(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo)
    }

    override func OnDialingCall(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnDialingCall(sAccountName, nLineNo, nStatusCode, sReasonPhrase)
    }

    override func OnDialCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sContact: String!) ->Void
    {
        cVaxUserAgentSIP.OnDialCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact)
    }

    
    override func OnConnectedCall(_ sAccountName: String!, _ nLineNo: Int, _ sToRTPIP: String!, _ nToRTPPort: Int) ->Void
    {
        cVaxUserAgentSIP.OnConnectedCall(sAccountName, nLineNo, sToRTPIP, nToRTPPort)
    }

    override func OnHungupCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnHungupCall(sAccountName, nLineNo)
    }

    override func OnIncomingCallStarted(_ sAccountName: String!, _ sCallId: String!, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ sFromURI: String!, _ sToURI: String!) ->Void
    {
        cVaxUserAgentSIP.OnIncomingCallStarted(sAccountName, sCallId, sCallerName, sCallerId, sDialNo, sFromURI, sToURI)
    }

    override func OnIncomingCallEnded(_ sAccountName: String!, _ sCallId: String!, _ nReasonCode: Int) ->Void
    {
        cVaxUserAgentSIP.OnIncomingCallEnded(sAccountName, sCallId, nReasonCode)
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnTransferCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnTransferCallFailed(sAccountName, nLineNo, nStatusCode, sReasonPhrase)
    }

    override func OnTransferCallAccepted(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnTransferCallAccepted(sAccountName, nLineNo)
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnRingToneStarted(_ sAccountName: String!, _ sCallId: String!) ->Void
    {
        cVaxUserAgentSIP.OnRingToneStarted(sAccountName)
    }

    override func OnRingToneEnded(_ sAccountName: String!, _ sCallId: String!) ->Void
    {
        cVaxUserAgentSIP.OnRingToneEnded(sAccountName)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnPlayWaveDone(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnPlayWaveDone(sAccountName, nLineNo)
    }

    override func OnDigitDTMF(_ sAccountName: String!, _ nLineNo: Int, _ sDigit: String!) ->Void
    {
        cVaxUserAgentSIP.OnDigitDTMF(sAccountName, nLineNo, sDigit)
    }
    
    override func OnMsgNOTIFY(_ sAccountName: String!, _ sMsg: String!) ->Void
    {
        cVaxUserAgentSIP.OnMsgNOTIFY(sAccountName, sMsg)
    }

    override func OnVoiceMailMsg(_ sAccountName: String!, _ bIsMsgWaiting: Bool, _ nNewMsgCount: Int, _ nOldMsgCount: Int, _ nNewUrgentMsgCount: Int, _ nOldUrgentMsgCount: Int, _ sMsgAccount: String!) ->Void
    {
        cVaxUserAgentSIP.OnVoiceMailMsg(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnIncomingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sFromIP: String!, _ nFromPort: Int) ->Void
    {
        cVaxUserAgentSIP.OnIncomingDiagnostic(sAccountName, sMsgSIP, sFromIP, nFromPort)
    }

    override func OnOutgoingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sToIP: String!, _ nToPort: Int) ->Void
    {
        cVaxUserAgentSIP.OnOutgoingDiagnostic(sAccountName, sMsgSIP, sToIP, nToPort)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnAudioSessionLost(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnAudioSessionLost(sAccountName, nLineNo)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnSuccessToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToHold(sAccountName, nLineNo)
    }

    override func OnTryingToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnTryingToHold(sAccountName, nLineNo)
    }

    override func OnFailToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnFailToHold(sAccountName, nLineNo)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnSuccessToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToUnHold(sAccountName, nLineNo)
    }

    override func OnTryingToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnTryingToUnHold(sAccountName, nLineNo)
    }

    override func OnFailToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnFailToUnHold(sAccountName, nLineNo)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnTryingToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnTryingToRefresh(sAccountName, nLineNo)
    }
    
    override func OnFailToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnFailToRefresh(sAccountName, nLineNo)
    }
    
    override func OnSuccessToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnSuccessToRefresh(sAccountName, nLineNo)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnChatSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
        cVaxUserAgentSIP.OnChatSubscribeSuccess(sAccountName, sUserName)
    }

    override func OnChatSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnChatSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase)
    }
        
    override func OnChatContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void
    {
        cVaxUserAgentSIP.OnChatContactStatus(sAccountName, sUserName, nStatusId)
    }
    
    override func OnChatSendMsgTextSuccess(_ sAccountName: String!, _ sUserName: String!, _ sMsgText:String!, _ nUserValue: Int) ->Void
    {
        cVaxUserAgentSIP.OnChatSendMsgTextSuccess(sAccountName, sUserName, sMsgText, nUserValue)
    }

    override func OnChatSendMsgTextFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sMsgText: String!, _ nUserValue: Int) ->Void
    {
        cVaxUserAgentSIP.OnChatSendMsgTextFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue)
    }
    
    override func OnChatSendMsgTypingSuccess(_ sAccountName: String!, _ sUserName: String!, _ nUserValue: Int) ->Void
    {
        cVaxUserAgentSIP.OnChatSendMsgTypingSuccess(sAccountName, sUserName, nUserValue)
    }

    override func OnChatSendMsgTypingFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ nUserValue: Int) ->Void
    {
        cVaxUserAgentSIP.OnChatSendMsgTypingFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue)
    }
    
    override func OnChatRecvMsgText(_ sAccountName: String!, _ sUserName: String!, _ sMsgText: String!, _ bIsChatContact: Bool) ->Void
    {
        cVaxUserAgentSIP.OnChatRecvMsgText(sAccountName, sUserName, sMsgText, bIsChatContact)
    }

    override func OnChatRecvMsgTypingStart(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
        cVaxUserAgentSIP.OnChatRecvMsgTypingStart(sAccountName, sUserName)
    }

    override func OnChatRecvMsgTypingStop(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
        cVaxUserAgentSIP.OnChatRecvMsgTypingStop(sAccountName, sUserName)
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnAudioRecordedPCM(_ sAccountName: String!, _ nLineNo: Int, _ pDataPCM :UnsafeMutablePointer<Int8>!, _ nSizePCM: Int, _ nTypePCM: Int) ->Void
    {
        cVaxUserAgentSIP.OnAudioRecordedPCM(sAccountName, nLineNo, pDataPCM, nSizePCM, nTypePCM)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnHoldCall(sAccountName, nLineNo)
    }

    override func OnUnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnUnHoldCall(sAccountName, nLineNo)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnVideoRemoteStarted(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnVideoRemoteStarted(sAccountName, nLineNo)
    }

    override func OnVideoRemoteEnded(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        cVaxUserAgentSIP.OnVideoRemoteEnded(sAccountName, nLineNo)
    }
    
    override func OnVideoDeviceFrameRGB(_ nDeviceId: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
    {
        cVaxUserAgentSIP.OnVideoDeviceFrameRGB(nDeviceId, pFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    }

    override func OnVideoRemoteFrameRGB(_ sAccountName: String!, _ nLineNo: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
    {
        cVaxUserAgentSIP.OnVideoRemoteFrameRGB(sAccountName, nLineNo, pFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnAddCallHistory(_ sAccountName: String!, _ bOutboundCallType: Bool, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void
    {
        cVaxUserAgentSIP.OnAddCallHistory(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId)
    }

    override func OnNetworkReachability(_ bAvailable: Bool) ->Void
    {
        cVaxUserAgentSIP.OnNetworkReachability(bAvailable)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnAudioDeviceMicVU(_ nLevelVU: Int) ->Void
    {
        cVaxUserAgentSIP.OnAudioDeviceMicVU(nLevelVU)
    }

    override func OnAudioDeviceSpkVU(_ nLevelVU: Int) ->Void
    {
        cVaxUserAgentSIP.OnAudioDeviceSpkVU(nLevelVU)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnBusyLampSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
        cVaxUserAgentSIP.OnBusyLampSubscribeSuccess(sAccountName, sUserName)
    }

    override func OnBusyLampSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        cVaxUserAgentSIP.OnBusyLampSubscribeFailed(sAccountName, sUserName, nStatusCode, sReasonPhrase)
    }

    override func OnBusyLampContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void
    {
        cVaxUserAgentSIP.OnBusyLampContactStatus(sAccountName, sUserName, nStatusId)
    }

    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    override func OnVaxErrorMsg(_ sFuncName: String!, _ sErrorMsg: String!, _ nErrorCode: Int) ->Void
    {
        cVaxUserAgentSIP.OnVaxErrorMsg(sFuncName, sErrorMsg, nErrorCode)
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
}
