
//  Created by VaxSoft
//  Copyright © 2025 VaxSoft. All rights reserved.

import UIKit

class cVaxUserAgentSIP : NSObject
{
    static var mVaxAgentFrwSIP: cVaxUserAgentFrwSIP? = nil
    static var mListDelegate = [iVaxUserAgentSIP]()
    
    var mVaxAgentDelegate: iVaxUserAgentSIP!
    var mAgentFrwSIP: cVaxUserAgentFrwSIP!
    
    init(iDelegate: Any!)
    {
        mVaxAgentDelegate = (iDelegate as! iVaxUserAgentSIP)
        
        super.init()
        
        if cVaxUserAgentSIP.mVaxAgentFrwSIP == nil
        {
            cVaxUserAgentSIP.mVaxAgentFrwSIP = cVaxUserAgentFrwSIP();
        }
        
        mAgentFrwSIP = cVaxUserAgentSIP.mVaxAgentFrwSIP;
        
        if mVaxAgentDelegate != nil
        {
            cVaxUserAgentSIP.mListDelegate.append(mVaxAgentDelegate)
        }
    }

    deinit
    {
        if mVaxAgentDelegate == nil
        {
            return;
        }
        
        for (nIndex, vDelegate) in cVaxUserAgentSIP.mListDelegate.enumerated()
        {
            if vDelegate === mVaxAgentDelegate
            {
                cVaxUserAgentSIP.mListDelegate.remove(at: nIndex)
                break;
            }
        }
        
        mVaxAgentDelegate = nil;
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func GetVersionFile() ->String
    {
        return mAgentFrwSIP.GetVersionFile()
    }

    func GetVersionSDK() ->String
    {
        return mAgentFrwSIP.GetVersionSDK()
    }
    
    func SetLicenceKey(_ sLicenceKey: String) ->Bool
    {
        return mAgentFrwSIP.SetLicenceKey(sLicenceKey)
    }
            
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func Initialize() ->Bool
    {
        return mAgentFrwSIP.Initialize()
    }
    
    func UnInitialize() ->Void
    {
        mAgentFrwSIP.UnInitialize()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AddAccountSIP(_ sAccountName: String, _ nAccountType: Int, _ sListenIP: String, _ nListenPort: Int, _ sDisplayName: String, _ sUserName: String, _ sAuthLogin: String, _ sAuthPwd: String, _ sDomainRealm: String, _ sServerAddr: String, _ nServerPort: Int) ->Bool
    {
        return mAgentFrwSIP.AddAccountSIP(sAccountName, nAccountType, sListenIP, nListenPort, sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort)
    }
    
    func RemoveAccountSIP(_ sAccountName: String)
    {
        mAgentFrwSIP.RemoveAccountSIP(sAccountName);
    }
    
    func RegisterAccountPushKit(_ sAccountName: String, _ nExpire: Int) ->Bool
    {
        return mAgentFrwSIP.RegisterAccountPushKit(sAccountName, nExpire);
    }
    
    func RegisterAccountSIP(_ sAccountName: String, _ nExpire: Int) ->Bool
    {
        return mAgentFrwSIP.RegisterAccountSIP(sAccountName, nExpire);
    }
    
    func UnRegisterAccountSIP(_ sAccountName: String) ->Bool
    {
        return mAgentFrwSIP.UnRegisterAccountSIP(sAccountName)
    }
    
    func SetPushSIP(_ sAccountName: String, _ sTeamID: String, _ sBundleID: String, _ sDeviceToken: String) ->Bool
    {
        return mAgentFrwSIP.SetPushSIP(sAccountName, sTeamID, sBundleID, sDeviceToken)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func OpenLine(_ nLineNo: Int, _ sRTPRxIP: String, _ nRxAudioPortRTP: Int, _ nRxVideoPortRTP:Int) ->Bool
    {
        return mAgentFrwSIP.OpenLine(nLineNo, sRTPRxIP, nRxAudioPortRTP, nRxVideoPortRTP)
    }
    
    func OpenLineREC(_ nLineNo: Int, _ sRTPRxIP: String, _ nAudioPortRTP: Int) ->Bool
    {
        return mAgentFrwSIP.OpenLineREC(nLineNo, sRTPRxIP, nAudioPortRTP)
    }
    
    func CloseLine(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.CloseLine(nLineNo)
    }
    
    func CryptoMediaNONE(_ bForced: Bool) ->Bool
    {
        return mAgentFrwSIP.CryptoMediaNONE(bForced)
    }
    
    func CryptoMediaSDP(_ bForced: Bool) ->Bool
    {
        return mAgentFrwSIP.CryptoMediaSDP(bForced)
    }
        
    func GetVaxErrorCode() ->Int
    {
        return mAgentFrwSIP.GetVaxErrorCode()
    }
    
    func GetVaxErrorMsg() ->String
    {
        return mAgentFrwSIP.GetVaxErrorMsg()
    }
    
    func GetCallId(_ nLineNo: Int) ->String
    {
        return mAgentFrwSIP.GetCallId(nLineNo);
    }
    
    func AudioDeviceVU(_ bActivate: Bool, _ bMicVU: Bool, _ bSpkVU: Bool) ->Bool
    {
        return mAgentFrwSIP.AudioDeviceVU(bActivate, bMicVU, bSpkVU);
    }
    
    func GetAudioInDevTotal() ->Int
    {
        return mAgentFrwSIP.GetAudioInDevTotal();
    }
    
    func GetAudioOutDevTotal() ->Int
    {
        return mAgentFrwSIP.GetAudioOutDevTotal();
    }
    
    func GetAudioOutDevName(_ nDeviceId: Int) ->String
    {
        return mAgentFrwSIP.GetAudioOutDevName(nDeviceId);
    }
    
    func GetAudioInDevName(_ nDeviceId: Int) ->String
    {
        return mAgentFrwSIP.GetAudioOutDevName(nDeviceId);
    }
    
    func DialCall(_ sAccountName: String, _ nLineNo: Int, _ sCallerName: String, _ sCallerId: String, _ sDialNo: String) ->Bool
    {
        return mAgentFrwSIP.DialCall(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo, -1, -1)
    }
    
    func DialCallToREC(_ sAccountName: String, _ nLineNo: Int, _ sDialNo: String) ->Bool
    {
        return mAgentFrwSIP.DialCallToREC(sAccountName, nLineNo, sDialNo)
    }
    
    func DisconnectCall(_ nLineNo: Int) ->Bool
    {
        if !mAgentFrwSIP.DisconnectCall(nLineNo)
        {
            return false
        }
            
        cVaxUserAgentSIP.OnDisconnectedCall(nLineNo)
        return true
    }
    
    func AcceptCall(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.AcceptCall(nLineNo, "", -1, -1)
    }
    
    func RejectCall() ->Bool
    {
        return mAgentFrwSIP.RejectCall("")
    }
    
    func TransferCallBlind(_ nLineNo: Int, _ sToUserName: String) ->Bool
    {
        return mAgentFrwSIP.TransferCallBlind(nLineNo, sToUserName)
    }
    
    func TransferCallConsult(_ nLineNoA: Int, _ nLineNoB: Int) ->Bool
    {
        return mAgentFrwSIP.TransferCallConsult(nLineNoA, nLineNoB)
    }
    
    func HoldLine(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.HoldLine(nLineNo)
    }
    
    func UnHoldLine(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.UnHoldLine(nLineNo)
    }
    
    func RefreshLine(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.RefreshLine(nLineNo)
    }
        
    func IsLineOpen(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLineOpen(nLineNo)
    }
    
    func IsLineHold(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLineHold(nLineNo)
    }
            
    func IsLineBusy(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLineBusy(nLineNo)
    }
    
    func IsLineConnected(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLineConnected(nLineNo)
    }
    
    func EnableKeepAlive(_ sAccountName: String, _ nSeconds: Int) ->Bool
    {
        return mAgentFrwSIP.EnableKeepAlive(sAccountName, nSeconds)
    }
    
    func DisableKeepAlive(_ sAccountName: String) ->Void
    {
        mAgentFrwSIP.DisableKeepAlive(sAccountName)
    }
    
    func SelectAllAudioCodec() ->Void
    {
        mAgentFrwSIP.SelectAllAudioCodec()
    }
    
    func SelectAudioCodec(_ nCodecNo: Int) ->Bool
    {
        return mAgentFrwSIP.SelectAudioCodec(nCodecNo)
    }
    
    func DeselectAllAudioCodec() ->Void
    {
        mAgentFrwSIP.DeselectAllAudioCodec()
    }
    
    func DeselectAudioCodec(_ nCodec: Int) ->Bool
    {
        return mAgentFrwSIP.DeselectAudioCodec(nCodec)
    }
    
    func SelectAllVideoCodec() ->Void
    {
        mAgentFrwSIP.SelectAllVideoCodec()
    }
    
    func SelectVideoCodec(_ nCodec: Int) ->Bool
    {
        return mAgentFrwSIP.SelectVideoCodec(nCodec)
    }
    
    func DeselectAllVideoCodec() ->Void
    {
        mAgentFrwSIP.DeselectAllVideoCodec()
    }
    
    func DeselectVideoCodec(_ nCodec: Int) ->Bool
    {
        return mAgentFrwSIP.DeselectVideoCodec(nCodec)
    }
    
    func DigitDTMF(_ nLineNo: Int, _ sDigit: String, _ nTypeDTMF: Int) ->Bool
    {
        return mAgentFrwSIP.DigitDTMF(nLineNo, sDigit, nTypeDTMF)
    }
    
    func SetVolumeDTMF(_ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.SetVolumeDTMF(nVolume)
    }
    
    func GetVolumeDTMF() ->Int
    {
        return mAgentFrwSIP.GetVolumeDTMF()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func MuteMic(_ bMute: Bool) ->Bool
    {
        return mAgentFrwSIP.MuteMic(bMute)
    }
    
    func MuteSpk(_ bMute: Bool) ->Bool
    {
        return mAgentFrwSIP.MuteSpk(bMute)
    }
    
    func MuteLineSpk(_ nLineNo: Int, _ bMute: Bool) ->Bool
    {
        return mAgentFrwSIP.MuteLineSpk(nLineNo, bMute)
    }
    
    func MuteLineMic(_ nLineNo: Int, _ bMute: Bool) ->Bool
    {
        return mAgentFrwSIP.MuteLineMic(nLineNo, bMute)
    }
    
    func AutoGainMic(_ bEnable: Bool, _ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.AutoGainMic(bEnable, nVolume)
    }
    
    func AutoGainSpk(_ bEnable: Bool, _ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.AutoGainSpk(bEnable, nVolume)
    }
    
    func SetVolumeMic(_ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.SetVolumeMic(nVolume)
    }
    
    func GetVolumeMic() ->Int
    {
        return mAgentFrwSIP.GetVolumeMic()
    }
    
    func SetVolumeSpk(_ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.SetVolumeSpk(nVolume)
    }
    
    func GetVolumeSpk() ->Int
    {
        return mAgentFrwSIP.GetVolumeSpk()
    }
    
    func SetLineVolumeSpk(_ nLineNo: Int, _ nVolume: Int) ->Bool
    {
        return mAgentFrwSIP.SetLineVolumeSpk(nLineNo, nVolume)
    }
    
    func GetLineVolumeSpk(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.GetLineVolumeSpk(nLineNo)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func EchoCancellation(_ bEnable: Bool) ->Bool
    {
        return mAgentFrwSIP.EchoCancellation(bEnable)
    }
    
    func DonotDisturb(_ bEnable: Bool) ->Bool
    {
        return mAgentFrwSIP.DonotDisturb(bEnable)
    }
    
    func IsLineRecording(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLineRecording(nLineNo)
    }
    
    func StartRecording(_ nLineNo: Int, _ sFileName: String, _ nTypeRecord: Int, _ nTypePCM: Int) ->Bool
    {
        return mAgentFrwSIP.StartRecording(nLineNo, sFileName, nTypeRecord, nTypePCM)
    }
    
    func StopRecording(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.StopRecording(nLineNo)
    }
    
    func ResetRecording(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.ResetRecording(nLineNo)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func IsLinePlaying(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.IsLinePlaying(nLineNo)
    }
    
    func PlayWaveOpen(_ nLineNo: Int, _ sFileName: String) ->Bool
    {
        return mAgentFrwSIP.PlayWaveOpen(nLineNo, sFileName)
    }
    
    func PlayWaveClose(_ nlineNo: Int) ->Bool
    {
        return mAgentFrwSIP.PlayWaveClose(nlineNo)
    }
    
    func PlayWaveSkipTo(_ nLineNo: Int, _ nMilliSeconds: Int) ->Bool
    {
        return mAgentFrwSIP.PlayWaveSkipTo(nLineNo, nMilliSeconds)
    }
    
    func PlayWaveTotalTime(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.PlayWaveTotalTime(nLineNo)
    }
    
    func PlayWavePause(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.PlayWavePause(nLineNo)
    }
    
    func PlayWaveStart(_ nLineNo: Int, _ bListen: Bool) ->Bool
    {
        return mAgentFrwSIP.PlayWaveStart(nLineNo, bListen)
    }
    
    func PlayWaveStop(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.PlayWaveStop(nLineNo)
    }
    
    func PlayWavePosition(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.PlayWavePosition(nLineNo)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func GetOutboundCodec(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.GetOutboundCodec(nLineNo)
    }
    
    func GetInboundCodec(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.GetInboundCodec(nLineNo)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AudioSessionLost(_ nSecond: Int) ->Void
    {
        mAgentFrwSIP.AudioSessionLost(nSecond)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func SetUserAgentSIP(_ sUserAgentName: String) ->Bool
    {
        return mAgentFrwSIP.SetUserAgentSIP(sUserAgentName)
    }
    
    func GetUserAgentSIP() ->String
    {
        return mAgentFrwSIP.GetUserAgentSIP()
    }
    
    func SetSubjectSDP(_ sSubjectSDP: String) ->Bool
    {
        return mAgentFrwSIP.SetSubjectSDP(sSubjectSDP)
    }
    
    func GetSubjectSDP() ->String
    {
        return mAgentFrwSIP.GetSubjectSDP()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func ConfAllowLine(_ nLineNo: Int, _ bAllowListen: Bool, _ bAllowSpeak: Bool) ->Bool
    {
        return mAgentFrwSIP.ConfAllowLine(nLineNo, bAllowListen, bAllowSpeak)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func ChatFindContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mAgentFrwSIP.ChatFindContact(sAccountName, sUserName)
    }
    
    func ChatAddContact(_ sAccountName: String, _ sUserName: String, _ bPresence: Bool) ->Bool
    {
        return mAgentFrwSIP.ChatAddContact(sAccountName, sUserName, bPresence)
    }
    
    func ChatRemoveContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mAgentFrwSIP.ChatRemoveContact(sAccountName, sUserName)
    }
    
    func ChatSendMessageTyping(_ sAccountName: String, _ sUserName: String, _ nUserValue: Int) ->Bool
    {
        return mAgentFrwSIP.ChatSendMessageTyping(sAccountName, sUserName, nUserValue)
    }
    
    func ChatSendMessageText(_ sAccountName: String, _ sUserName: String, _ sMsgText: String, _ bMsgTypeHtml: Bool, _ nUserValue: Int) ->Bool
    {
        return mAgentFrwSIP.ChatSendMessageText(sAccountName, sUserName, sMsgText, bMsgTypeHtml, nUserValue)
    }
    
    func ChatSubscribeContactAll(_ sAccountName: String) ->Bool
    {
        return mAgentFrwSIP.ChatSubscribeContactAll(sAccountName)
    }
    
    func ChatSetMyStatus(_ sAccountName: String, _ nStatusId: Int) ->Bool
    {
        return mAgentFrwSIP.ChatSetMyStatus(sAccountName, nStatusId)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func VoiceChanger(_ nPitch: Int) ->Bool
    {
        return mAgentFrwSIP.VoiceChanger(nPitch)
    }
    
    func ForwardCall(_ bEnable: Bool, _ sToUserName: String) ->Bool
    {
        return mAgentFrwSIP.ForwardCall(bEnable, sToUserName)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func PlayAddPCM(_ nLineNo: Int, _ pDataPCM: UnsafeMutablePointer<Int8>, _ nSizePCM: Int) ->Bool
    {
        return mAgentFrwSIP.PlayAddPCM(nLineNo, pDataPCM, nSizePCM)
    }
    
    func PlayResetPCM(_ nLineNo: Int) ->Bool
    {
        return mAgentFrwSIP.PlayResetPCM(nLineNo)
    }
            
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AddCustomHeader(_ nLineNo: Int, _ nReqId: Int, _ sName: String, _ sValue: String) ->Bool
    {
        return mAgentFrwSIP.AddCustomHeader(nLineNo, nReqId, sName, sValue)
    }
    
    func RemoveCustomHeader(_ nLineNo: Int, _ nReqId: Int, _ sName: String) ->Bool
    {
        return mAgentFrwSIP.RemoveCustomHeader(nLineNo, nReqId, sName)
    }
    
    func RemoveCustomHeaderAll(_ nLineNo: Int, _ nReqId: Int) ->Bool
    {
        return mAgentFrwSIP.RemoveCustomHeaderAll(nLineNo, nReqId)
    }
    
    
    func AddCustomHeaderReferToURI(_ sName: String, _ sValue: String) ->Bool
    {
        return mAgentFrwSIP.AddCustomHeaderReferToURI(sName, sValue)
    }
    
    func RemoveCustomHeaderReferToURI(_ sName: String) ->Bool
    {
        return mAgentFrwSIP.RemoveCustomHeaderReferToURI(sName)
    }
    
    func RemoveCustomHeaderAllReferToURI() ->Bool
    {
        return mAgentFrwSIP.RemoveCustomHeaderAllReferToURI()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func GetCountPacketLost(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.GetCountPacketLost(nLineNo)
    }
    
    func GetSizeJitterBuffer(_ nLineNo: Int) ->Int
    {
        return mAgentFrwSIP.GetSizeJitterBuffer(nLineNo)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func GetVideoDevTotal() ->Int
    {
        return mAgentFrwSIP.GetVideoDevTotal()
    }
    
    func GetVideoDevName(_ nDeviceId: Int) ->String
    {
        return mAgentFrwSIP.GetVideoDevName(nDeviceId)
    }
    
    func OpenVideoDev(_ nDeviceId: Int, _ nQuality: Int) ->Bool
    {
        return mAgentFrwSIP.OpenVideoDev(nDeviceId, nQuality)
    }
    
    func CloseVideoDev() ->Void
    {
        mAgentFrwSIP.CloseVideoDev()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
        
    func SpeakerPhone(_ bEnable: Bool) ->Bool
    {
        return mAgentFrwSIP.SpeakerPhone(bEnable)
    }
    
    func IsSpeakerPhone() ->Bool
    {
        return mAgentFrwSIP.IsSpeakerPhone()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
        
    func DialRingEnable(_ sFileName: String) ->Bool
    {
        return mAgentFrwSIP.DialRingEnable(sFileName)
    }
    
    func DialRingDisable() ->Bool
    {
        return mAgentFrwSIP.DialRingDisable()
    }
    
    func BusyRingEnable(_ sFileName: String) ->Bool
    {
        return mAgentFrwSIP.BusyRingEnable(sFileName)
    }
    
    func BusyRingDisable() ->Bool
    {
        return mAgentFrwSIP.BusyRingDisable()
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func EnableVideo(_ nLineNo: Int, _ bOutbound: Bool, _ bInbound: Bool) ->Bool
    {
        return mAgentFrwSIP.EnableVideo(nLineNo, bOutbound, bInbound)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////
    
    func IsNetworkAvailable() ->Bool
    {
        return mAgentFrwSIP.IsNetworkAvailable()
    }
    
    func NetworkReachability(_ bEnable: Bool) ->Bool
    {
        return mAgentFrwSIP.NetworkReachability(bEnable)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func AutoRegistration(_ sAccountName: String, _ bEnable: Bool, _ nTryCount: Int, _ nTryAfterSeconds: Int) ->Bool
    {
        return mAgentFrwSIP.AutoRegistration(sAccountName, bEnable, nTryCount, nTryAfterSeconds)
    }
    
    func VideoCodecBitRate(_ nCodecNo: Int, _ nQuality: Int) ->Bool
    {
        return mAgentFrwSIP.VideoCodecBitRate(nCodecNo, nQuality)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func BusyLampGetContactStatus(_ sAccountName: String, _ sUserName: String) ->Int
    {
        return mAgentFrwSIP.BusyLampGetContactStatus(sAccountName, sUserName)
    }
    
    func BusyLampFindContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mAgentFrwSIP.BusyLampFindContact(sAccountName, sUserName)
    }
    
    func BusyLampAddContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mAgentFrwSIP.BusyLampAddContact(sAccountName, sUserName)
    }
    
    func BusyLampRemoveContact(_ sAccountName: String, _ sUserName: String) ->Bool
    {
        return mAgentFrwSIP.BusyLampRemoveContact(sAccountName, sUserName)
    }
    
    func BusyLampSubscribeContactAll(_ sAccountName: String) ->Bool
    {
        return mAgentFrwSIP.BusyLampSubscribeContactAll(sAccountName)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    func DiagnosticLogSIP(_ sAccountName: String, _ bInbound: Bool, _ bOutbound: Bool) ->Bool
    {
        return mAgentFrwSIP.DiagnosticLogSIP(sAccountName, bInbound, bOutbound)
    }
    
    func AudioVAD(_ nLineNo: Int, _ bEnable: Bool) ->Bool
    {
        return mAgentFrwSIP.AudioVAD(nLineNo, bEnable)
    }
    
    func SetNetworkPrioritySIP(_ nMode: Int) ->Bool
    {
        return mAgentFrwSIP.SetNetworkPrioritySIP(nMode)
    }
    
    //////////////////////////////////////////////////////////////////////////////////////
    //////////////////////////////////////////////////////////////////////////////////////
    
    static func OnInitialized() ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnInitialized))
            {
                continue;
            }

            vDelegate.OnInitialized!()
        }
    }
    
    static func OnUnInitialized() ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnUnInitialized))
            {
                continue;
            }

            vDelegate.OnUnInitialized!()
        }
    }
    
    static func OnConnectingToRegister(_ sAccountName: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnConnectingToRegister))
            {
                continue;
            }

            vDelegate.OnConnectingToRegister!(sAccountName)
        }
    }
    
    static func OnTryingToRegister(_ sAccountName: String!) ->Void
    {
       for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToRegister))
            {
                continue;
            }

            vDelegate.OnTryingToRegister!(sAccountName)
        }
    }
    
    static func OnFailToRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
       for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToRegister))
            {
                continue;
            }

            vDelegate.OnFailToRegister!(sAccountName, nStatusCode, sReasonPhrase)
        }
    }

    static func OnSuccessToRegister(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToRegister))
            {
                continue;
            }

            vDelegate.OnSuccessToRegister!(sAccountName)
        }
    }
    
    static func OnConnectingToReRegister(_ sAccountName: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnConnectingToReRegister))
            {
                continue;
            }

            vDelegate.OnConnectingToReRegister!(sAccountName)
        }
    }

    static func OnTryingToReRegister(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToReRegister))
            {
                continue;
            }

            vDelegate.OnTryingToReRegister!(sAccountName)
        }
    }

    static func OnFailToReRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToReRegister))
            {
                continue;
            }

            vDelegate.OnFailToReRegister!(sAccountName, nStatusCode, sReasonPhrase)
        }
    }

    static func OnSuccessToReRegister(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToReRegister))
            {
                continue;
            }

            vDelegate.OnSuccessToReRegister!(sAccountName)
        }
    }

    
    static func OnTryingToUnRegister(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToUnRegister))
            {
                continue;
            }

            vDelegate.OnTryingToUnRegister!(sAccountName)
        }
    }

    static func OnFailToUnRegister(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToUnRegister))
            {
                continue;
            }

            vDelegate.OnFailToUnRegister!(sAccountName)
        }
    }

    static func OnSuccessToUnRegister(_ sAccountName: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToUnRegister))
            {
                continue;
            }

            vDelegate.OnSuccessToUnRegister!(sAccountName)
        }
    }
            
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnDialCallStarted(_ sAccountName: String!, _ nLineNo: Int, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnDialCallStarted))
            {
                continue;
            }

            vDelegate.OnDialCallStarted!(sAccountName, nLineNo, sCallerName, sCallerId, sDialNo)
        }
    }

    static func OnDialingCall(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnDialingCall))
            {
                continue;
            }

            vDelegate.OnDialingCall!(sAccountName, nLineNo, nStatusCode, sReasonPhrase)
        }
    }

    static func OnDialCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sContact: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnDialCallFailed))
            {
                continue;
            }

            vDelegate.OnDialCallFailed!(sAccountName, nLineNo, nStatusCode, sReasonPhrase, sContact)
        }
    }

    
    static func OnConnectedCall(_ sAccountName: String!, _ nLineNo: Int, _ sToRTPIP: String!, _ nToRTPPort: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnConnectedCall))
            {
                continue;
            }

            vDelegate.OnConnectedCall!(sAccountName, nLineNo)
        }
    }

    static func OnHungupCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnHungupCall))
            {
                continue;
            }

            vDelegate.OnHungupCall!(sAccountName, nLineNo)
        }
    }

    static private func OnDisconnectedCall(_ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnDisconnectedCall))
            {
                continue;
            }

            vDelegate.OnDisconnectedCall!(nLineNo)
        }
    }
    
    static func OnIncomingCallStarted(_ sAccountName: String!, _ sCallId: String!, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ sFromURI: String!, _ sToURI: String!) ->Void
    {
        var sResultCallerName: String = ""
        var sResultCallerId: String = ""
        var sResultContactId: String = ""
        
        cVaxCallInfo.PrepareInfo(sCallerName, sCallerId, &sResultCallerName, &sResultCallerId, &sResultContactId)
        
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnIncomingCallStarted))
            {
                continue;
            }

            vDelegate.OnIncomingCallStarted!(sAccountName, sResultCallerName, sResultCallerId)
        }
    }

    static func OnIncomingCallEnded(_ sAccountName: String!, _ sCallId: String!, _ nReasonCode: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnIncomingCallEnded))
            {
                continue;
            }

            vDelegate.OnIncomingCallEnded!(sAccountName, nReasonCode)
        }
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnTransferCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTransferCallFailed))
            {
                continue;
            }

            vDelegate.OnTransferCallFailed!(sAccountName, nLineNo, nStatusCode, sReasonPhrase)
        }
    }

    static func OnTransferCallAccepted(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTransferCallAccepted))
            {
                continue;
            }

            vDelegate.OnTransferCallAccepted!(sAccountName, nLineNo)
        }
    }
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnRingToneStarted(_ sAccountName: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnRingToneStarted))
            {
                continue;
            }

            vDelegate.OnRingToneStarted!(sAccountName)
        }
    }

    static func OnRingToneEnded(_ sAccountName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnRingToneEnded))
            {
                continue;
            }

            vDelegate.OnRingToneEnded!(sAccountName)
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnPlayWaveDone(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnPlayWaveDone))
            {
                continue;
            }

            vDelegate.OnPlayWaveDone!(sAccountName, nLineNo)
        }
    }

    static func OnDigitDTMF(_ sAccountName: String!, _ nLineNo: Int, _ sDigit: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnDigitDTMF))
            {
                continue;
            }

            vDelegate.OnDigitDTMF!(sAccountName, nLineNo, sDigit)
        }
    }
    
    static func OnMsgNOTIFY(_ sAccountName: String!, _ sMsg: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnMsgNOTIFY))
            {
                continue;
            }

            vDelegate.OnMsgNOTIFY!(sAccountName, sMsg)
        }
    }

    static func OnVoiceMailMsg(_ sAccountName: String!, _ bIsMsgWaiting: Bool, _ nNewMsgCount: Int, _ nOldMsgCount: Int, _ nNewUrgentMsgCount: Int, _ nOldUrgentMsgCount: Int, _ sMsgAccount: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVoiceMailMsg))
            {
                continue;
            }

            vDelegate.OnVoiceMailMsg!(sAccountName, bIsMsgWaiting, nNewMsgCount, nOldMsgCount, nNewUrgentMsgCount, nOldUrgentMsgCount, sMsgAccount)
        }
    }
        
    static func OnIncomingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sFromIP: String!, _ nFromPort: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnIncomingDiagnostic))
            {
                continue;
            }

            vDelegate.OnIncomingDiagnostic!(sAccountName, sMsgSIP, sFromIP, nFromPort)
        }
    }

    static func OnOutgoingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sToIP: String!, _ nToPort: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnOutgoingDiagnostic))
            {
                continue;
            }

            vDelegate.OnOutgoingDiagnostic!(sAccountName, sMsgSIP, sToIP, nToPort)
        }
    }
    
    static func OnAudioSessionLost(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnAudioSessionLost))
            {
                continue;
            }

            vDelegate.OnAudioSessionLost!(sAccountName, nLineNo)
        }
    }
    
    static func OnSuccessToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToHold))
            {
                continue;
            }

            vDelegate.OnSuccessToHold!(sAccountName, nLineNo)
        }
    }

    static func OnTryingToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToHold))
            {
                continue;
            }

            vDelegate.OnTryingToHold!(sAccountName, nLineNo)
        }
    }

    static func OnFailToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToHold))
            {
                continue;
            }

            vDelegate.OnFailToHold!(sAccountName, nLineNo)
        }
    }
    
    static func OnSuccessToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToUnHold))
            {
                continue;
            }

            vDelegate.OnSuccessToUnHold!(sAccountName, nLineNo)
        }
    }

    static func OnTryingToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToUnHold))
            {
                continue;
            }

            vDelegate.OnTryingToUnHold!(sAccountName, nLineNo)
        }
    }

    static func OnFailToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToUnHold))
            {
                continue;
            }

            vDelegate.OnFailToUnHold!(sAccountName, nLineNo)
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    static func OnTryingToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnTryingToRefresh))
            {
                continue;
            }

            vDelegate.OnTryingToRefresh!(sAccountName, nLineNo)
        }
    }

    static func OnFailToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnFailToRefresh))
            {
                continue;
            }

            vDelegate.OnFailToRefresh!(sAccountName, nLineNo)
        }
    }

    static func OnSuccessToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnSuccessToRefresh))
            {
                continue;
            }

            vDelegate.OnSuccessToRefresh!(sAccountName, nLineNo)
        }
    }
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////

    static func OnChatSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSubscribeSuccess))
            {
                continue;
            }

            vDelegate.OnChatSubscribeSuccess!(sAccountName, sUserName)
        }
    }
    
    static func OnChatSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSubscribeFailed))
            {
                continue;
            }

            vDelegate.OnChatSubscribeFailed!(sAccountName, sUserName, nStatusCode, sReasonPhrase)
        }
    }
        
    static func OnChatContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatContactStatus))
            {
                continue;
            }

            vDelegate.OnChatContactStatus!(sAccountName, sUserName, nStatusId)
        }
    }
    
    static func OnChatSendMsgTextSuccess(_ sAccountName: String!, _ sUserName: String!, _ sMsgText:String!, _ nUserValue: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSendMsgTextSuccess))
            {
                continue;
            }

            vDelegate.OnChatSendMsgTextSuccess!(sAccountName, sUserName, sMsgText, nUserValue)
        }
    }

    static func OnChatSendMsgTextFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sMsgText: String!, _ nUserValue: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSendMsgTextFailed))
            {
                continue;
            }

            vDelegate.OnChatSendMsgTextFailed!(sAccountName, sUserName, nStatusCode, sReasonPhrase, sMsgText, nUserValue)
        }
    }
    
    static func OnChatSendMsgTypingSuccess(_ sAccountName: String!, _ sUserName: String!, _ nUserValue: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSendMsgTypingSuccess))
            {
                continue;
            }

            vDelegate.OnChatSendMsgTypingSuccess!(sAccountName, sUserName, nUserValue)
        }
    }

    static func OnChatSendMsgTypingFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ nUserValue: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatSendMsgTypingFailed))
            {
                continue;
            }

            vDelegate.OnChatSendMsgTypingFailed!(sAccountName, sUserName, nStatusCode, sReasonPhrase, nUserValue)
        }
    }
    
    static func OnChatRecvMsgText(_ sAccountName: String!, _ sUserName: String!, _ sMsgText: String!, _ bIsChatContact: Bool) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatRecvMsgText))
            {
                continue;
            }

            vDelegate.OnChatRecvMsgText!(sAccountName, sUserName, sMsgText, bIsChatContact)
        }
    }

    static func OnChatRecvMsgTypingStart(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatRecvMsgTypingStart))
            {
                continue;
            }

            vDelegate.OnChatRecvMsgTypingStart!(sAccountName, sUserName)
        }
    }

    static func OnChatRecvMsgTypingStop(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnChatRecvMsgTypingStop))
            {
                continue;
            }

            vDelegate.OnChatRecvMsgTypingStop!(sAccountName, sUserName)
        }
    }
    
    static func OnAudioRecordedPCM(_ sAccountName: String!, _ nLineNo: Int, _ pDataPCM :UnsafeMutablePointer<Int8>!, _ nSizePCM: Int, _ nTypePCM: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnAudioRecordedPCM))
            {
                continue;
            }

            vDelegate.OnAudioRecordedPCM!(sAccountName, nLineNo, pDataPCM, nSizePCM, nTypePCM)
        }
    }

    static func OnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnHoldCall))
            {
                continue;
            }

            vDelegate.OnHoldCall!(sAccountName, nLineNo)
        }
    }

    static func OnUnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnUnHoldCall))
            {
                continue;
            }

            vDelegate.OnUnHoldCall!(sAccountName, nLineNo)
        }
    }
    
    static func OnVideoRemoteStarted(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVideoRemoteStarted))
            {
                continue;
            }

            vDelegate.OnVideoRemoteStarted!(sAccountName, nLineNo)
        }
    }

    static func OnVideoRemoteEnded(_ sAccountName: String!, _ nLineNo: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVideoRemoteEnded))
            {
                continue;
            }

            vDelegate.OnVideoRemoteEnded!(sAccountName, nLineNo)
        }
    }
    
    static func OnVideoDeviceFrameRGB(_ nDeviceId: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVideoDeviceFrameRGB))
            {
                continue;
            }

            vDelegate.OnVideoDeviceFrameRGB!(nDeviceId, pFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        }
    }

    static func OnVideoRemoteFrameRGB(_ sAccountName: String!, _ nLineNo: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVideoRemoteFrameRGB))
            {
                continue;
            }

            vDelegate.OnVideoRemoteFrameRGB!(sAccountName, nLineNo, pFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        }
    }
           
    static func OnAddCallHistory(_ sAccountName: String!, _ bOutboundCallType: Bool, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnAddCallHistory))
            {
                continue;
            }

            vDelegate.OnAddCallHistory!(sAccountName, bOutboundCallType, sCallerName, sCallerId, sDialNo, nStartTime, nEndTime, nDuration, nDayNo, nHistoryTypeId)
        }
    }

    static func OnNetworkReachability(_ bAvailable: Bool) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnNetworkReachability))
            {
                continue;
            }

            vDelegate.OnNetworkReachability!(bAvailable)
        }
    }

    
    static func OnAudioDeviceMicVU(_ nLevelVU: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnAudioDeviceMicVU))
            {
                continue;
            }

            vDelegate.OnAudioDeviceMicVU!(nLevelVU)
        }
    }

    static func OnAudioDeviceSpkVU(_ nLevelVU: Int) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnAudioDeviceSpkVU))
            {
                continue;
            }

            vDelegate.OnAudioDeviceSpkVU!(nLevelVU)
        }
    }

    
    static func OnBusyLampSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnBusyLampSubscribeSuccess))
            {
                continue;
            }

            vDelegate.OnBusyLampSubscribeSuccess!(sAccountName, sUserName)
        }
    }

    static func OnBusyLampSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    {
         for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnBusyLampSubscribeFailed))
            {
                continue;
            }

            vDelegate.OnBusyLampSubscribeFailed!(sAccountName, sUserName, nStatusCode, sReasonPhrase)
        }
    }

    static func OnBusyLampContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnBusyLampContactStatus))
            {
                continue;
            }

            vDelegate.OnBusyLampContactStatus!(sAccountName, sUserName, nStatusId)
        }
    }

    static func OnVaxErrorMsg(_ sFuncName: String!, _ sErrorMsg: String!, _ nErrorCode: Int) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVaxErrorMsg))
            {
                continue;
            }

            vDelegate.OnVaxErrorMsg!(sFuncName, sErrorMsg, nErrorCode)
        }
    }
    
    static func OnVaxRegisterTryingPushKit() ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVaxRegisterTryingPushKit))
            {
                continue;
            }

            vDelegate.OnVaxRegisterTryingPushKit!()
        }
    }
    
    static func OnVaxRegisterFailedPushKit()  ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVaxRegisterFailedPushKit))
            {
                continue;
            }

            vDelegate.OnVaxRegisterFailedPushKit!()
        }
    }
    
    static func OnVaxRegisterSuccessPushKit(_ sDeviceToken: String) ->Void
    {
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnVaxRegisterSuccessPushKit))
            {
                continue;
            }

            vDelegate.OnVaxRegisterSuccessPushKit!(sDeviceToken)
        }
    }
    
    static func OnVaxNotificationPushKit(_ sCallerName :String!, _ sCallerId :String!)  ->Void
    {
        var sResultCallerName: String = ""
        var sResultCallerId: String = ""
        var sResultContactId: String = ""
        
        cVaxCallInfo.PrepareInfo(sCallerName, sCallerId, &sResultCallerName, &sResultCallerId, &sResultContactId)
        
        for vDelegate in cVaxUserAgentSIP.mListDelegate
        {
            if !vDelegate.responds(to: #selector(iVaxUserAgentSIP.OnIncomingCallPushKit))
            {
                continue;
            }

            vDelegate.OnIncomingCallPushKit!(sResultCallerName, sResultCallerId)
        }
    }
}

@objc protocol iVaxUserAgentSIP: NSObjectProtocol
{
    @objc optional func OnInitialized() ->Void
    @objc optional func OnUnInitialized() ->Void
    
    @objc optional func OnConnectingToRegister(_ sAccountName: String!) ->Void
    @objc optional func OnTryingToRegister(_ sAccountName: String!) ->Void
    @objc optional func OnFailToRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    @objc optional func OnSuccessToRegister(_ sAccountName: String!) ->Void
    
    @objc optional func OnConnectingToReRegister(_ sAccountName: String!) ->Void
    @objc optional func OnTryingToReRegister(_ sAccountName: String!) ->Void
    @objc optional func OnFailToReRegister(_ sAccountName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    @objc optional func OnSuccessToReRegister(_ sAccountName: String!) ->Void
    
    @objc optional func OnTryingToUnRegister(_ sAccountName: String!) ->Void
    @objc optional func OnFailToUnRegister(_ sAccountName: String!) ->Void
    @objc optional func OnSuccessToUnRegister(_ sAccountName: String!) ->Void
            
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc optional func OnDialCallStarted(_ sAccountName: String!, _ nLineNo: Int, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!) ->Void
    @objc optional func OnDialingCall(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    @objc optional func OnDialCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sContact: String!) ->Void
    
    @objc optional func OnConnectedCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnHungupCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnDisconnectedCall(_ nLineNo: Int) ->Void
    
    @objc optional func OnIncomingCallStarted(_ sAccountName: String!, _ sCallerName: String!, _ sCallerId: String!) ->Void
    @objc optional func OnIncomingCallEnded(_ sAccountName: String!, _ nReasonCode: Int) ->Void
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc optional func OnTransferCallFailed(_ sAccountName: String!, _ nLineNo: Int, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    @objc optional func OnTransferCallAccepted(_ sAccountName: String!, _ nLineNo: Int) ->Void
        
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc optional func OnRingToneStarted(_ sAccountName: String!) ->Void
    @objc optional func OnRingToneEnded(_ sAccountName: String!) ->Void
    
    /////////////////////////////////////////////////////////////////////////////////////////
    /////////////////////////////////////////////////////////////////////////////////////////
    
    @objc optional func OnPlayWaveDone(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnDigitDTMF(_ sAccountName: String!, _ nLineNo: Int, _ sDigit: String!) ->Void
    
    @objc optional func OnMsgNOTIFY(_ sAccountName: String!, _ sMsg: String!) ->Void
    @objc optional func OnVoiceMailMsg(_ sAccountName: String!, _ bIsMsgWaiting: Bool, _ nNewMsgCount: Int, _ nOldMsgCount: Int, _ nNewUrgentMsgCount: Int, _ nOldUrgentMsgCount: Int, _ sMsgAccount: String!) ->Void
    
    @objc optional func OnIncomingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sFromIP: String!, _ nFromPort: Int) ->Void
    @objc optional func OnOutgoingDiagnostic(_ sAccountName: String!, _ sMsgSIP: String!, _ sToIP: String!, _ nToPort: Int) ->Void
    
    @objc optional func OnAudioSessionLost(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnSuccessToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnTryingToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnFailToHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnSuccessToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnTryingToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnFailToUnHold(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnTryingToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnFailToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnSuccessToRefresh(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnChatSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    @objc optional func OnChatSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
        
    @objc optional func OnChatContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void
    
    @objc optional func OnChatSendMsgTextSuccess(_ sAccountName: String!, _ sUserName: String!, _ sMsgText:String!, _ nUserValue: Int) ->Void
    @objc optional func OnChatSendMsgTextFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ sMsgText: String!, _ nUserValue: Int) ->Void
    
    @objc optional func OnChatSendMsgTypingSuccess(_ sAccountName: String!, _ sUserName: String!, _ nUserValue: Int) ->Void
    @objc optional func OnChatSendMsgTypingFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!, _ nUserValue: Int) ->Void
    
    @objc optional func OnChatRecvMsgText(_ sAccountName: String!, _ sUserName: String!, _ sMsgText: String!, _ bIsChatContact: Bool) ->Void
    @objc optional func OnChatRecvMsgTypingStart(_ sAccountName: String!, _ sUserName: String!) ->Void
    @objc optional func OnChatRecvMsgTypingStop(_ sAccountName: String!, _ sUserName: String!) ->Void
    
    @objc optional func OnAudioRecordedPCM(_ sAccountName: String!, _ nLineNo: Int, _ pDataPCM :UnsafeMutablePointer<Int8>!, _ nSizePCM: Int, _ nTypePCM: Int) ->Void
    
    @objc optional func OnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnUnHoldCall(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnVideoRemoteStarted(_ sAccountName: String!, _ nLineNo: Int) ->Void
    @objc optional func OnVideoRemoteEnded(_ sAccountName: String!, _ nLineNo: Int) ->Void
    
    @objc optional func OnVideoDeviceFrameRGB(_ nDeviceId: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
    @objc optional func OnVideoRemoteFrameRGB(_ sAccountName: String!, _ nLineNo: Int, _ pFrameRGB :UnsafeMutablePointer<Int8>!, _ nFrameSize: Int, _ nFrameWidth: Int, _ nFrameHeight: Int) ->Void
           
    @objc optional func OnAddCallHistory(_ sAccountName: String!, _ bOutboundCallType: Bool, _ sCallerName: String!, _ sCallerId: String!, _ sDialNo: String!, _ nStartTime: Int, _ nEndTime: Int, _ nDuration: Int, _ nDayNo: Int, _ nHistoryTypeId: Int) ->Void
    @objc optional func OnNetworkReachability(_ bAvailable: Bool) ->Void
    
    @objc optional func OnAudioDeviceMicVU(_ nLevelVU: Int) ->Void
    @objc optional func OnAudioDeviceSpkVU(_ nLevelVU: Int) ->Void
    
    @objc optional func OnBusyLampSubscribeSuccess(_ sAccountName: String!, _ sUserName: String!) ->Void
    @objc optional func OnBusyLampSubscribeFailed(_ sAccountName: String!, _ sUserName: String!, _ nStatusCode: Int, _ sReasonPhrase: String!) ->Void
    @objc optional func OnBusyLampContactStatus(_ sAccountName: String!, _ sUserName: String!, _ nStatusId: Int) ->Void

    @objc optional func OnVaxErrorMsg(_ sFuncName: String!, _ sErrorMsg: String!, _ nErrorCode: Int) ->Void
    
    @objc optional func OnVaxRegisterTryingPushKit() ->Void
    @objc optional func OnVaxRegisterFailedPushKit() ->Void
    @objc optional func OnVaxRegisterSuccessPushKit(_ sDeviceToken: String) ->Void
    
    @objc optional func OnIncomingCallPushKit(_ sCallerName :String!, _ sCallerId :String!)  ->Void
    
}
